unit UMatriceFortran2;

interface
{dfinition des types matriciels compatibles FORTRAN
 par dfaut, les indices de tableaux FORTRAN commencent  1 ; c'est  priori le cas dans arpack : array[ 1 : xxx
 en FORTRAN, c'est l'indice de gauche qui est rang en continu, en pascal, c'est l'indice de droite (array of array
 ce qui implique l'organisation suivante :
 - les dimensions sont fixes par DIMENSION(nli,nco) ; l'ordre de dclaration est le mme que l'instruction DIMENSION de FORTRAN
 - le rangement FORTRAN en mmoire est ainsi (1,1) (2,1) (3,1) (1,2) (2,2) .. == <col1> <col2> <col3> ...
 - en Pascal, cela conduit  la dfinition de type array[1..nco,1..nli] ; cette matrice peut tre passe globalement  FORTRAN
 - le rangement interne est fait sous forme d'un vecteur au format interne FORTRAN : <col1> <col2> <col3> ...
 - l'accs  un lment est calcul : MAT(li,co) renvoie MATinterne[ (co-1)*nli + li-1 ]  ( co*nli+li - (nli+1) )
 - la "LEADING DIMENSION" est nli
Le type TFPackMat est un rangement triangulaire sup compatible avec lapack "packed array" de type "U"
Ce type est compatible "ligne de ciel" ; dans ce mode, la position des lments diagonaux est pointe par une table, car la hauteur
 des colonnes n'est pas calculable ; il faut dans un premier temps remplir cette table avec la ht des colonnes, puis
 appeler PkcMatInitCiel pour transformer la table des hauteurs en positions de diag et rserver la mmoire.
 (par la suite, la hauteur des colonnes est calcule par diffrence dans cette table)
En mode "packed array", les positions de diag sont calcules (les colonnes sont de taille linairement croissante),
 et la mmoire est rserve ds la cration.
Ce type supporte 2 plans d'adressage li,co :
 - les fonctions pvPkMatLc et pcPkMatLc numrotent la ligne  partir de l'lment diagonal adress par (1,co)
   (ce mode conserve le systme d'adressage de WinCops < V4 et facilite la transition)
 - les fonctions pvPkMat et pcPkMat utilisent un numrotage classique (li,co) o l'lment diagonal est adress par (co,co)
Ces types sont construits comme des RECORD et les rservations mmoire accdes par des pointeurs explicites, car les tableaux
 variables de delphi comportent des variables masques (informations de taille stockes avant le 1er lment) incompatibles avec fortran 
}
uses
  SysUtils;

const                                                        
  k_tmInteger4 = 1;
  k_tmLogical4 = 2;
  k_tmReal4    = 3;
  k_tmDoublePrecision8 = 4;
  k_tmComplex8 = 5;
  k_tmDoubleComplex16 = 6;
  k_tmPRecord4 = 7;

  k_tmSizInteger4 = 4;
  k_tmSizLogical4 = 4;
  k_tmSizReal4 = 4;
  k_tmSizDoublePrecision8 = 8;
  k_tmSizComplex8 = 8;
  k_tmSizDoubleComplex16 = 16;
  k_tmSizPRecord4 = 4;

type
  charF = array[0..255] of char;  //////// A REVOIR
  charF2 = array[0..1] of char;
  charF6 = array[0..5] of char;
  charF1 = char ;

  TComplex = record
    cx_r,cx_i: single;
  end;
  TDoubleComplex = record
    dcx_r,dcx_i: double;
  end;

  TTblD = array[1..1000000] of double;
  PTblD = ^TTblD;
  
  TVecRec = type pointer;
  PVecRec = ^TVecRec;

  TVecInteger = type integer;
  PVecInteger = ^TVecInteger;
  TMatInteger = type integer;
  PMatInteger = ^TMatInteger;

  TVecReal = type real;
  PVecReal = ^TVecReal;
  TMatReal = type real;
  PMatReal = ^TMatReal;

  TVecDouble = type double;
  PVecDouble = ^TVecDouble;
  TMatDouble = type double;
  PMatDouble = ^TMatDouble;
  PCellD     = ^double;

  TVecComplex = type TComplex;
  PVecComplex = ^TVecComplex;
  TMatComplex = type TComplex;
  PMatComplex = ^TMatComplex;

  TVecDoubleComplex = type TDoubleComplex;
  PVecDoubleComplex = ^TVecDoubleComplex;
  TMatDoubleComplex = type TDoubleComplex;
  PMatDoubleComplex = ^TMatDoubleComplex;

  TVecLogical = type longbool;
  PVecLogical = ^TVecLogical;
  TMatLogical = type longbool;
  PMatLogical = ^TMatLogical;


  TNomMV = string[16];
  TFMatrix = record
    nomM: TNomMV;
    nli,nco, //dimensions 1..nli , 1..nco dans l'ordre FORTRAN
    typelt, //k_tm..
    sizelt, //en octets
    delta,
    sizmat: integer; //en nb d'lments (et non en octets)
    mat: pointer;
    MxI: PMatInteger;
    MxL: PMatLogical;
    MxR: PMatReal;
    MxD: PMatDouble;
    MxC: PMatComplex;
    MxDC: PMatDoubleComplex;
  end;
  TPackDiag = array[1..1] of integer;
  TFPackMat = record
//les lments de la matrice sont rangs au format packed matrix de lapack : (1,1) , (1,2),(2,2) , (1,3),(2,3),(3,3)..
//si ciel=T, rgt par ligne de ciel, pdiags^ contient l'indice de l'lment diagonal
    nomM: TNomMV;
    dim, //dimension
    sizmat: integer; //en nb d'lments (et non en octets)
    ciel: boolean;
    MpD: PMatDouble;
    _pdiags: ^TPackDiag;//pointe sur les lments diagonaux si rgt en ligne de ciel ; **INTERNE**
  end;
  TVector = record
    nomV: TNomMV;
    typelt,
    sizelt,
    sizvec: integer; //en nb d'lments (et non en octets)
    vec: pointer;
    VcI: PVecInteger;
    VcL: PVecLogical;
    VcR: PVecReal;
    VcD: PVecDouble;
    VcC: PVecComplex;
    VcDC: PVecDoubleComplex;
    VcRc: PVecRec;
  end;

procedure PkMatCreate(var Mp:TFPackMat;nom:string;nbel:integer;ciel_:boolean);
procedure PkMatInit(var Mp:TFPackMat);
procedure PkcMatInitCiel(var Mpc:TFPackMat); //transforme les ht colonnes en index diag et rserve la mmoire de MpD
function PkMatHCol(Mp:TFPackMat;co1:integer):integer;
procedure PkMatSetHCol(Mp:TFPackMat;co1,hc:integer);
function PkMatInMat(Mp:TFPackMat;li1,co1:integer):boolean;
function PkcMatDebCol(Mp:TFPackMat;co1:integer):integer;
procedure PkMatFree(var Mp:TFPackMat);
function PkMatToStr(M:TFPackMat):string;
function pvPkMatLc(Mp:TFPackMat;li1,co1:integer):PVecDouble;
function pcPkMatLc(Mp:TFPackMat;li1,co1:integer):PCellD;
function pvPkMat(Mp:TFPackMat;li1,co1:integer):PVecDouble;
function pcPkMat(Mp:TFPackMat;li1,co1:integer):PCellD;
function PkMatVal(Mp:TFPackMat;ix1:integer):double;overload; //ix=1..sizmat
function PkMatVal(Mp:TFPackMat;li1,co1:integer):double;overload;
procedure PkMatSaveData(M:TFPackMat;PF:string);
procedure PkMatLoadData(M:TFPackMat;PF:string);
procedure PkMatSaveMat(M:TFPackMat;PF:string);
procedure PkMatLoadMat(var M:TFPackMat;PF:string);
procedure PkMatCopyData(var Mr:TFPackMat; M:TFPackMat; struconly:boolean=false);
procedure PkMatZero(M:TFPackMat);
procedure PkMat_MxM(Mr,M1,M2:TFPackMat;n:integer=0);
procedure PkMat_MxV(var Vr:TVecDouble;M:TFPackMat;var V:TVecDouble;n:integer);
procedure Check(var Mp:TFPackMat);overload;

procedure MatCreate(var M:TFMatrix;nom:string;type_,nbli,nbco:integer);
procedure MatInit(var M:TFMatrix);
procedure MatFree(var M:TFMatrix);
procedure MatResize(var M:TFMatrix;newnbli,newnbco:integer);
procedure MatSetColAZero(M:TFMatrix;numcol:integer);
procedure MatCopyCol(M:TFMatrix;numcolsrc,numcoldst:integer);
function MatVal(M:TFMatrix;ix1:integer):double; //ix=1..sizmat
procedure MatSaveData(M:TFMatrix;PF:string);
procedure MatLoadData(M:TFMatrix;PF:string;rafraichirdate:boolean=false);
procedure MatSaveMat(M:TFMatrix;PF:string);
procedure MatLoadMat(var M:TFMatrix;PF:string;rafraichirdate:boolean=false);

procedure VecCreate(var V:TVector;nom:string;type_,nbe:integer;nofill:boolean=false);
procedure VecInit(var V:TVector);
procedure VecClear(var V:TVector);
procedure VecFree(var V:TVector);
procedure VecResize(var V:TVector;newsize:integer);
procedure Check(var V:TVector);overload;

function PMatI(M:TFMatrix;li1,co1:integer):PMatInteger;
function PMatL(M:TFMatrix;li1,co1:integer):PMatLogical;
function PMatR(M:TFMatrix;li1,co1:integer):PMatReal;
function PMatD(M:TFMatrix;li1,co1:integer):PMatDouble;
function PMatC(M:TFMatrix;li1,co1:integer):PMatComplex;
function PMatDC(M:TFMatrix;li1,co1:integer):PMatDoubleComplex;

function PVecI(M:TFMatrix;li1,co1:integer):PVecInteger;overload;
function PVecI(V:TVector;ix:integer):PVecInteger;overload;
function PVecL(M:TFMatrix;li1,co1:integer):PVecLogical;overload;
function PVecL(V:TVector;ix:integer):PVecLogical;overload;
function PVecR(M:TFMatrix;li1,co1:integer):PVecReal;overload;
function PVecR(V:TVector;ix:integer):PVecReal;overload;
function PVecD(M:TFMatrix;li1,co1:integer):PVecDouble;overload;
function PVecD(V:TVector;ix:integer):PVecDouble;overload;
function PVecC(M:TFMatrix;li1,co1:integer):PVecComplex;overload;
function PVecC(V:TVector;ix:integer):PVecComplex;overload;
function PVecDC(M:TFMatrix;li1,co1:integer):PVecDoubleComplex;overload;
function PVecDC(V:TVector;ix1:integer):PVecDoubleComplex;overload;
function PVecRc(V:TVector;ix1:integer):PVecRec;

function PCellRelI(var V:TVecInteger; ix1:integer):PVecInteger;
function PCellRelL(var V:TVecLogical; ix1:integer):PVecLogical;
function PCellRelR(var V:TVecReal; ix1:integer):PVecReal;
function PCellRelD(var V:TVecDouble; ix1:integer):PVecDouble;overload;
function PCellRelC(var V:TVecComplex; ix1:integer):PVecComplex;
function PCellRelDC(var V:TVecDoubleComplex; ix1:integer):PVecDoubleComplex;
function PCellRelRc(var V:TVecRec;ix1:integer):PVecRec;

function PCellRelD(var M:TMatDouble; nli , li1,co1:integer):PVecDouble;overload;
procedure CumulerCellule(M:TFMatrix;li1,co1:integer;value:double);
//

procedure MatSetId(M:TFMatrix);//cre une matrice Id
procedure MatMul_AxB(var Mr,A,B:TMatDouble ; nlc:integer);
procedure MatCombiLin(var Mres:TFMatrix;alpha:double;A:TFMatrix;beta:double;B:TFMatrix);
procedure MatMulV(var Vr:TVecDouble; var M:TMatDouble; nl,nc:integer; var V:TVecDouble);overload;//NB : Vr[nl], V[nc]
procedure MatMulV(Vr:TVector;M:TFMatrix;V:TVector);overload;

function MatToStr(M:TFMatrix):string;overload;
function MatToStr(nli,nco:integer;var M:TMatDouble):string;overload;
function VecToStr(V:TVector;vert:boolean=false):string;overload;
function VecToStr(ne:integer;var V:TVecDouble;vert:boolean=false):string;overload;
procedure MatDisplay(tit:string;M:TFMatrix);
procedure VecDisplay(tit:string;V:TVector;vert:boolean=false);overload;
procedure VecDisplay(tit:string;ne:integer;var V:TVecDouble;vert:boolean=false);overload;

procedure VecCopy(var Vr,V:TVecDouble;n:integer);overload;
procedure VecCopy(PVr,PV:PVecDouble;n:integer);overload;
function VecIxAbsMax(ne:integer;var V:TVecDouble):integer;



implementation

uses Utils, StringUtils, Math, UMemoEdit;

const
  k_sizelt : array[1..7] of integer = (4,4,4,8,8,16,4);

function Complex(r,i:real):TComplex;
begin
  with result do begin cx_r:=r; cx_i:=i; end;
end;

function DoubleComplex(r,i:double):TDoubleComplex;
begin
  with result do begin dcx_r:=r; dcx_i:=i; end;
end;

procedure xchg(var i,j:integer);
var k: integer;
begin
  k:=i; i:=j; j:=k;
end;

procedure MatCreate(var M:TFMatrix;nom:string;type_,nbli,nbco:integer);
begin
  with M do begin
    nomM:=nom;
    sizmat:=nbli*nbco;
    if sizmat=0 then raise Exception.Create('la matrice est de taille nulle');
    typelt:=type_;
    sizelt:=k_sizelt[type_];
    nli:=nbli;
    nco:=nbco;
    delta:=nbli+1;
    GetMem(mat,sizmat*sizelt);
    FillChar(mat^,sizmat*sizelt,0);
    case typelt of   //fait pointer le bon type sur la zone mmoire
      k_tmInteger4:MxI:=mat;//pointer(pMatI):=pointer(mat);
      k_tmLogical4:MxL:=mat;
      k_tmReal4:MxR:=mat;// pointer(pMatR):=pointer(mat);
      k_tmDoublePrecision8:MxD:=mat;//pointer(pMatD):=pointer(mat);
      k_tmComplex8:MxC:=mat;//pointer(pMatC):=pointer(mat);
      k_tmDoubleComplex16:MxDC:=mat;//pointer(pMatDC):=pointer(mat);
    end;
  end;
end;
procedure MatInit(var M:TFMatrix);
begin
  FillChar(M,sizeof(M),0);
end;
procedure MatFree(var M:TFMatrix);
begin
  if M.sizelt=0 then exit; //dj fait
  FreeMem(M.mat,M.sizmat*M.sizelt);
  MatInit(M);
end;
procedure MatResize(var M:TFMatrix;newnbli,newnbco:integer); //si newxx = 0, on garde l'ancien
var
  p,pt: pchar;
  co,nli_,nco_: integer;
  Mt: TFMatrix;
begin
  if newnbli=0 then newnbli:=M.nli;
  if newnbco=0 then newnbco:=M.nco;
  if (newnbli=M.nli) and (newnbco=M.nco) then exit; //rien  faire
  MatCreate(Mt,M.nomM,M.typelt,newnbli,newnbco);//met tout  0 : un peu de gchis, mais ...
  nco_:=Min(M.nco,newnbco);
  nli_:=Min(M.nli,newnbli);
  for co:=1 to nco_  do begin
    p:=pchar(M.mat) + (co*M.nli+1-M.delta)*M.sizelt;
    pt:=pchar(Mt.mat) + (co*Mt.nli+1-Mt.delta)*Mt.sizelt;
    Move(p^,pt^,nli_*M.sizelt); //copie la colonne
  end;
  MatFree(M);//teste dbordement
  M:=Mt;
end;
procedure MatSetColAZero(M:TFMatrix;numcol:integer);
var
  p: pchar;
begin
  p:=pchar(M.mat) + (numcol*M.nli+1-M.delta)*M.sizelt;
  FillChar(p^,M.nli*M.sizelt,0);
end;
function MatVal(M:TFMatrix;ix1:integer):double; //ix=1..sizmat
begin
  with M do result:=PCellD( pchar(MxD)+ (ix1-1)*k_tmSizDoublePrecision8 )^;
end;
procedure MatCopyCol(M:TFMatrix;numcolsrc,numcoldst:integer);
var
ps,pd: pchar;
begin
  ps:=pchar(M.mat) + (numcolsrc*M.nli+1-M.delta)*M.sizelt;
  pd:=pchar(M.mat) + (numcoldst*M.nli+1-M.delta)*M.sizelt;
  Move(ps^ , pd^ , M.nli*M.sizelt);
end;

procedure MatSaveData(M:TFMatrix;PF:string);
//ne range que les cellules de la matrice
var F:file;
begin
  AssignFile(F,PF);
  Rewrite(F,M.sizmat*M.sizelt);
  if M.sizmat>0 then BlockWrite(F,M.mat^,1);
  CloseFile(F);
end;
procedure MatLoadData(M:TFMatrix;PF:string;rafraichirdate:boolean=false);
//ne charge que les cellules de la matrice
var F:file;
begin
  AssignFile(F,PF);
  Reset(F,M.sizmat*M.sizelt);
  if M.sizmat>0 then BlockRead(F,M.mat^,1);
  CloseFile(F);
  if rafraichirdate then Utils.DaterFichier(PF,0);// la date du jour
end;
procedure MatSaveMat(M:TFMatrix;PF:string);
//range tout
var
F:file;
begin
  AssignFile(F,PF);
  Rewrite(F,1);
  BlockWrite(F,M,sizeof(M));
  BlockWrite(F,M.mat^, M.sizmat*M.sizelt);
  CloseFile(F);
end;
procedure MatLoadMat(var M:TFMatrix;PF:string;rafraichirdate:boolean=false);
//charge tout et rinitialise
var
F:file;
i: integer;
begin
  MatFree(M); //libre la mmoire
  AssignFile(F,PF);
  Reset(F,1);
  BlockRead(F,M,sizeof(M));
  if Assigned(M.mat) then begin  //on relit tout
    i:=M.sizmat*M.sizelt;
    GetMem(M.mat,i);
    BlockRead(F,M.mat^,i);
  end;
  CloseFile(F);
  if rafraichirdate then Utils.DaterFichier(PF,0);// la date du jour
end;

////////////////////////////////////////////////  T F P a c k M a t /////////////////////////////////////////////////////////

procedure PkMatInit(var Mp:TFPackMat);
begin
  FillChar(Mp,SizeOf(Mp),0);
end;
procedure PkMatClear(Mp:TFPackMat);
begin
  with Mp do FillChar(MpD^,sizmat*k_tmSizDoublePrecision8,0);
end;
procedure PkMatCreate(var Mp:TFPackMat;nom:string;nbel:integer;ciel_:boolean);
var
  n: integer;
begin
  FillChar(Mp,SizeOf(Mp),0);
  with Mp do begin
    nomM:=nom;
    dim:=nbel;
    ciel:=ciel_;
    if ciel then begin
      n:=dim*sizeof(integer);
      GetMem(_pdiags,n);
      FillChar(_pdiags^,n,0);
    end else begin
      sizmat:=dim*(dim+1) div 2;
      GetMem(MpD,sizmat*k_tmSizDoublePrecision8+1);
      PkMatClear(Mp);
      byte( CalPtr(MpD,sizmat*k_tmSizDoublePrecision8)^ ) := $AA ;
    end;
  end;
end;
procedure PkcMatInitCiel(var Mpc:TFPackMat);
//transforme les ht colonnes en index diag et rserve la mmoire de MpD
//index diag[1] = 0, pointe direct dans MpD
var
  i,k: integer;
begin
  with Mpc do begin
    sizmat:=0;
    for i:=1 to dim do begin
      k:=_pdiags^[i];//ht col i
      if k=0 then raise Exception.Create('hcol=0 en '+IntToStr(i));
      inc(sizmat,k); //nouvelle taille, compris vecteur i
      _pdiags^[i]:=sizmat;
    end;
    GetMem(MpD,sizmat*k_tmSizDoublePrecision8+1);
    PkMatClear(Mpc);
    byte( CalPtr(MpD,sizmat*k_tmSizDoublePrecision8+1)^ ) := $AA ;
  end;
end;
procedure Check(var Mp:TFPackMat);
begin
  with Mp do begin
    if Assigned(MpD) then begin
      if byte( CalPtr(MpD,sizmat*k_tmSizDoublePrecision8+1)^ ) <> $AA then raise exception.Create(nomM+' : violation mmoire dtecte  la libration de la matrice');
    end;
  end;
end;
procedure PkMatFree(var Mp:TFPackMat);
begin
  with Mp do begin
    if Assigned(_pdiags) then FreeMem(_pdiags,dim*sizeof(integer));
    if Assigned(MpD) then begin
      Check(Mp);
      FreeMem(MpD,sizmat*k_tmSizDoublePrecision8+1);
    end;
  end;
  PkMatInit(Mp);
end;
function pvPkMatLc(Mp:TFPackMat;li1,co1:integer):PVecDouble;
//co=1.. : n de la colonne ; li=1 sur la diagonale et augmente en remontant vers le haut de la colonne
begin
  with Mp do
  if ciel then result:=PVecDouble( pchar(MpD)+((_pdiags^[co1]-1)-(li1-1))*k_tmSizDoublePrecision8 )
          else result:=PVecDouble( pchar(MpD)+((co1*(co1+1) div 2)-li1)*k_tmSizDoublePrecision8 );
end;
function pcPkMatLc(Mp:TFPackMat;li1,co1:integer):PCellD;
//co=1.. : n de la colonne ; li=1 sur la diagonale et augmente en remontant vers le haut de la colonne
begin
  with Mp do
  if ciel then result:=PCellD( pchar(MpD)+((_pdiags^[co1]-1)-(li1-1))*k_tmSizDoublePrecision8 )
          else result:=PCellD( pchar(MpD)+((co1*(co1+1) div 2)-li1)*k_tmSizDoublePrecision8 );
end;
function pvPkMat(Mp:TFPackMat;li1,co1:integer):PVecDouble;
//li,co=1.. : n de la ligne, colonne dans une matrice normale ; l'accs  la partie L est gr, mais n'a de sens que pour traiter 1 cellule
//renvoie un pointeur sur un vecteur
begin
  if li1>co1 then xchg(li1,co1);
  with Mp do
  if ciel then result:=PVecDouble( pchar(MpD)+(_pdiags^[co1]-1-(co1-li1))*k_tmSizDoublePrecision8 )
          else result:=PVecDouble( pchar(MpD)+(li1+(co1*(co1-1) div 2)-1)*k_tmSizDoublePrecision8 );
end;
function pcPkMat(Mp:TFPackMat;li1,co1:integer):PCellD;
//li,co=1.. : n de la ligne, colonne dans une matrice normale ; l'accs  la partie L est gr, mais n'a de sens que pour traiter 1 cellule
//renvoie un pointeur sur une cellule
begin
  if li1>co1 then xchg(li1,co1);
  with Mp do
  if ciel then result:=PCellD( pchar(MpD)+(_pdiags^[co1]-1-(co1-li1))*k_tmSizDoublePrecision8 )
          else result:=PCellD( pchar(MpD)+(li1+(co1*(co1-1) div 2)-1)*k_tmSizDoublePrecision8 );
end;
function PkMatVal(Mp:TFPackMat;ix1:integer):double; //ix=1..sizmat
begin
  with Mp do
  result:=PCellD( pchar(MpD)+ (ix1-1)*k_tmSizDoublePrecision8 )^;
end;
function PkMatVal(Mp:TFPackMat;li1,co1:integer):double;
//li,co=1.. : n de la ligne, colonne dans une matrice normale ; l'accs  la partie L est gr
//renvoie la valeur, 0 si hors ligne de ciel
var
ix: integer;
begin
  if li1>co1 then xchg(li1,co1);
  with Mp do
  if ciel then begin
    ix:=_pdiags^[co1]-(co1-li1);
    if (co1>1) and (ix<=_pdiags^[co1-1])
      then result:=0
      else result:=PCellD( pchar(MpD)+(ix-1)*k_tmSizDoublePrecision8 )^
  end else result:=PCellD( pchar(MpD)+(li1+(co1*(co1-1) div 2)-1)*k_tmSizDoublePrecision8 )^;
end;
function PkMatHCol(Mp:TFPackMat;co1:integer):integer;
begin
  with Mp do begin
    if ciel then begin
      result:=Mp._pdiags^[co1];
      if Assigned(MpD) and (co1>1) then dec(result,Mp._pdiags^[co1-1]); // si MpD est cr, _pdiags pointe l'elt diag, sinon contient la ht col
    end else result:=co1; //renvoie tjs la ht colonne
  end;
end;
procedure PkMatSetHCol(Mp:TFPackMat;co1,hc:integer);
//finalis par l'appel de PkcMatInitCiel
begin
  with Mp do
    if ciel and (MpD=nil) then _pdiags^[co1]:=hc
    else raise Exception.Create('la hauteur colonne ne peut tre modifie');
end;
function PkMatInMat(Mp:TFPackMat;li1,co1:integer):boolean;
//renvoie T si la cellule est dans la matrice (seulement pour matrice ciel, pour matrice triangulaire, renvoie tjs T)
//(le rgt triangulaire est un rangement compact destin aux matrices symtriques)
begin
  with Mp do
  if ciel then begin //sinon mat tri
    if li1>co1 then xchg(li1,co1);
    result := ( co1 = 1 ) or
              ( li1 >= co1-(_pdiags^[co1]-_pdiags^[co1-1])+1 );
  end else result:=true;
end;
function PkcMatDebCol(Mp:TFPackMat;co1:integer):integer;
//renvoie l'indice de dbut de colonne (en adressage normal) pour une matrice ciel - erreur si pas ciel
begin
  with Mp do
  if ciel then begin //sinon mat tri
    result:= co1 - (_pdiags^[co1]-_pdiags^[co1-1]) + 1;
  end else raise Exception.Create('la matrice doit tre de type ciel');
end;

function PkMatToStr(M:TFPackMat):string;
var
  l,c: integer;
begin
  with M do begin
    result:='';
    for l:=1 to dim do begin
      for c:= 1 to l-1 do result:=result+'                ';
      for c:=l to dim do result:=result+Format(' %15.5e',[pcPkMat(M,l,c)^]);
      result:=result+k_CRLF;
    end;
  end;
end;

procedure PkMat_MxM(Mr,M1,M2:TFPackMat;n:integer=0);
var
  li,co,k: integer;
  d: double;
begin
  with Mr do begin
    if n=0 then n:=dim;
    for li:=1 to n do for co:=1 to n do if co>=li then begin //on ne remplit que la demi matrice
      d:=0;
      for k:=1 to n do d:=d+pcPkMat(M1,li,k)^*pcPkMat(M2,k,co)^;
      pcPkMat(Mr,li,co)^:=d;
    end;
  end;
end;

procedure PkMat_MxV(var Vr:TVecDouble;M:TFPackMat;var V:TVecDouble;n:integer);
var
  li,k: integer;
  d: double;
begin
  with M do begin
    for li:=1 to n do begin
      d:=0;
      for k:=1 to n do d:=d+pcPkMat(M,li,k)^*PCellRelD(V,k)^;
      PCellRelD(Vr,li)^:=d;
    end;
  end;
end;

procedure PkMatSaveData(M:TFPackMat;PF:string);
//ne range que les cellules de la matrice
var F:file;
begin
  AssignFile(F,PF);
  Rewrite(F,M.sizmat*k_tmSizDoublePrecision8+1);
  BlockWrite(F,M.MpD^,1);
  CloseFile(F);
end;
procedure PkMatLoadData(M:TFPackMat;PF:string);
//ne charge que les cellules de la matrice
var F:file;
begin
  AssignFile(F,PF);
  Reset(F,M.sizmat*k_tmSizDoublePrecision8+1);
  BlockRead(F,M.MpD^,1);
  CloseFile(F);
end;
procedure PkMatSaveMat(M:TFPackMat;PF:string);
//range tout
var F:file;
begin
  AssignFile(F,PF);
  Rewrite(F,1);
  BlockWrite(F,M,sizeof(M));
  if Assigned(M.MpD) then BlockWrite(F,M.MpD^,M.sizmat*k_tmSizDoublePrecision8+1);
  if Assigned(M._pdiags) then BlockWrite(F,M._pdiags^,M.dim*sizeof(integer));
  CloseFile(F);
end;
procedure PkMatLoadMat(var M:TFPackMat;PF:string);
//charge tout et rinitialise
var F:file;
begin
  PkMatFree(M); //libre la mmoire
  AssignFile(F,PF);
  Reset(F,1);
  BlockRead(F,M,sizeof(M));
  if Assigned(M.MpD) then begin
    GetMem(M.MpD,M.sizmat*k_tmSizDoublePrecision8+1);
    BlockRead(F,M.MpD^,M.sizmat*k_tmSizDoublePrecision8+1);
  end;
  if Assigned(M._pdiags) then begin
    GetMem(M._pdiags,M.dim*sizeof(integer));
    BlockRead(F,M._pdiags^,M.dim*sizeof(integer));
  end;
  CloseFile(F);
end;

procedure PkMatCopyData(var Mr:TFPackMat; M:TFPackMat; struconly:boolean=false);
var  n: integer;
begin
  Mr.dim:=M.dim;
  Mr.sizmat:=M.sizmat;
  Mr.ciel:=M.ciel;
  if Mr.ciel then begin
    n:=Mr.dim*sizeof(integer);
    GetMem(Mr._pdiags,n);
    Move(M._pdiags^,Mr._pdiags^,n);
  end;
  GetMem(Mr.MpD,Mr.sizmat*k_tmSizDoublePrecision8+1);
  if struconly
    then FillChar(Mr.MpD^,Mr.sizmat*k_tmSizDoublePrecision8+1,0)      //vide
    else Move(M.MpD^,Mr.MpD^,Mr.sizmat*k_tmSizDoublePrecision8+1);  //copie
end;

procedure PkMatZero(M:TFPackMat);
begin
  FillChar(M.MpD^,M.sizmat*k_tmSizDoublePrecision8,0);
end;
////////////////////////////////////////////////  T V e c t o r /////////////////////////////////////////////////////////

procedure VecCreate(var V:TVector;nom:string;type_,nbe:integer;nofill:boolean=false);
begin
  with V do begin
    nomV:=nom;
    sizvec:=nbe;
    if sizvec=0 then raise Exception.Create('le vecteur est de taille nulle');
    typelt:=type_;
    sizelt:=k_sizelt[type_];
    GetMem(vec,sizvec*sizelt+1);
    case typelt of   //fait pointer le bon type sur la zone mmoire
      k_tmInteger4:VcI:=vec;
      k_tmLogical4:VcL:=vec;
      k_tmReal4   :VcR:=vec;
      k_tmDoublePrecision8:VcD:=vec;
      k_tmComplex8:VcC:=vec;
      k_tmDoubleComplex16:VcDC:=vec;
      k_tmPRecord4:VcRc:=vec;
    end;
    if not nofill then VecClear(V);//FillChar(vec^,sizvec*sizelt+1,0);
    byte( CalPtr(vec,sizvec*sizelt)^ ) := $AA ; //10101010
  end;
end;
procedure VecInit(var V:TVector);
begin
  FillChar(V,sizeof(V),0);
end;
procedure VecClear(var V:TVector);
begin
  with V do FillChar(vec^,sizvec*sizelt,0);
end;
procedure Check(var V:TVector);
begin
  if V.sizelt=0 then exit; //dj fait
  with V do if Assigned(vec) then begin
    if byte( CalPtr(vec,sizvec*sizelt)^ ) <> $AA then raise exception.Create(nomV+' : violation mmoire dtecte  la libration du vecteur');
  end;
end;
procedure VecFree(var V:TVector);
begin
  if V.sizelt=0 then exit; //dj fait
  with V do if Assigned(vec) then begin
    Check(V);
    FreeMem(vec,V.sizvec*sizelt+1);
  end;
  VecInit(V);
end;
procedure VecResize(var V:TVector;newsize:integer);
//conserve les donnes existantes, met  0 le complment si extension, libre la mmoire si rduction
//dans l'opration, le pointeur mmoire interne change (vec), mais c'est transparent pour l'utilisateur
var
  nbcop,nz: integer;
  pz: pointer;
  Vt:TVector;
begin
  if newsize=V.sizvec then exit; //pas de chgt!
  VecCreate(Vt,V.nomV,V.typelt,newsize,true); //nouveau temporaire, pas de raz
  if newsize>V.sizvec then begin //extension
    nbcop:=V.sizvec;
    nz:=(newsize-nbcop)*V.sizelt;//nb oct  raz
  end else begin //rduction
    nbcop:=newsize;
    nz:=0;
  end;
  Move( V.vec^ , Vt.vec^ , nbcop * V.sizelt );
  pz:= pchar(Vt.vec) + nbcop * V.sizelt;
  FillChar(pz^,nz,0);
  VecFree(V);//teste dbordement
  V:=Vt;
end;

//renvoie un pointeur sur l'lment
function PMatI(M:TFMatrix;li1,co1:integer):PMatInteger;
begin
  with M do result:=PMatInteger( pchar(mat) + (co1*nli+li1-delta)*k_tmSizInteger4 );
end;
function PVecI(M:TFMatrix;li1,co1:integer):PVecInteger;
begin
  with M do result:=PVecInteger( pchar(mat) + (co1*nli+li1-delta)*k_tmSizInteger4 );
end;
function PVecI(V:TVector;ix:integer):PVecInteger;
begin
  with V do result:=PVecInteger( pchar(vec) + (ix-1)*k_tmSizInteger4 );
end;

function PMatL(M:TFMatrix;li1,co1:integer):PMatLogical;
begin
  with M do result:=PMatLogical( pchar(mat) + (co1*nli+li1-delta)*k_tmSizLogical4 );
end;
function PVecL(M:TFMatrix;li1,co1:integer):PVecLogical;
begin
  with M do result:=PVecLogical( pchar(mat) + (co1*nli+li1-delta)*k_tmSizLogical4 );
end;
function PVecL(V:TVector;ix:integer):PVecLogical;
begin
  with V do result:=PVecLogical( pchar(vec) + (ix-1)*k_tmSizLogical4 );
end;

function PMatR(M:TFMatrix;li1,co1:integer):PMatReal;
begin
  with M do result:=PMatReal( pchar(mat) + (co1*nli+li1-delta)*k_tmSizReal4 );
end;
function PVecR(M:TFMatrix;li1,co1:integer):PVecReal;
begin
  with M do result:=PVecReal( pchar(mat) + (co1*nli+li1-delta)*k_tmSizReal4 );
end;
function PVecR(V:TVector;ix:integer):PVecReal;
begin
  with V do result:=PVecReal( pchar(vec) + (ix-1)*k_tmSizReal4 );
end;

function PMatD(M:TFMatrix;li1,co1:integer):PMatDouble;
begin
  with M do result:=PMatDouble( pchar(mat) + (co1*nli+li1-delta)*k_tmSizDoublePrecision8 );
end;
function PVecD(M:TFMatrix;li1,co1:integer):PVecDouble;
begin
  with M do result:=PVecDouble( pchar(mat) + (co1*nli+li1-delta)*k_tmSizDoublePrecision8 );
end;
function PVecD(V:TVector;ix:integer):PVecDouble;
begin
  with V do result:=PVecDouble( pchar(vec) + (ix-1)*k_tmSizDoublePrecision8 );
end;

function PMatC(M:TFMatrix;li1,co1:integer):PMatComplex;
begin
  with M do result:=PMatComplex( pchar(mat) + (co1*nli+li1-delta)*k_tmSizComplex8 );
end;
function PVecC(M:TFMatrix;li1,co1:integer):PVecComplex;
begin
  with M do result:=PVecComplex( pchar(mat) + (co1*nli+li1-delta)*k_tmSizComplex8 );
end;
function PVecC(V:TVector;ix:integer):PVecComplex;
begin
  with V do result:=PVecComplex( pchar(vec) + (ix-1)*k_tmSizComplex8 );
end;

function PMatDC(M:TFMatrix;li1,co1:integer):PMatDoubleComplex;
begin
  with M do result:=PMatDoubleComplex( pchar(mat) + (co1*nli+li1-delta)*k_tmSizDoubleComplex16 );
end;
function PVecDC(M:TFMatrix;li1,co1:integer):PVecDoubleComplex;
begin
  with M do result:=PVecDoubleComplex( pchar(mat) + (co1*nli+li1-delta)*k_tmSizDoubleComplex16 );
end;
function PVecDC(V:TVector;ix1:integer):PVecDoubleComplex;
begin
  with V do result:=PVecDoubleComplex( pchar(vec) + (ix1-1)*k_tmSizDoubleComplex16 );
end;
function PVecRc(V:TVector;ix1:integer):PVecRec;
begin
  with V do result:=PVecRec( pchar(vec) + (ix1-1)*k_tmSizPRecord4 );
end;

//Vecteur : accs direct  la mmoire sans contrle
function PCellRelI(var V:TVecInteger; ix1:integer):PVecInteger;
begin
  result:=PVecInteger( pchar(@V)+(ix1-1)*k_tmSizInteger4 );
end;
function PCellRelL(var V:TVecLogical; ix1:integer):PVecLogical;
begin
  result:=PVecLogical( pchar(@V)+(ix1-1)*k_tmSizLogical4 );
end;
function PCellRelR(var V:TVecReal; ix1:integer):PVecReal;
begin
  result:=PVecReal( pchar(@V)+(ix1-1)*k_tmSizReal4 );
end;
function PCellRelD(var V:TVecDouble; ix1:integer):PVecDouble;
begin
  result:=PVecDouble( pchar(@V)+(ix1-1)*k_tmSizDoublePrecision8 );
end;
function PCellRelC(var V:TVecComplex; ix1:integer):PVecComplex;
begin
  result:=PVecComplex( pchar(@V)+(ix1-1)*k_tmSizComplex8 );
end;
function PCellRelDC(var V:TVecDoubleComplex; ix1:integer):PVecDoubleComplex;
begin
  result:=PVecDoubleComplex( pchar(@V)+(ix1-1)*k_tmSizDoubleComplex16 );
end;
function PCellRelRc(var V:TVecRec;ix1:integer):PVecRec;
begin
  result:=PVecRec( pchar(@V)+(ix1-1)*k_tmSizPRecord4 );
end;

//Matrice : accs direct  la mmoire sans contrle
function PCellRelD(var M:TMatDouble; nli , li1,co1:integer):PVecDouble;
begin
  result:=PVecDouble( pchar(@M)+((co1-1)*nli+li1-1)*k_tmSizDoublePrecision8 );
end;

procedure CumulerCellule(M:TFMatrix;li1,co1:integer;value:double);
var
  cell: pointer;
begin
  if M.typelt<>k_tmDoublePrecision8 then raise Exception.Create('type de matrice incompatible');
  with M do cell:=pchar(MxD)+(co1*nli+li1-delta)*k_tmSizDoublePrecision8;
  double(cell^):=double(cell^)+value;
end;

/////////////////////////////////////////////////////////// OPERATIONS

procedure MatSetId(M:TFMatrix);//cre une matrice Id
var
i: integer;
begin
  with M do begin
    if (M.nli<>M.nco) then raise Exception.Create('MatSetId : la matrice doit tre carre');
    FillChar(mat^,sizmat*sizelt,0);
    for i:=1 to nli do case typelt of   //fait pointer le bon type sur la zone mmoire
      k_tmInteger4:PVecI(M,i,i)^:=1;
      k_tmLogical4:PVecL(M,i,i)^:=true;
      k_tmReal4:PVecR(M,i,i)^:=1;
      k_tmDoublePrecision8:PVecD(M,i,i)^:=1;
      k_tmComplex8:PVecC(M,i,i)^:= TVecComplex( Complex(1,1) );
      k_tmDoubleComplex16:PVecDC(M,i,i)^:=TVecDoubleComplex( DoubleComplex(1,1) );
    end;
  end;
end;

procedure MatMul_AxB(var Mr,A,B:TMatDouble ; nlc:integer);
var
  l,c,k: integer;
  d: double;
  pMtmp : PMatDouble;
  tmp: boolean;
begin
  tmp:= (@Mr=@A) or (@Mr=@B) ;
  if tmp then GetMem(pMtmp, nlc*nlc*k_tmSizDoublePrecision8) else pMtmp:=@Mr;
  for l:=1 to nlc do for c:=1 to nlc do begin
    d:=0;
    for k:=1 to nlc do d:=d+PCellRelD(A,nlc,l,k)^ * PCellRelD(B,nlc,k,c)^ ;
    PCellRelD(Mr,nlc,l,c)^:=d;
  end;
  if tmp then begin
    Move(pMtmp^ , Mr , nlc*nlc*k_tmSizDoublePrecision8);
    FreeMem(pMtmp, nlc*nlc*k_tmSizDoublePrecision8);
  end;
end;

procedure MatCombiLin(var Mres:TFMatrix;alpha:double;A:TFMatrix;beta:double;B:TFMatrix);
var
  i,j: integer;
begin
  for i:=1 to Mres.nli do for j:=1 to Mres.nco do PMatD(Mres,i,j)^:=alpha*PMatD(A,i,j)^ + beta*PMatD(B,i,j)^ ;
end;

procedure MatMulV(var Vr:TVecDouble; var M:TMatDouble; nl,nc:integer; var V:TVecDouble);//NB : Vr[nl], V[nc]
var
  i,j: integer;
  pVtmp : PVecDouble;
  d: double;
begin
  if @Vr=@V then GetMem(pVtmp, nl*k_tmSizDoublePrecision8) else pVtmp:=@Vr;
  for i:=1 to nl do begin
    d:=0;
    for j:=1 to nc do d:=d+PCellRelD(M,nl,i,j)^*PCellRelD(V,j)^;
    PCellRelD(pVtmp^,i)^ := d;
  end;
  if @Vr=@V then begin
    Move( pVtmp^ , Vr , nl*k_tmSizDoublePrecision8);
    FreeMem(pVtmp, nl*k_tmSizDoublePrecision8);
  end;
end;
procedure MatMulV(Vr:TVector;M:TFMatrix;V:TVector);
begin
  if (Vr.sizvec <> M.nco) or (V.sizvec <> M.nli) then raise Exception.Create('tailles incompatibles dans MatMulV');
  case M.typelt of   //fait pointer le bon type sur la zone mmoire
    k_tmInteger4:;
    k_tmLogical4:;
    k_tmReal4:;
    k_tmDoublePrecision8:MatMulV(Vr.VcD^,M.MxD^,M.nli,M.nco,V.VcD^);
    k_tmComplex8:;
    k_tmDoubleComplex16:;
  end;
end;

procedure VecCopy(var Vr,V:TVecDouble;n:integer);
begin
  Move(V,Vr,n*k_tmSizDoublePrecision8);
end;
procedure VecCopy(PVr,PV:PVecDouble;n:integer);
begin
  Move(PV^,PVr^,n*k_tmSizDoublePrecision8);
end;

function VecIxAbsMax(ne:integer;var V:TVecDouble):integer;
var
  e: integer;
  d,da: double;
begin
  d:=0;
  result:=0;
  for e:=1 to ne do begin
    da:=Abs(PCellRelD(V,e)^);
    if da>d then begin
      d:=da;
      result:=e;
    end;
  end;
end;

/////////////////////////////////////////// AFFICHAGE

function MatToStr(M:TFMatrix):string;
begin
  with M do result:=MatToStr(nli,nco,MxD^);
end;
function MatToStr(nli,nco:integer;var M:TMatDouble):string;
var
  l,c: integer;
begin
  result:='';
  for l:=1 to nli do begin
    for c:=1 to nco do result:=result+Format('  %15.5e',[PCellRelD(M,nco,l,c)^]);
    result:=result+k_CRLF;
  end;
end;

function VecToStr(V:TVector;vert:boolean=false):string;
begin
  with V do result:=VecToStr(sizvec,VcD^,vert);
end;
function VecToStr(ne:integer;var V:TVecDouble;vert:boolean=false):string;
const
k_hv: array[boolean] of string[2] = ('',k_CRLF);
var
e: integer;
begin
  result:='';
  for e:=1 to ne do result:=result+Format('  %15.5e',[PCellRelD(V,e)^])+k_hv[vert];
  result:=result+k_CRLF;
end;

procedure MatDisplay(tit:string;M:TFMatrix);
begin
  with M do AffiMemo(tit,Format('nli=%d  nco=%d  type=%d  sizelt=%d  sizmat=%d  mem=%d ko',[nli,nco,typelt,sizelt,sizmat,sizmat*sizelt div 1024])+k_CRLF+MatToStr(M));
end;
procedure VecDisplay(tit:string;V:TVector;vert:boolean=false);
begin
  with V do AffiMemo(tit,Format('type=%d  sizelt=%d  sizvec=%d  mem=%d ko',[typelt,sizelt,sizvec,sizvec*sizelt div 1024])+k_CRLF+VecToStr(V,vert));
end;
procedure VecDisplay(tit:string;ne:integer;var V:TVecDouble;vert:boolean=false);
begin
  AffiMemo(tit,VecToStr(ne,V,vert));
end;

END.


























