unit Uheaders_F;
//destin  ARPACK ; suppose 1 routine par fichier .F, avec le mme nom
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Utils, StringUtils, StdCtrls, Math;

type
  TFheaders_F = class(TForm)
    Label1: TLabel;
    MmSrcs: TMemo;
    LbTraite: TLabel;
    MmRes: TMemo;
    GO: TButton;
    LBxErr: TListBox;
    EdStop: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure GOClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
    nf: integer;
    args: TStringList;
    func: boolean;
    procedure TraiterFichier(pf,nomproc:string);
    procedure ClearArgs;
    function IndexArg(Anom:string):integer;
    procedure AddArg(Anom,AtypeF,Aspec:string);
    function ProcF(nom:string):string;
//    function ProcD(nom:string):string;
    function ArgChar:boolean;
    function ParamsP(yccaches:boolean):string;
    function ParamsPcall:string;
  public
    { Dclarations publiques }
  end;

  Targ = class
    nompas,
    specificateur,
    typefortran,
    typepascal: string[64];
    typechar: boolean;
  end;
var
  Fheaders_F: TFheaders_F;

implementation

{$R *.dfm}

uses strutils, clipbrd,         ARPACK;

const
  k_nomsdelphi = ',ARRAY,TYPE,';   //noms de variables  translater
//  k_nomlib = 'arpacklib.dll';
  k_nomlib = 'lapacklib.dll';


procedure TFheaders_F.FormCreate(Sender: TObject);
begin
  args:=TStringList.Create;       
{   MmSrcs.Text:= 'C:\DEV\FORTRAN\ARPACK\TEST\*.f';     }
{ MmSrcs.Text:= 'C:\DEV\FORTRAN\ARPACK\UTIL\*.f'+k_CRLF+
                'C:\DEV\FORTRAN\ARPACK\BLAS\*.f'+k_CRLF+
                'C:\DEV\FORTRAN\ARPACK\LAPACK\*.f'+k_CRLF+
                'C:\DEV\FORTRAN\ARPACK\SRC\*.f';}
 MmSrcs.Text:= 'C:\DEV\FORTRAN\lapack_3.1.1\BLAS\SRC\*.f'+k_CRLF+
                'C:\DEV\FORTRAN\lapack_3.1.1\SRC\*.f';
end;

procedure TFheaders_F.FormDestroy(Sender: TObject);
begin
  args.Free;
end;

procedure TFheaders_F.ClearArgs;
var  i: integer;
begin
  for i:=1 to args.Count do Targ(args.Objects[i-1]).Free;
  args.Clear;
end;

function TFheaders_F.IndexArg(Anom:string):integer;
begin
  result:=-1;
  Anom:=Trim(Uppercase(Anom));
  if Anom='' then exit;
  result:=args.IndexOf(Anom);
end;

function completer_type_char(S:string):string;
  procedure getlg;
  var i:integer;
  begin
    i:=2;
    while S[i] in ['0'..'9'] do begin  result:=result+S[i]; inc(i); end; //capte lg
  end;
begin
  result:='';
  if S[1]='(' then begin   //CHARACTER(xx)
    getlg;
  end else if S[1]='*' then begin //CHARACTER*???
    if Pos('*(*)',S)=1 then result:='256'  //CHARACTER*(*)
    else getlg; //CHARACTER*xx
  end;
  if result='1' then result:='';
end;

var
  TypesAry: string; //la liste des types tableau

function calculertypeP(A:Targ):string;
const // ; en dbut et fin !!
  k_nt = 37;
  k_xlF : array[1..k_nt] of string = ('INTEGER*1','INTEGER(1)','INTEGER*2','INTEGER(2)','INTEGER*4','INTEGER(4)','INTEGER*8','INTEGER(8)','INTEGER',
                                      'REAL*4','REAL(4)','REAL*8','REAL(8)','DOUBLE PRECISION','DOUBLEPRECISION','REAL*16','REAL(16)','REAL',
                                      'COMPLEX*8','COMPLEX(4)','COMPLEX*16','COMPLEX(8)','DOUBLE COMPLEX','DOUBLECOMPLEX','COMPLEX*32','COMPLEX(16)','COMPLEX',
                                      'LOGICAL*1','LOGICAL(1)','LOGICAL*2','LOGICAL(2)','LOGICAL*4','LOGICAL(4)','LOGICAL*8','LOGICAL(8)','LOGICAL',
                                      'CHARACTER');
  k_xlP : array[1..k_nt] of string = ('shortint','shortint','smallint','smallint','integer','integer','int64','int65','integer',
                                      'real','real','double','double','double','double','xxx','xxx','real',
                                      'TComplex','TComplex','TDoubleComplex','TDoubleComplex','TDoubleComplex','TDoubleComplex','xxx','xxx','TComplex',
                                      'boolean','boolean','wordbool','wordbool','longbool','longbool','xxx','xxx','longbool',
                                      'char');
var
  i,nv: integer;
  S,F: string;
begin
  result:='';
  F:=A.typefortran+A.specificateur;
  for i:=1 to k_nt do if F=k_xlF[i] then begin
    result:=k_xlP[i];
    exit;
  end;
  F:=A.typefortran+' ';
  for i:=1 to k_nt do if Pos(k_xlF[i],F)=1 then begin
    result:=k_xlP[i];
    F:=A.specificateur;
    if result='char' then begin
      result:='char'+completer_type_char(F);
    end else begin //tableau
      if F[1]='(' then begin //ya tableau (mais plus char..)
        nv:=NbrSep(F,',');
        if nv>0 then S:='ary'+IntToStr(nv+1)+result else S:='ary'+result;
        if Pos(';'+S+';', TypesAry)=0 then TypesAry:=TypesAry+S+';'; //complte la table
        result:=S;
      end else result:=result+F+'???';
    end;
  end;
end;

procedure TFheaders_F.AddArg(Anom,AtypeF,Aspec:string);
var
  ix: integer;
  a: Targ;
begin
  Anom:=Trim(Uppercase(Anom));
  if Anom='' then exit;
  ix:=args.IndexOf(Anom);
  if ix=-1 then begin
    a:=Targ.Create;
    ix:=args.AddObject(Anom,a);
//vrifier si nom rserv de delphi
    if Pos(','+Anom+',',k_nomsdelphi)>0 then Anom:=Anom+'_';
    a.nompas:=Anom;
  end else a:=Targ(args.Objects[ix]);
  if AtypeF<>'' then begin //ajouter le type
    a.typechar:= Pos('CHARACTER',AtypeF)=1;
    a.typefortran:=Uppercase(AtypeF);
    a.specificateur:=Uppercase(Aspec);
    a.typepascal:=calculertypeP(a);
  end;
end;

function TFheaders_F.ArgChar:boolean;
var i: integer;
begin
  result:=true;
  for i:=1 to args.Count do if Targ(args.Objects[i-1]).typechar then exit;
  result:=false;
end;

function TFheaders_F.ParamsP(yccaches:boolean):string;//params pascal
var
  ix,narg: integer;
  a: Targ;
  Spl: string;
begin
  narg:=args.Count;
  Spl:='';
  result:='';
  for ix:=1 to narg do begin
    a:= Targ(args.Objects[ix-1]);
    if a.typechar then Spl:=Spl+',l__'+a.nompas;
    result:=result+'var '+a.nompas+':'+a.typepascal+';';
  end;
  if yccaches and (Spl<>'') then begin //ajoute paramtres cachs
    delete(Spl,1,1);
    result:=result+Spl+':integer;';
  end;
  delete(result,length(result),1);//le dernier ;
end;

function TFheaders_F.ParamsPcall:string;//params pascal pour appel
var
  ix,narg: integer;
  a: Targ;
  Spl: string;
begin
  narg:=args.Count;
  Spl:='';
  result:='';
  for ix:=1 to narg do begin
    a:= Targ(args.Objects[ix-1]);
    if a.typechar then Spl:=Spl+',length('+a.nompas+')';
    result:=result+','+a.nompas;
  end;
  result:=result+Spl;
  delete(result,1,1);
end;

function TFheaders_F.ProcF(nom:string):string;
//crit l'en-tte pour transformer la dfinition de fonction en dfinition de procedure
var
  ix,narg: integer;
  a: Targ;
  S,SF: string;
begin
  nom:=Uppercase(nom);
  if func then SF:='FUNC_' else SF:='';
  result:= 'cDEC$ ATTRIBUTES  DLLEXPORT :: '+SF+nom+k_LF;
  if not func then exit;

  narg:=args.Count;
  S:='';
  for ix:=1 to narg do S:=S+','+args[ix-1];
  delete(S,1,1);
  result:=result+'      SUBROUTINE FUNC_'+nom+'('+S+')'+k_LF;
  for ix:=1 to narg do with Targ(args.Objects[ix-1]) do result:=result+'      '+typefortran+' '+args[ix-1]+specificateur+k_LF; //les dclarations de type
  delete(S,1,length('RESULT_,')); //ote 1er arg
  result:=result+'      RESULT_ = '+nom+'('+S+')'+k_LF+ //l'appel de la fonction
                 '      END'+k_LF;
end;

{function TFheaders_F.ProcD(nom:string):string;
//la ligne de dclaration Delphi
var
  ix,narg: integer;
  a: Targ;
  S: string;
begin
  nom:=Uppercase(nom);
  narg:=args.Count;
  S:='';
  for ix:=1 to narg do begin
    a:=Targ(args.Objects[ix-1]);
    S:=S+', var '+a.nompas+':'+a.typepascal;
  end;
  delete(S,1,1);
  result:='procedure '+nom+'('+S+');stdcall; external '''+k_nomlib+''';'; //interface
end; }

var
  ncarlus,ncarlusP,posblocsub: integer;
  txtimplementation,txtinterface: string;

function getligLF(var S:string):string;
begin
  result:=LireEtOterStr0(S,k_LF);
  inc(ncarlus, length(result)+1{LF} );
end;

function ligne(var txt:string):string;
//saute les commentaires
//regroupe les lignes de suite
var
  Sprec: string;
  function ligne_non_comm:string;
  //pas de Trim ici
  begin
    result:='';
    while txt<>'' do begin
      result:=UpperCase( getligLF(txt) );
      Sprec:=result;
      if (result<>'') and not (result[1] in ['*','!','C']) then exit;
    end;
  end;
  procedure oter_comm(sep:char;var L:string);
  //pas de Trim ici
  var i1,i2: integer;
  begin
    repeat
      i1:=Pos(sep,L);
      if i1=0 then exit;
      i2:=PosEx(sep,L,i1+1);
      if i2=0 then exit;//err??
      delete(L,i1,i2-i1+1);
    until false;
  end;
var
  S: string;
  i: integer;
begin
  Sprec:='';//car on lit 1 ligne de trop pour vrifier col 6
  result:='';
  repeat
    ncarlusP:=ncarlus;
    S:=ligne_non_comm;
//supp Hollerith
    oter_comm('''',S);
    oter_comm('"',S);
    i:=Pos('!',S);
    if i>0 then SetLength(S,i-1);//commentaire aprs le !
    if (length(S)>5) and (S[1]=' ') and (S[6]>' ') then delete(S,1,6) //ligne de suite
    else begin
      if result<>'' then begin
        txt:=Sprec+k_LF+txt; //restitue
        ncarlus:=ncarlusP;
        exit;
      end;
      S:=Trim(S);
    end;
    if S='' then continue; //vide au final, on ignore
    if S[1]='&' then delete(S,1,1); //ligne de continuation, on ne vrifie pas s'il y a une prcdente
    result:=result+S;
    i:=length(result);
    if result[i]='&' then SetLength(result,i-1); //et on boucle
//    else exit;//fini
  until txt='';
end;

procedure lire_mot(var S,mot,specif:string;lectype:boolean);
const
  k_ntF=7;
  k_typF : array[1..k_ntF] of string = ('INTEGER','REAL','DOUBLE PRECISION','COMPLEX','DOUBLE COMPLEX','LOGICAL','CHARACTER');
var
  C: char;
  i: integer;
begin
  S:=trimleft(S);
  mot:='';
  if lectype then begin  //type
    for i:=1 to k_ntF do if Pos(k_typF[i],S)=1 then begin mot:=k_typF[i]; break; end;
    if mot='' then exit; //err?
    delete(S,1,length(mot));
  end else begin //nom de variable
    while ( (S+' ')[1] in ['A'..'Z','_','0'..'9'] ) do begin
      mot:=mot+S[1];
      delete(S,1,1);
    end;
  end;
//lire spcificateur
  specif:='';
  S:=trimleft(S);
  while not ( (S+'!')[1] in ['A'..'Z','_',',','!']) do begin  //arrt par le 1er nom de variable ou la 1re virgule
    C:=S[1];
    delete(S,1,1);
    if C<>' ' then specif:=specif+C;
    if C='(' then begin //chercher ) et quitter
      while  S[1]<>')' do begin
        C:=S[1];
        delete(S,1,1);
        if C<>' ' then specif:=specif+C;
      end;
      delete(S,1,1);
      specif:=specif+')';
      exit;
    end;
  end;
end;

function decouperligne(entt,S:string):string;//dcoupe  moins de 72 car par ligne
var  ix: integer;
begin
  result:='';
  S:=S+',';
  repeat
    S:=entt+S;
    if length(S)<72 then begin
      result:=result+S;
      SetLength( result , length(result)-1 );//ote la ,
      exit;
    end;
    ix:=71;
    while (S[ix]<>',') do dec(ix);
    result:=result+Copy(S,1,ix-1)+k_LF;
    delete(S,1,ix);
  until false;
end;

// rsultats de fonctions : real double integer longbool complex doublecomplex
procedure TFheaders_F.TraiterFichier(pf,nomproc:string);
var
  src,txt,txtf,S,S0,S1,Sty: string;
  mot, specif,specifbase,SIF: string;
  ix,ixf,nprms: integer;
  argch: boolean;
label ERR;
begin
  ClearArgs;
  ncarlus:=0;
  nomproc:=UpperCase(nomproc);
  if nomproc=uppercase(EdStop.Text) then showmessage('trouv');
  inc(nf);
  txtf:=StringFromFile(pf);
  if Trim(txtf)='' then exit;
//nettoyage
//  if Pos('*DEC$  ATTRIBUTES C,',txtf)=1 then getligLF(txtf);  //limine antique version...
  ix:=Pos('c<ajout IDES>'+k_LF,txtf);
  if ix>0 then begin
    ixf:=PosEx('c<fin ajout IDES>'+k_LF,txtf,ix);
    if ixf>0 then begin
      ixf:=PosEx(k_LF,txtf,ixf);
      delete(txtf,ix,ixf-ix+1);
    end;
  end;
//fin nettoyage
  txt:=txtf;
//rechercher la dclaration
  src:='';
  ncarlus:=0;
  posblocsub:=0;
  repeat
    S:=ligne(txt);  S0:=S;
    if S='' then break;//la fin
    src:=src+k_CRLF+S;
    S:=Uppercase( Trim(S) );
    if posblocsub=0 then begin //analyse de la ligne de dfinition
      posblocsub:=ncarlus;
      if pos('SUBROUTINE',S)=1 then begin
        func:=false;
        delete(S,1,10);
      end else begin
        func:=true;
        S1:=Trim( StrLireEtOterStr0(S,'FUNCTION') ); //extrait le type
        S1:=compacter(S1);
        AddArg('RESULT_',S1,'');
      end;
  //lire les paramtres
      S:=TrimLeft(S);
      if Pos(nomproc,S)<>1 then goto ERR;
      delete(S,1,length(nomproc));
      S:=TrimLeft(S);
      if S='' then break //pas de paramtres Sprms:=''
      else begin
        if S[1]<>'(' then goto ERR;
        delete(S,1,1);
        SetLength(S,length(S)-1); //ote ) final
        S:=Compacter(S);              // BREAK;
        nprms:=NbrSep(S,',')+1;
        while S<>'' do AddArg(LireEtOterStr0(S,','),'','');
      end;

    end else begin //dfinitions de type
//remplace les groupes de blancs par un seul (S est Trimme)
      S:=StringToTabString(S);
      S:=StringReplace(S,k_TAB,' ',[rfReplaceAll]);
//recherche du type des paramtres
      lire_mot(S,Sty,specifbase,true);
      if Sty='' then begin  //vrifier si la ligne est "sautable"
        if Pos('INCLUDE ',S)=1 then continue;
      end;
      S:=Compacter(S);
//lire la liste des noms de paramtres ; la dclaration de tableau est dans le nom : mavar(5,10,*)=mavar est un tableau  3 dim
      while S<>'' do begin
        lire_mot(S,mot,specif,false);  //mot est le nom de variable
        delete(S,1,1);//la virgule
//chercher si la variable est dans la liste de prms
        ix:=IndexArg(mot); //cherche le nom de variable dans les paramtres
        if ix>-1 then begin //trouv
          if specif='' then S1:=specifbase else S1:=specif;
          AddArg(mot,Sty,S1);
          dec(nprms);
          if nprms=0 then break;
        end;
      end;
      if nprms=0 then break; //on dispose de toutes les infos pour rdiger
    end;
  until false;

// modifier le fichier fortran
  StringToFile('c<ajout IDES>'+k_LF+procF(nomproc)+'c<fin ajout IDES>'+k_LF+txtf,pf); //enregistre

// ajouter le code pascal
  argch:=ArgChar;
  if func or argch then begin //il faut coder une implementation
    if func then S:='FUNC_'+nomproc else S:=nomproc;
    SIF:='procedure '+S+'('+ParamsP(false)+');';//stdcall; external '''+k_nomlib+''';'; //interface
    txtimplementation:=txtimplementation+k_CRLF+
       'procedure _'+S+'('+ParamsP(true)+');cdecl; external '''+k_nomlib+''' name '''+S+''';'+k_CRLF+
       SIF+k_CRLF+
       'begin'+k_CRLF+
       '  _'+S+'('+ParamsPcall+');'+k_CRLF+
       'end;'+k_CRLF;
  end else begin
    SIF:='procedure '+nomproc+'('+ParamsP(false)+');cdecl; external '''+k_nomlib+''';'; //interface
  end;
  txtinterface:=txtinterface+'{'+src+'}'+k_CRLF + SIF + k_CRLF+k_CRLF;
  exit;
ERR:
    LBxErr.Items.Add(pf+' : '+S0);
    exit;
end;

procedure TFheaders_F.GOClick(Sender: TObject);
var
  Srcs,S,Spfs,dir,nom: string;
begin
  MmRes.Clear;
  Srcs:=MmSrcs.Text;
  nf:=0;
  txtimplementation:='implementation'+k_CRLF;
  txtinterface:='interface'+k_CRLF;
  TypesAry:=';';
  repeat
    S:=Trim( LgetS(Srcs) );
    if S='' then break;
    dir:=ExtractFilePath(S);
    txtinterface:=txtinterface+k_CRLF+k_CRLF+'// FICHIERS DE : '+dir+k_CRLF+k_CRLF;
    FindFiles(S,0,Spfs);
    repeat
      S:=Trim( LgetS(Spfs) );
      if S='' then break;
      nom:=GetPathElt(S,k_peNom);
      S:=dir+S;
      LbTraite.Caption:='traite : '+S;
      TraiterFichier(S,nom);
    until false;
  until false;
  S:='Liste des types tableaux  crer :'+k_CRLF+TypesAry+k_CRLF+k_CRLF+txtinterface+k_CRLF+txtimplementation;
  ClipBoard.AsText:=S;
  MmRes.Text:=S;
  ShowMessage('Fin - '+IntToStr(nf)+' fichiers traits');
end;

end.










































{procedure lire_param(var src,nom,ary:string;typ:string);
  function get_nom:string;
  var  i: integer;
  begin
    for i:=1 to length(src) do if (src[i] in ['*','(',',']) then begin
      result:=Copy(src,1,i-1);
      delete(src,1,i-1);
//test noms rservs
      exit;
    end;
    result:=src;
  end;
var
  S: string;
  nv,i: integer;
begin
  nom:=get_nom;
  ary:=typ;
  if typ='char' then ary:=ary+check_str(src)
  else begin
    if Copy(src,1,1)='(' then begin //ya tableau (mais plus char..)
      S:= LireEtOterStr0(src,')'); //rcupre la dclaration de tableau
      nv:=NbrSep(S,',');
      if nv>0 then ary:='ary'+IntToStr(nv+1)+typ else ary:='ary'+typ;
      S:=ary+';';
      if Pos(';'+S, TypesAry)=0 then TypesAry:=TypesAry+S; //complte la table
    end;
  end;
  delete(src,1,1); //ote ,
//compact  src:=TrimLeft(src);
end;  }


