unit ARPACK;

interface

uses UMatriceFortran2;

{type
  charF = array[0..255] of char;  //////// A REVOIR
  charF2 = array[0..1] of char;
  charF6 = array[0..5] of char;
}


// FICHIERS DE : C:\DEV\FORTRAN\ARPACK\UTIL\

{
SUBROUTINE CMOUT( LOUT, M, N, A, LDA, IDIGIT, IFMT )
INTEGER            M, N, IDIGIT, LDA, LOUT
COMPLEX                   A( LDA, * )
charFACTER          IFMT*( 2147483647 )}
procedure CMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var IDIGIT:integer;var IFMT:charF);

{
SUBROUTINE CVOUT( LOUT, N, CX, IDIGIT, IFMT )
INTEGER            N, IDIGIT, LOUT
COMPLEX                   CX( * )
charFACTER          IFMT*( 2147483647 )}
procedure CVOUT(var LOUT:integer;var N:integer;var CX:TVecComplex;var IDIGIT:integer;var IFMT:charF);

{
SUBROUTINE DMOUT( LOUT, M, N, A, LDA, IDIGIT, IFMT )
charFACTER*( 256 )    IFMT
INTEGER            IDIGIT, LDA, LOUT, M, N
DOUBLE PRECISION   A( LDA, * )}
procedure DMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var IDIGIT:integer;var IFMT:charF);

{
SUBROUTINE DVOUT( LOUT, N, SX, IDIGIT, IFMT )
charFACTER*( 2147483647 )    IFMT
INTEGER            IDIGIT, LOUT, N
DOUBLE PRECISION   SX( * )}
procedure DVOUT(var LOUT:integer;var N:integer;var SX:TVecDouble;var IDIGIT:integer;var IFMT:charF);

{
INTEGER FUNCTION ICNTEQ (N, ARRAY, VALUE)
INTEGER    N, VALUE
INTEGER    ARRAY(*)}
procedure FUNC_ICNTEQ(var RESULT_:integer;var N:integer;var ARRAY_:TVecInteger;var VALUE:integer);

{
SUBROUTINE ICOPY( N, LX, INCX, LY, INCY )
INTEGER    INCX, INCY, N
INTEGER    LX( 1 ), LY( 1 )}
procedure ICOPY(var N:integer;var LX:shortint;var INCX:integer;var LY:shortint;var INCY:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ISET (N, VALUE, ARRAY, INC)
INTEGER    N, VALUE, INC
INTEGER    ARRAY(*)}
procedure ISET(var N:integer;var VALUE:integer;var ARRAY_:TVecInteger;var INC:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ISWAP (N,SX,INCX,SY,INCY)
INTEGER SX(1),SY(1),STEMP
INTEGER I,INCX,INCY,IX,IY,M,MP1,N}
procedure ISWAP(var N:integer;var SX:shortint;var INCX:integer;var SY:shortint;var INCY:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE IVOUT (LOUT, N, IX, IDIGIT, IFMT)
INTEGER    IX(*), N, IDIGIT, LOUT
charFACTER  IFMT*(2147483647)}
procedure IVOUT(var LOUT:integer;var N:integer;var IX:TVecInteger;var IDIGIT:integer;var IFMT:charF);

{
SUBROUTINE SECOND( T )
REAL       T}
procedure SECOND(var T:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SMOUT( LOUT, M, N, A, LDA, IDIGIT, IFMT )
INTEGER            M, N, IDIGIT, LDA, LOUT
REAL               A( LDA, * )
charFACTER          IFMT*( 2147483647 )}
procedure SMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var IDIGIT:integer;var IFMT:charF);

{
SUBROUTINE SVOUT( LOUT, N, SX, IDIGIT, IFMT )
INTEGER            N, IDIGIT, LOUT
REAL               SX( * )
charFACTER          IFMT*( 2147483647 )}
procedure SVOUT(var LOUT:integer;var N:integer;var SX:TVecReal;var IDIGIT:integer;var IFMT:charF);

{
SUBROUTINE ZMOUT( LOUT, M, N, A, LDA, IDIGIT, IFMT )
INTEGER            M, N, IDIGIT, LDA, LOUT
COMPLEX*16                   A( LDA, * )
charFACTER          IFMT*( 2147483647 )}
procedure ZMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var IDIGIT:integer;var IFMT:charF);

{
SUBROUTINE ZVOUT( LOUT, N, CX, IDIGIT, IFMT )
INTEGER            N, IDIGIT, LOUT
COMPLEX*16                   CX( * )
charFACTER          IFMT*( 2147483647 )}
procedure ZVOUT(var LOUT:integer;var N:integer;var CX:TVecComplex;var IDIGIT:integer;var IFMT:charF);



// FICHIERS DE : C:\DEV\FORTRAN\ARPACK\BLAS\

{
SUBROUTINE CAXPY(N,CA,CX,INCX,CY,INCY)
COMPLEX CX(*),CY(*),CA
INTEGER I,INCX,INCY,IX,IY,N}
procedure CAXPY(var N:integer;var CA:TComplex;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  CCOPY(N,CX,INCX,CY,INCY)
COMPLEX CX(*),CY(*)
INTEGER I,INCX,INCY,IX,IY,N}
procedure CCOPY(var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer);cdecl; external 'arpacklib.dll';

{
COMPLEX FUNCTION CDOTC(N,CX,INCX,CY,INCY)
COMPLEX CX(*),CY(*),CTEMP
INTEGER I,INCX,INCY,IX,IY,N}
procedure FUNC_CDOTC(var RESULT_:TComplex;var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer);

{
COMPLEX FUNCTION CDOTU(N,CX,INCX,CY,INCY)
COMPLEX CX(*),CY(*),CTEMP
INTEGER I,INCX,INCY,IX,IY,N}
procedure FUNC_CDOTU(var RESULT_:TComplex;var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer);

{
SUBROUTINE CGBMV ( TRANS, M, N, KL, KU, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
COMPLEX            ALPHA, BETA
INTEGER            INCX, INCY, KL, KU, LDA, M, N
charFACTER*1        TRANS
COMPLEX            A( LDA, * ), X( * ), Y( * )}
procedure CGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TComplex;var Y:TVecComplex;var INCY:integer);

{
SUBROUTINE CGEMM ( TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB,                   BETA, C, LDC )
charFACTER*1        TRANSA, TRANSB
INTEGER            M, N, K, LDA, LDB, LDC
COMPLEX            ALPHA, BETA
COMPLEX            A( LDA, * ), B( LDB, * ), C( LDC, * )}
procedure CGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var BETA:TComplex;var C:TMatComplex;var LDC:integer);

{
SUBROUTINE CGEMV ( TRANS, M, N, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
COMPLEX            ALPHA, BETA
INTEGER            INCX, INCY, LDA, M, N
charFACTER*1        TRANS
COMPLEX            A( LDA, * ), X( * ), Y( * )}
procedure CGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TComplex;var Y:TVecComplex;var INCY:integer);

{
SUBROUTINE CGERC ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
COMPLEX            ALPHA
INTEGER            INCX, INCY, LDA, M, N
COMPLEX            A( LDA, * ), X( * ), Y( * )}
procedure CGERC(var M:integer;var N:integer;var ALPHA:TComplex;var X:TVecComplex;var INCX:integer;var Y:TVecComplex;var INCY:integer;var A:TMatComplex;var LDA:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CGERU ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
COMPLEX            ALPHA
INTEGER            INCX, INCY, LDA, M, N
COMPLEX            A( LDA, * ), X( * ), Y( * )}
procedure CGERU(var M:integer;var N:integer;var ALPHA:TComplex;var X:TVecComplex;var INCX:integer;var Y:TVecComplex;var INCY:integer;var A:TMatComplex;var LDA:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  CSCAL(N,CA,CX,INCX)
COMPLEX CA,CX(*)
INTEGER I,INCX,N,NINCX}
procedure CSCAL(var N:integer;var CA:TComplex;var CX:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  CSSCAL(N,SA,CX,INCX)
COMPLEX CX(*)
REAL SA
INTEGER I,INCX,N,NINCX}
procedure CSSCAL(var N:integer;var SA:real;var CX:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  CSWAP (N,CX,INCX,CY,INCY)
COMPLEX CX(*),CY(*),CTEMP
INTEGER I,INCX,INCY,IX,IY,N}
procedure CSWAP(var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CTBSV ( UPLO, TRANS, DIAG, N, K, A, LDA, X, INCX )
INTEGER            INCX, K, LDA, N
charFACTER*1        DIAG, TRANS, UPLO
COMPLEX            A( LDA, * ), X( * )}
procedure CTBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer);

{
SUBROUTINE CTRMM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,                   B, LDB )
charFACTER*1        SIDE, UPLO, TRANSA, DIAG
INTEGER            M, N, LDA, LDB
COMPLEX            ALPHA
COMPLEX            A( LDA, * ), B( LDB, * )}
procedure CTRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);

{
SUBROUTINE CTRSM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,                   B, LDB )
charFACTER*1        SIDE, UPLO, TRANSA, DIAG
INTEGER            M, N, LDA, LDB
COMPLEX            ALPHA
COMPLEX            A( LDA, * ), B( LDB, * )}
procedure CTRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);

{
SUBROUTINE CTRSV ( UPLO, TRANS, DIAG, N, A, LDA, X, INCX )
INTEGER            INCX, LDA, N
charFACTER*1        DIAG, TRANS, UPLO
COMPLEX            A( LDA, * ), X( * )}
procedure CTRSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer);

{
DOUBLE PRECISION FUNCTION DASUM(N,DX,INCX)
DOUBLE PRECISION DX(1),DTEMP
INTEGER I,INCX,IX,M,MP1,N}
procedure FUNC_DASUM(var RESULT_:double;var N:integer;var DX:TVecDouble;var INCX:integer);

{
SUBROUTINE DAXPY(N,DA,DX,INCX,DY,INCY)
DOUBLE PRECISION DX(1),DY(1),DA
INTEGER I,INCX,INCY,IX,IY,M,MP1,N}
procedure DAXPY(var N:integer;var DA:double;var DX:TVecDouble;var INCX:integer;var DY:TVecDouble;var INCY:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  DCOPY(N,DX,INCX,DY,INCY)
DOUBLE PRECISION DX(1),DY(1)
INTEGER I,INCX,INCY,IX,IY,M,MP1,N}
procedure DCOPY(var N:integer;var DX:TVecDouble;var INCX:integer;var DY:TVecDouble;var INCY:integer);cdecl; external 'arpacklib.dll';

{
DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)
DOUBLE PRECISION DX(1),DY(1),DTEMP
INTEGER I,INCX,INCY,IX,IY,M,MP1,N}
procedure FUNC_DDOT(var RESULT_:double;var N:integer;var DX:TVecDouble;var INCX:integer;var DY:TVecDouble;var INCY:integer);

{
SUBROUTINE DGBMV ( TRANS, M, N, KL, KU, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
DOUBLE PRECISION   ALPHA, BETA
INTEGER            INCX, INCY, KL, KU, LDA, M, N
charFACTER*1        TRANS
DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )}
procedure DGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;var BETA:double;var Y:TVecDouble;var INCY:integer);

{
SUBROUTINE DGEMM ( TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB,                   BETA, C, LDC )
charFACTER*1        TRANSA, TRANSB
INTEGER            M, N, K, LDA, LDB, LDC
DOUBLE PRECISION   ALPHA, BETA
DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )}
procedure DGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer;var BETA:double;var C:TMatDouble;var LDC:integer);

{
SUBROUTINE DGEMV ( TRANS, M, N, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
DOUBLE PRECISION   ALPHA, BETA
INTEGER            INCX, INCY, LDA, M, N
charFACTER*1        TRANS
DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )}
procedure DGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;var BETA:double;var Y:TVecDouble;var INCY:integer);

{
SUBROUTINE DGER  ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
DOUBLE PRECISION   ALPHA
INTEGER            INCX, INCY, LDA, M, N
DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )}
procedure DGER(var M:integer;var N:integer;var ALPHA:double;var X:TVecDouble;var INCX:integer;var Y:TVecDouble;var INCY:integer;var A:TMatDouble;var LDA:integer);cdecl; external 'arpacklib.dll';

{
DOUBLE PRECISION FUNCTION DNRM2 ( N, DX, INCX)
INTEGER I, INCX, IX, J, N, NEXT
DOUBLE PRECISION   DX(1), CUTLO, CUTHI, HITEST, SUM, XMAX,ZERO,ONE}
procedure FUNC_DNRM2(var RESULT_:double;var N:integer;var DX:TVecDouble;var INCX:integer);

{
SUBROUTINE  DROT (N,DX,INCX,DY,INCY,C,S)
DOUBLE PRECISION DX(1),DY(1),DTEMP,C,S
INTEGER I,INCX,INCY,IX,IY,N}
procedure DROT(var N:integer;var DX:TVecDouble;var INCX:integer;var DY:TVecDouble;var INCY:integer;var C:double;var S:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DROTG(DA,DB,C,S)
DOUBLE PRECISION DA,DB,C,S,ROE,SCALE,R,Z}
procedure DROTG(var DA:double;var DB:double;var C:double;var S:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  DSCAL(N,DA,DX,INCX)
DOUBLE PRECISION DA,DX(1)
INTEGER I,INCX,IX,M,MP1,N}
procedure DSCAL(var N:integer;var DA:double;var DX:TVecDouble;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  DSWAP (N,DX,INCX,DY,INCY)
DOUBLE PRECISION DX(1),DY(1),DTEMP
INTEGER I,INCX,INCY,IX,IY,M,MP1,N}
procedure DSWAP(var N:integer;var DX:TVecDouble;var INCX:integer;var DY:TVecDouble;var INCY:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DSYMV ( UPLO, N, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
DOUBLE PRECISION   ALPHA, BETA
INTEGER            INCX, INCY, LDA, N
charFACTER*1        UPLO
DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )}
procedure DSYMV(var UPLO:charF;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;var BETA:double;var Y:TVecDouble;var INCY:integer);

{
SUBROUTINE DSYR2 ( UPLO, N, ALPHA, X, INCX, Y, INCY, A, LDA )
DOUBLE PRECISION   ALPHA
INTEGER            INCX, INCY, LDA, N
charFACTER*1        UPLO
DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )}
procedure DSYR2(var UPLO:charF;var N:integer;var ALPHA:double;var X:TVecDouble;var INCX:integer;var Y:TVecDouble;var INCY:integer;var A:TMatDouble;var LDA:integer);

{
SUBROUTINE DTBSV ( UPLO, TRANS, DIAG, N, K, A, LDA, X, INCX )
INTEGER            INCX, K, LDA, N
charFACTER*1        DIAG, TRANS, UPLO
DOUBLE PRECISION   A( LDA, * ), X( * )}
procedure DTBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer);

{
SUBROUTINE DTRMM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,                   B, LDB )
charFACTER*1        SIDE, UPLO, TRANSA, DIAG
INTEGER            M, N, LDA, LDB
DOUBLE PRECISION   ALPHA
DOUBLE PRECISION   A( LDA, * ), B( LDB, * )}
procedure DTRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer);

{
SUBROUTINE DTRSM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,                   B, LDB )
charFACTER*1        SIDE, UPLO, TRANSA, DIAG
INTEGER            M, N, LDA, LDB
DOUBLE PRECISION   ALPHA
DOUBLE PRECISION   A( LDA, * ), B( LDB, * )}
procedure DTRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer);

{
DOUBLE PRECISION FUNCTION DZASUM(N,ZX,INCX)
DOUBLE COMPLEX ZX(*)
DOUBLE PRECISION STEMP,DCABS1
INTEGER I,INCX,IX,N}
procedure FUNC_DZASUM(var RESULT_:double;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer);

{
DOUBLE PRECISION FUNCTION DZNRM2( N, X, INCX )
INTEGER                           INCX, N
COMPLEX*16                        X( * )}
procedure FUNC_DZNRM2(var RESULT_:double;var N:integer;var X:TVecComplex;var INCX:integer);

{
INTEGER FUNCTION ICAMAX(N,CX,INCX)
COMPLEX CX(*)
REAL SMAX
INTEGER I,INCX,IX,N}
procedure FUNC_ICAMAX(var RESULT_:integer;var N:integer;var CX:TVecComplex;var INCX:integer);

{
INTEGER FUNCTION IDAMAX(N,DX,INCX)
DOUBLE PRECISION DX(1),DMAX
INTEGER I,INCX,IX,N}
procedure FUNC_IDAMAX(var RESULT_:integer;var N:integer;var DX:TVecDouble;var INCX:integer);

{
INTEGER FUNCTION ISAMAX(N,SX,INCX)
REAL SX(1),SMAX
INTEGER I,INCX,IX,N}
procedure FUNC_ISAMAX(var RESULT_:integer;var N:integer;var SX:TVecReal;var INCX:integer);

{
INTEGER FUNCTION IZAMAX(N,ZX,INCX)
DOUBLE COMPLEX ZX(*)
DOUBLE PRECISION SMAX
INTEGER I,INCX,IX,N}
procedure FUNC_IZAMAX(var RESULT_:integer;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer);

{
REAL FUNCTION SASUM(N,SX,INCX)
REAL SX(1),STEMP
INTEGER I,INCX,IX,M,MP1,N}
procedure FUNC_SASUM(var RESULT_:real;var N:integer;var SX:TVecReal;var INCX:integer);

{
SUBROUTINE SAXPY(N,SA,SX,INCX,SY,INCY)
REAL SX(1),SY(1),SA
INTEGER I,INCX,INCY,IX,IY,M,MP1,N}
procedure SAXPY(var N:integer;var SA:real;var SX:TVecReal;var INCX:integer;var SY:TVecReal;var INCY:integer);cdecl; external 'arpacklib.dll';

{
REAL FUNCTION SCASUM(N,CX,INCX)
COMPLEX CX(*)
REAL STEMP
INTEGER I,INCX,N,NINCX}
procedure FUNC_SCASUM(var RESULT_:real;var N:integer;var CX:TVecComplex;var INCX:integer);

{
REAL             FUNCTION SCNRM2( N, X, INCX )
INTEGER                           INCX, N
COMPLEX                           X( * )}
procedure FUNC_SCNRM2(var RESULT_:real;var N:integer;var X:TVecComplex;var INCX:integer);

{
SUBROUTINE SCOPY(N,SX,INCX,SY,INCY)
REAL SX(1),SY(1)
INTEGER I,INCX,INCY,IX,IY,M,MP1,N}
procedure SCOPY(var N:integer;var SX:TVecReal;var INCX:integer;var SY:TVecReal;var INCY:integer);cdecl; external 'arpacklib.dll';

{
REAL FUNCTION SDOT(N,SX,INCX,SY,INCY)
REAL SX(1),SY(1),STEMP
INTEGER I,INCX,INCY,IX,IY,M,MP1,N}
procedure FUNC_SDOT(var RESULT_:real;var N:integer;var SX:TVecReal;var INCX:integer;var SY:TVecReal;var INCY:integer);

{
SUBROUTINE SGBMV ( TRANS, M, N, KL, KU, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
REAL               ALPHA, BETA
INTEGER            INCX, INCY, KL, KU, LDA, M, N
charFACTER*1        TRANS
REAL               A( LDA, * ), X( * ), Y( * )}
procedure SGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;var BETA:real;var Y:TVecReal;var INCY:integer);

{
SUBROUTINE SGEMM ( TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB,                   BETA, C, LDC )
charFACTER*1        TRANSA, TRANSB
INTEGER            M, N, K, LDA, LDB, LDC
REAL               ALPHA, BETA
REAL               A( LDA, * ), B( LDB, * ), C( LDC, * )}
procedure SGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer;var BETA:real;var C:TMatReal;var LDC:integer);

{
SUBROUTINE SGEMV ( TRANS, M, N, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
REAL               ALPHA, BETA
INTEGER            INCX, INCY, LDA, M, N
charFACTER*1        TRANS
REAL               A( LDA, * ), X( * ), Y( * )}
procedure SGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;var BETA:real;var Y:TVecReal;var INCY:integer);

{
SUBROUTINE SGER  ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
REAL               ALPHA
INTEGER            INCX, INCY, LDA, M, N
REAL               A( LDA, * ), X( * ), Y( * )}
procedure SGER(var M:integer;var N:integer;var ALPHA:real;var X:TVecReal;var INCX:integer;var Y:TVecReal;var INCY:integer;var A:TMatReal;var LDA:integer);cdecl; external 'arpacklib.dll';

{
REAL FUNCTION SNRM2 ( N, SX, INCX)
INTEGER I, INCX, IX, J, N, NEXT
REAL   SX(1),  CUTLO, CUTHI, HITEST, SUM, XMAX, ZERO, ONE}
procedure FUNC_SNRM2(var RESULT_:real;var N:integer;var SX:TVecReal;var INCX:integer);

{
SUBROUTINE SROT (N,SX,INCX,SY,INCY,C,S)
REAL SX(1),SY(1),STEMP,C,S
INTEGER I,INCX,INCY,IX,IY,N}
procedure SROT(var N:integer;var SX:TVecReal;var INCX:integer;var SY:TVecReal;var INCY:integer;var C:real;var S:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SROTG(SA,SB,C,S)
REAL SA,SB,C,S,ROE,SCALE,R,Z}
procedure SROTG(var SA:real;var SB:real;var C:real;var S:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SSCAL(N,SA,SX,INCX)
REAL SA,SX(1)
INTEGER I,INCX,IX,M,MP1,N}
procedure SSCAL(var N:integer;var SA:real;var SX:TVecReal;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SSWAP (N,SX,INCX,SY,INCY)
REAL SX(1),SY(1),STEMP
INTEGER I,INCX,INCY,IX,IY,M,MP1,N}
procedure SSWAP(var N:integer;var SX:TVecReal;var INCX:integer;var SY:TVecReal;var INCY:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SSYMV ( UPLO, N, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
REAL               ALPHA, BETA
INTEGER            INCX, INCY, LDA, N
charFACTER*1        UPLO
REAL               A( LDA, * ), X( * ), Y( * )}
procedure SSYMV(var UPLO:charF;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;var BETA:real;var Y:TVecReal;var INCY:integer);

{
SUBROUTINE SSYR2 ( UPLO, N, ALPHA, X, INCX, Y, INCY, A, LDA )
REAL               ALPHA
INTEGER            INCX, INCY, LDA, N
charFACTER*1        UPLO
REAL               A( LDA, * ), X( * ), Y( * )}
procedure SSYR2(var UPLO:charF;var N:integer;var ALPHA:real;var X:TVecReal;var INCX:integer;var Y:TVecReal;var INCY:integer;var A:TMatReal;var LDA:integer);

{
SUBROUTINE STBSV ( UPLO, TRANS, DIAG, N, K, A, LDA, X, INCX )
INTEGER            INCX, K, LDA, N
charFACTER*1        DIAG, TRANS, UPLO
REAL               A( LDA, * ), X( * )}
procedure STBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer);

{
SUBROUTINE STRMM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,                   B, LDB )
charFACTER*1        SIDE, UPLO, TRANSA, DIAG
INTEGER            M, N, LDA, LDB
REAL               ALPHA
REAL               A( LDA, * ), B( LDB, * )}
procedure STRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer);

{
SUBROUTINE STRSM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,                   B, LDB )
charFACTER*1        SIDE, UPLO, TRANSA, DIAG
INTEGER            M, N, LDA, LDB
REAL               ALPHA
REAL               A( LDA, * ), B( LDB, * )}
procedure STRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer);

{
SUBROUTINE ZAXPY(N,ZA,ZX,INCX,ZY,INCY)
DOUBLE COMPLEX ZX(*),ZY(*),ZA
INTEGER I,INCX,INCY,IX,IY,N}
procedure ZAXPY(var N:integer;var ZA:TDoubleComplex;var ZX:TVecDoubleComplex;var INCX:integer;var ZY:TVecDoubleComplex;var INCY:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  ZCOPY(N,ZX,INCX,ZY,INCY)
DOUBLE COMPLEX ZX(*),ZY(*)
INTEGER I,INCX,INCY,IX,IY,N}
procedure ZCOPY(var N:integer;var ZX:TVecDoubleComplex;var INCX:integer;var ZY:TVecDoubleComplex;var INCY:integer);cdecl; external 'arpacklib.dll';

{
DOUBLE COMPLEX FUNCTION ZDOTC(N,ZX,INCX,ZY,INCY)
DOUBLE COMPLEX ZX(*),ZY(*),ZTEMP
INTEGER I,INCX,INCY,IX,IY,N}
procedure FUNC_ZDOTC(var RESULT_:TDoubleComplex;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer;var ZY:TVecDoubleComplex;var INCY:integer);

{
DOUBLE COMPLEX FUNCTION ZDOTU(N,ZX,INCX,ZY,INCY)
DOUBLE COMPLEX ZX(*),ZY(*),ZTEMP
INTEGER I,INCX,INCY,IX,IY,N}
procedure FUNC_ZDOTU(var RESULT_:TDoubleComplex;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer;var ZY:TVecDoubleComplex;var INCY:integer);

{
SUBROUTINE  ZDSCAL(N,DA,ZX,INCX)
DOUBLE COMPLEX ZX(*)
DOUBLE PRECISION DA
INTEGER I,INCX,IX,N}
procedure ZDSCAL(var N:integer;var DA:double;var ZX:TVecDoubleComplex;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZGBMV ( TRANS, M, N, KL, KU, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
COMPLEX*16         ALPHA, BETA
INTEGER            INCX, INCY, KL, KU, LDA, M, N
charFACTER*1        TRANS
COMPLEX*16         A( LDA, * ), X( * ), Y( * )}
procedure ZGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TDoubleComplex;var Y:TVecComplex;var INCY:integer);

{
SUBROUTINE ZGEMM ( TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB,                   BETA, C, LDC )
charFACTER*1        TRANSA, TRANSB
INTEGER            M, N, K, LDA, LDB, LDC
COMPLEX*16         ALPHA, BETA
COMPLEX*16         A( LDA, * ), B( LDB, * ), C( LDC, * )}
procedure ZGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var BETA:TDoubleComplex;var C:TMatComplex;var LDC:integer);

{
SUBROUTINE ZGEMV ( TRANS, M, N, ALPHA, A, LDA, X, INCX,                   BETA, Y, INCY )
COMPLEX*16         ALPHA, BETA
INTEGER            INCX, INCY, LDA, M, N
charFACTER*1        TRANS
COMPLEX*16         A( LDA, * ), X( * ), Y( * )}
procedure ZGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TDoubleComplex;var Y:TVecComplex;var INCY:integer);

{
SUBROUTINE ZGERC ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
COMPLEX*16         ALPHA
INTEGER            INCX, INCY, LDA, M, N
COMPLEX*16         A( LDA, * ), X( * ), Y( * )}
procedure ZGERC(var M:integer;var N:integer;var ALPHA:TDoubleComplex;var X:TVecComplex;var INCX:integer;var Y:TVecComplex;var INCY:integer;var A:TMatComplex;var LDA:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZGERU ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
COMPLEX*16         ALPHA
INTEGER            INCX, INCY, LDA, M, N
COMPLEX*16         A( LDA, * ), X( * ), Y( * )}
procedure ZGERU(var M:integer;var N:integer;var ALPHA:TDoubleComplex;var X:TVecComplex;var INCX:integer;var Y:TVecComplex;var INCY:integer;var A:TMatComplex;var LDA:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  ZSCAL(N,ZA,ZX,INCX)
DOUBLE COMPLEX ZA,ZX(*)
INTEGER I,INCX,IX,N}
procedure ZSCAL(var N:integer;var ZA:TDoubleComplex;var ZX:TVecDoubleComplex;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE  ZSWAP (N,ZX,INCX,ZY,INCY)
DOUBLE COMPLEX ZX(*),ZY(*),ZTEMP
INTEGER I,INCX,INCY,IX,IY,N}
procedure ZSWAP(var N:integer;var ZX:TVecDoubleComplex;var INCX:integer;var ZY:TVecDoubleComplex;var INCY:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZTBSV ( UPLO, TRANS, DIAG, N, K, A, LDA, X, INCX )
INTEGER            INCX, K, LDA, N
charFACTER*1        DIAG, TRANS, UPLO
COMPLEX*16         A( LDA, * ), X( * )}
procedure ZTBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer);

{
SUBROUTINE ZTRMM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,                   B, LDB )
charFACTER*1        SIDE, UPLO, TRANSA, DIAG
INTEGER            M, N, LDA, LDB
COMPLEX*16         ALPHA
COMPLEX*16         A( LDA, * ), B( LDB, * )}
procedure ZTRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);

{
SUBROUTINE ZTRSM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,                   B, LDB )
charFACTER*1        SIDE, UPLO, TRANSA, DIAG
INTEGER            M, N, LDA, LDB
COMPLEX*16         ALPHA
COMPLEX*16         A( LDA, * ), B( LDB, * )}
procedure ZTRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);

{
SUBROUTINE ZTRSV ( UPLO, TRANS, DIAG, N, A, LDA, X, INCX )
INTEGER            INCX, LDA, N
charFACTER*1        DIAG, TRANS, UPLO
COMPLEX*16         A( LDA, * ), X( * )}
procedure ZTRSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer);



// FICHIERS DE : C:\DEV\FORTRAN\ARPACK\LAPACK\

{
SUBROUTINE CGBTF2( M, N, KL, KU, AB, LDAB, IPIV, INFO )
INTEGER            INFO, KL, KU, LDAB, M, N
INTEGER            IPIV( * )
COMPLEX            AB( LDAB, * )}
procedure CGBTF2(var M:integer;var N:integer;var KL:integer;var KU:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CGBTRF( M, N, KL, KU, AB, LDAB, IPIV, INFO )
INTEGER            INFO, KL, KU, LDAB, M, N
INTEGER            IPIV( * )
COMPLEX            AB( LDAB, * )}
procedure CGBTRF(var M:integer;var N:integer;var KL:integer;var KU:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CGBTRS( TRANS, N, KL, KU, NRHS, AB, LDAB, IPIV, B, LDB,                   INFO )
charFACTER          TRANS
INTEGER            INFO, KL, KU, LDAB, LDB, N, NRHS
INTEGER            IPIV( * )
COMPLEX            AB( LDAB, * ), B( LDB, * )}
procedure CGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer);

{
SUBROUTINE CGEQR2( M, N, A, LDA, TAU, WORK, INFO )
INTEGER            INFO, LDA, M, N
COMPLEX            A( LDA, * ), TAU( * ), WORK( * )}
procedure CGEQR2(var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var TAU:TVecComplex;var WORK:TVecComplex;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CGTTRF( N, DL, D, DU, DU2, IPIV, INFO )
INTEGER            INFO, N
INTEGER            IPIV( * )
COMPLEX            D( * ), DL( * ), DU( * ), DU2( * )}
procedure CGTTRF(var N:integer;var DL:TVecComplex;var D:TVecComplex;var DU:TVecComplex;var DU2:TVecComplex;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CGTTRS( TRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB,                   INFO )
charFACTER          TRANS
INTEGER            INFO, LDB, N, NRHS
INTEGER            IPIV( * )
COMPLEX            B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )}
procedure CGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecComplex;var D:TVecComplex;var DU:TVecComplex;var DU2:TVecComplex;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer);

{
SUBROUTINE CLACGV( N, X, INCX )
INTEGER            INCX, N
COMPLEX            X( * )}
procedure CLACGV(var N:integer;var X:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CLACON( N, V, X, EST, KASE )
INTEGER            KASE, N
REAL               EST
COMPLEX            V( N ), X( N )}
procedure CLACON(var N:integer;var V:TVecComplex;var X:TVecComplex;var EST:real;var KASE:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CLACPY( UPLO, M, N, A, LDA, B, LDB )
charFACTER          UPLO
INTEGER            LDA, LDB, M, N
COMPLEX            A( LDA, * ), B( LDB, * )}
procedure CLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);

{
COMPLEX FUNCTION CLADIV( X, Y )
COMPLEX            X, Y}
procedure FUNC_CLADIV(var RESULT_:TComplex;var X:TComplex;var Y:TComplex);

{
SUBROUTINE CLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, W, ILOZ,                   IHIZ, Z, LDZ, INFO )
LOGICAL            WANTT, WANTZ
INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
COMPLEX            H( LDH, * ), W( * ), Z( LDZ, * )}
procedure CLAHQR(var WANTT:longbool;var WANTZ:longbool;var N:integer;var ILO:integer;var IHI:integer;var H:TMatComplex;var LDH:integer;var W:TVecComplex;var ILOZ:integer;var IHIZ:integer;var Z:TMatComplex;var LDZ:integer;var INFO:integer);cdecl; external 'arpacklib.dll';

{
REAL             FUNCTION CLANGE( NORM, M, N, A, LDA, WORK )
charFACTER          NORM
INTEGER            LDA, M, N
REAL               WORK( * )
COMPLEX            A( LDA, * )}
procedure FUNC_CLANGE(var RESULT_:real;var NORM:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecReal);

{
REAL             FUNCTION CLANHS( NORM, N, A, LDA, WORK )
charFACTER          NORM
INTEGER            LDA, N
REAL               WORK( * )
COMPLEX            A( LDA, * )}
procedure FUNC_CLANHS(var RESULT_:real;var NORM:charF;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecReal);

{
SUBROUTINE CLARF( SIDE, M, N, V, INCV, TAU, C, LDC, WORK )
charFACTER          SIDE
INTEGER            INCV, LDC, M, N
COMPLEX            TAU
COMPLEX            C( LDC, * ), V( * ), WORK( * )}
procedure CLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecComplex;var INCV:integer;var TAU:TComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex);

{
SUBROUTINE CLARFG( N, ALPHA, X, INCX, TAU )
INTEGER            INCX, N
COMPLEX            ALPHA, TAU
COMPLEX            X( * )}
procedure CLARFG(var N:integer;var ALPHA:TComplex;var X:TVecComplex;var INCX:integer;var TAU:TComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CLARNV( IDIST, ISEED, N, X )
INTEGER            IDIST, N
INTEGER            ISEED( 4 )
COMPLEX            X( * )}
procedure CLARNV(var IDIST:integer;var ISEED:integer;var N:integer;var X:TVecComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CLARTG( F, G, CS, SN, R )
REAL               CS
COMPLEX            F, G, R, SN}
procedure CLARTG(var F:TComplex;var G:TComplex;var CS:real;var SN:TComplex;var R:TComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CLASCL( TYPE, KL, KU, CFROM, CTO, M, N, A, LDA, INFO )
charFACTER          TYPE
INTEGER            INFO, KL, KU, LDA, M, N
REAL               CFROM, CTO
COMPLEX            A( LDA, * )}
procedure CLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:real;var CTO:real;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var INFO:integer);

{
SUBROUTINE CLASET( UPLO, M, N, ALPHA, BETA, A, LDA )
charFACTER          UPLO
INTEGER            LDA, M, N
COMPLEX            ALPHA, BETA
COMPLEX            A( LDA, * )}
procedure CLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:TComplex;var BETA:TComplex;var A:TMatComplex;var LDA:integer);

{
SUBROUTINE CLASSQ( N, X, INCX, SCALE, SUMSQ )
INTEGER            INCX, N
REAL               SCALE, SUMSQ
COMPLEX            X( * )}
procedure CLASSQ(var N:integer;var X:TVecComplex;var INCX:integer;var SCALE:real;var SUMSQ:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CLASWP( N, A, LDA, K1, K2, IPIV, INCX )
INTEGER            INCX, K1, K2, LDA, N
INTEGER            IPIV( * )
COMPLEX            A( LDA, * )}
procedure CLASWP(var N:integer;var A:TMatComplex;var LDA:integer;var K1:integer;var K2:integer;var IPIV:TVecInteger;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CLATRS( UPLO, TRANS, DIAG, NORMIN, N, A, LDA, X, SCALE,                   CNORM, INFO )
charFACTER          DIAG, NORMIN, TRANS, UPLO
INTEGER            INFO, LDA, N
REAL               SCALE
REAL               CNORM( * )
COMPLEX            A( LDA, * ), X( * )}
procedure CLATRS(var UPLO:charF;var TRANS:charF;var DIAG:charF;var NORMIN:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var SCALE:real;var CNORM:TVecReal;var INFO:integer);

{
REAL FUNCTION CMACH(JOB)
INTEGER JOB}
procedure FUNC_CMACH(var RESULT_:real;var JOB:integer);

{
SUBROUTINE CROT( N, CX, INCX, CY, INCY, C, S )
INTEGER            INCX, INCY, N
REAL               C
COMPLEX            S
COMPLEX            CX( * ), CY( * )}
procedure CROT(var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer;var C:real;var S:TComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CTREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,                   LDVR, MM, M, WORK, RWORK, INFO )
charFACTER          HOWMNY, SIDE
INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
LOGICAL            SELECT( * )
REAL               RWORK( * )
COMPLEX            T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),                   WORK( * )}
procedure CTREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var VL:TMatComplex;var LDVL:integer;var VR:TMatComplex;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecComplex;var RWORK:TVecReal;var INFO:integer);

{
SUBROUTINE CTREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, INFO )
charFACTER          COMPQ
INTEGER            IFST, ILST, INFO, LDQ, LDT, N
COMPLEX            Q( LDQ, * ), T( LDT, * )}
procedure CTREXC(var COMPQ:charF;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var IFST:integer;var ILST:integer;var INFO:integer);

{
SUBROUTINE CTRSEN( JOB, COMPQ, SELECT, N, T, LDT, Q, LDQ, W, M, S,                   SEP, WORK, LWORK, INFO )
charFACTER          COMPQ, JOB
INTEGER            INFO, LDQ, LDT, LWORK, M, N
REAL               S, SEP
LOGICAL            SELECT( * )
COMPLEX            Q( LDQ, * ), T( LDT, * ), W( * ), WORK( * )}
procedure CTRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var W:TVecComplex;var M:integer;var S:real;var SEP:real;var WORK:TVecComplex;var LWORK:integer;var INFO:integer);

{
SUBROUTINE CTRSYL( TRANA, TRANB, ISGN, M, N, A, LDA, B, LDB, C,                   LDC, SCALE, INFO )
charFACTER          TRANA, TRANB
INTEGER            INFO, ISGN, LDA, LDB, LDC, M, N
REAL               SCALE
COMPLEX            A( LDA, * ), B( LDB, * ), C( LDC, * )}
procedure CTRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var C:TMatComplex;var LDC:integer;var SCALE:real;var INFO:integer);

{
SUBROUTINE CUNM2R( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,                   WORK, INFO )
charFACTER          SIDE, TRANS
INTEGER            INFO, K, LDA, LDC, M, N
COMPLEX            A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )}
procedure CUNM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var TAU:TVecComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex;var INFO:integer);

{
SUBROUTINE DGBTF2( M, N, KL, KU, AB, LDAB, IPIV, INFO )
INTEGER            INFO, KL, KU, LDAB, M, N
INTEGER            IPIV( * )
DOUBLE PRECISION   AB( LDAB, * )}
procedure DGBTF2(var M:integer;var N:integer;var KL:integer;var KU:integer;var AB:TMatDouble;var LDAB:integer;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DGBTRF( M, N, KL, KU, AB, LDAB, IPIV, INFO )
INTEGER            INFO, KL, KU, LDAB, M, N
INTEGER            IPIV( * )
DOUBLE PRECISION   AB( LDAB, * )}
procedure DGBTRF(var M:integer;var N:integer;var KL:integer;var KU:integer;var AB:TMatDouble;var LDAB:integer;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DGBTRS( TRANS, N, KL, KU, NRHS, AB, LDAB, IPIV, B, LDB,                   INFO )
charFACTER          TRANS
INTEGER            INFO, KL, KU, LDAB, LDB, N, NRHS
INTEGER            IPIV( * )
DOUBLE PRECISION   AB( LDAB, * ), B( LDB, * )}
procedure DGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatDouble;var LDAB:integer;var IPIV:TVecInteger;var B:TMatDouble;var LDB:integer;var INFO:integer);

{
SUBROUTINE DGEQR2( M, N, A, LDA, TAU, WORK, INFO )
INTEGER            INFO, LDA, M, N
DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )}
procedure DGEQR2(var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var TAU:TVecDouble;var WORK:TVecDouble;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DGTTRF( N, DL, D, DU, DU2, IPIV, INFO )
INTEGER            INFO, N
INTEGER            IPIV( * )
DOUBLE PRECISION   D( * ), DL( * ), DU( * ), DU2( * )}
procedure DGTTRF(var N:integer;var DL:TVecDouble;var D:TVecDouble;var DU:TVecDouble;var DU2:TVecDouble;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DGTTRS( TRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB,                   INFO )
charFACTER          TRANS
INTEGER            INFO, LDB, N, NRHS
INTEGER            IPIV( * )
DOUBLE PRECISION   B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )}
procedure DGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecDouble;var D:TVecDouble;var DU:TVecDouble;var DU2:TVecDouble;var IPIV:TVecInteger;var B:TMatDouble;var LDB:integer;var INFO:integer);

{
SUBROUTINE DLABAD( SMALL, LARGE )
DOUBLE PRECISION   LARGE, SMALL}
procedure DLABAD(var SMALL:double;var LARGE:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLACON( N, V, X, ISGN, EST, KASE )
INTEGER            KASE, N
DOUBLE PRECISION   EST
INTEGER            ISGN( * )
DOUBLE PRECISION   V( * ), X( * )}
procedure DLACON(var N:integer;var V:TVecDouble;var X:TVecDouble;var ISGN:TVecInteger;var EST:double;var KASE:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLACPY( UPLO, M, N, A, LDA, B, LDB )
charFACTER          UPLO
INTEGER            LDA, LDB, M, N
DOUBLE PRECISION   A( LDA, * ), B( LDB, * )}
procedure DLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer);

{
SUBROUTINE DLADIV( A, B, C, D, P, Q )
DOUBLE PRECISION   A, B, C, D, P, Q}
procedure DLADIV(var A:double;var B:double;var C:double;var D:double;var P:double;var Q:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLAE2( A, B, C, RT1, RT2 )
DOUBLE PRECISION   A, B, C, RT1, RT2}
procedure DLAE2(var A:double;var B:double;var C:double;var RT1:double;var RT2:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLAEV2( A, B, C, RT1, RT2, CS1, SN1 )
DOUBLE PRECISION   A, B, C, CS1, RT1, RT2, SN1}
procedure DLAEV2(var A:double;var B:double;var C:double;var RT1:double;var RT2:double;var CS1:double;var SN1:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLAEXC( WANTQ, N, T, LDT, Q, LDQ, J1, N1, N2, WORK,                   INFO )
LOGICAL            WANTQ
INTEGER            INFO, J1, LDQ, LDT, N, N1, N2
DOUBLE PRECISION   Q( LDQ, * ), T( LDT, * ), WORK( * )}
procedure DLAEXC(var WANTQ:longbool;var N:integer;var T:TMatDouble;var LDT:integer;var Q:TMatDouble;var LDQ:integer;var J1:integer;var N1:integer;var N2:integer;var WORK:TVecDouble;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLAGTM( TRANS, N, NRHS, ALPHA, DL, D, DU, X, LDX, BETA,                   B, LDB )
charFACTER          TRANS
INTEGER            LDB, LDX, N, NRHS
DOUBLE PRECISION   ALPHA, BETA
DOUBLE PRECISION   B( LDB, * ), D( * ), DL( * ), DU( * ),                   X( LDX, * )}
procedure DLAGTM(var TRANS:charF;var N:integer;var NRHS:integer;var ALPHA:double;var DL:TVecDouble;var D:TVecDouble;var DU:TVecDouble;var X:TMatDouble;var LDX:integer;var BETA:double;var B:TMatDouble;var LDB:integer);

{
SUBROUTINE DLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI,                   ILOZ, IHIZ, Z, LDZ, INFO )
LOGICAL            WANTT, WANTZ
INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
DOUBLE PRECISION   H( LDH, * ), WI( * ), WR( * ), Z( LDZ, * )}
procedure DLAHQR(var WANTT:longbool;var WANTZ:longbool;var N:integer;var ILO:integer;var IHI:integer;var H:TMatDouble;var LDH:integer;var WR:TVecDouble;var WI:TVecDouble;var ILOZ:integer;var IHIZ:integer;var Z:TMatDouble;var LDZ:integer;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLALN2( LTRANS, NA, NW, SMIN, CA, A, LDA, D1, D2, B,                   LDB, WR, WI, X, LDX, SCALE, XNORM, INFO )
LOGICAL            LTRANS
INTEGER            INFO, LDA, LDB, LDX, NA, NW
DOUBLE PRECISION   CA, D1, D2, SCALE, SMIN, WI, WR, XNORM
DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), X( LDX, * )}
procedure DLALN2(var LTRANS:longbool;var NA:integer;var NW:integer;var SMIN:double;var CA:double;var A:TMatDouble;var LDA:integer;var D1:double;var D2:double;var B:TMatDouble;var LDB:integer;var WR:double;var WI:double;var X:TMatDouble;var LDX:integer;var SCALE:double;var XNORM:double;var INFO:integer);cdecl; external 'arpacklib.dll';

{
DOUBLE PRECISION FUNCTION DLAMCH( CMACH )
charFACTER          CMACH}
procedure FUNC_DLAMCH(var RESULT_:double;var CMACH:charF);

{
DOUBLE PRECISION FUNCTION DLANGE( NORM, M, N, A, LDA, WORK )
charFACTER          NORM
INTEGER            LDA, M, N
DOUBLE PRECISION   A( LDA, * ), WORK( * )}
procedure FUNC_DLANGE(var RESULT_:double;var NORM:charF;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var WORK:TVecDouble);

{
DOUBLE PRECISION FUNCTION DLANHS( NORM, N, A, LDA, WORK )
charFACTER          NORM
INTEGER            LDA, N
DOUBLE PRECISION   A( LDA, * ), WORK( * )}
procedure FUNC_DLANHS(var RESULT_:double;var NORM:charF;var N:integer;var A:TMatDouble;var LDA:integer;var WORK:TVecDouble);

{
DOUBLE PRECISION FUNCTION DLANST( NORM, N, D, E )
charFACTER          NORM
INTEGER            N
DOUBLE PRECISION   D( * ), E( * )}
procedure FUNC_DLANST(var RESULT_:double;var NORM:charF;var N:integer;var D:TVecDouble;var E:TVecDouble);

{
SUBROUTINE DLANV2( A, B, C, D, RT1R, RT1I, RT2R, RT2I, CS, SN )
DOUBLE PRECISION   A, B, C, CS, D, RT1I, RT1R, RT2I, RT2R, SN}
procedure DLANV2(var A:double;var B:double;var C:double;var D:double;var RT1R:double;var RT1I:double;var RT2R:double;var RT2I:double;var CS:double;var SN:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLAPTM( N, NRHS, ALPHA, D, E, X, LDX, BETA, B, LDB )
INTEGER            LDB, LDX, N, NRHS
DOUBLE PRECISION   ALPHA, BETA
DOUBLE PRECISION   B( LDB, * ), D( * ), E( * ), X( LDX, * )}
procedure DLAPTM(var N:integer;var NRHS:integer;var ALPHA:double;var D:TVecDouble;var E:TVecDouble;var X:TMatDouble;var LDX:integer;var BETA:double;var B:TMatDouble;var LDB:integer);cdecl; external 'arpacklib.dll';

{
DOUBLE PRECISION FUNCTION DLAPY2( X, Y )
DOUBLE PRECISION   X, Y}
procedure FUNC_DLAPY2(var RESULT_:double;var X:double;var Y:double);

{
DOUBLE PRECISION FUNCTION DLAPY3( X, Y, Z )
DOUBLE PRECISION   X, Y, Z}
procedure FUNC_DLAPY3(var RESULT_:double;var X:double;var Y:double;var Z:double);

{
DOUBLE PRECISION FUNCTION DLARAN( ISEED )
INTEGER            ISEED( 4 )}
procedure FUNC_DLARAN(var RESULT_:double;var ISEED:integer);

{
SUBROUTINE DLARF( SIDE, M, N, V, INCV, TAU, C, LDC, WORK )
charFACTER          SIDE
INTEGER            INCV, LDC, M, N
DOUBLE PRECISION   TAU
DOUBLE PRECISION   C( LDC, * ), V( * ), WORK( * )}
procedure DLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecDouble;var INCV:integer;var TAU:double;var C:TMatDouble;var LDC:integer;var WORK:TVecDouble);

{
SUBROUTINE DLARFG( N, ALPHA, X, INCX, TAU )
INTEGER            INCX, N
DOUBLE PRECISION   ALPHA, TAU
DOUBLE PRECISION   X( * )}
procedure DLARFG(var N:integer;var ALPHA:double;var X:TVecDouble;var INCX:integer;var TAU:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLARFX( SIDE, M, N, V, TAU, C, LDC, WORK )
charFACTER          SIDE
INTEGER            LDC, M, N
DOUBLE PRECISION   TAU
DOUBLE PRECISION   C( LDC, * ), V( * ), WORK( * )}
procedure DLARFX(var SIDE:charF;var M:integer;var N:integer;var V:TVecDouble;var TAU:double;var C:TMatDouble;var LDC:integer;var WORK:TVecDouble);

{
DOUBLE PRECISION FUNCTION DLARND( IDIST, ISEED )
INTEGER            IDIST
INTEGER            ISEED( 4 )}
procedure FUNC_DLARND(var RESULT_:double;var IDIST:integer;var ISEED:integer);

{
SUBROUTINE DLARNV( IDIST, ISEED, N, X )
INTEGER            IDIST, N
INTEGER            ISEED( 4 )
DOUBLE PRECISION   X( * )}
procedure DLARNV(var IDIST:integer;var ISEED:integer;var N:integer;var X:TVecDouble);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLARTG( F, G, CS, SN, R )
DOUBLE PRECISION   CS, F, G, R, SN}
procedure DLARTG(var F:double;var G:double;var CS:double;var SN:double;var R:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLARUV( ISEED, N, X )
INTEGER            N
INTEGER            ISEED( 4 )
DOUBLE PRECISION   X( N )}
procedure DLARUV(var ISEED:integer;var N:integer;var X:TVecDouble);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLASCL( TYPE, KL, KU, CFROM, CTO, M, N, A, LDA, INFO )
charFACTER          TYPE
INTEGER            INFO, KL, KU, LDA, M, N
DOUBLE PRECISION   CFROM, CTO
DOUBLE PRECISION   A( LDA, * )}
procedure DLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:double;var CTO:double;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var INFO:integer);

{
SUBROUTINE DLASET( UPLO, M, N, ALPHA, BETA, A, LDA )
charFACTER          UPLO
INTEGER            LDA, M, N
DOUBLE PRECISION   ALPHA, BETA
DOUBLE PRECISION   A( LDA, * )}
procedure DLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:double;var BETA:double;var A:TMatDouble;var LDA:integer);

{
SUBROUTINE DLASR( SIDE, PIVOT, DIRECT, M, N, C, S, A, LDA )
charFACTER          DIRECT, PIVOT, SIDE
INTEGER            LDA, M, N
DOUBLE PRECISION   A( LDA, * ), C( * ), S( * )}
procedure DLASR(var SIDE:charF;var PIVOT:charF;var DIRECT:charF;var M:integer;var N:integer;var C:TVecDouble;var S:TVecDouble;var A:TMatDouble;var LDA:integer);

{
SUBROUTINE DLASRT( ID, N, D, INFO )
charFACTER          ID
INTEGER            INFO, N
DOUBLE PRECISION   D( * )}
procedure DLASRT(var ID:charF;var N:integer;var D:TVecDouble;var INFO:integer);

{
SUBROUTINE DLASSQ( N, X, INCX, SCALE, SUMSQ )
INTEGER            INCX, N
DOUBLE PRECISION   SCALE, SUMSQ
DOUBLE PRECISION   X( * )}
procedure DLASSQ(var N:integer;var X:TVecDouble;var INCX:integer;var SCALE:double;var SUMSQ:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLASWP( N, A, LDA, K1, K2, IPIV, INCX )
INTEGER            INCX, K1, K2, LDA, N
INTEGER            IPIV( * )
DOUBLE PRECISION   A( LDA, * )}
procedure DLASWP(var N:integer;var A:TMatDouble;var LDA:integer;var K1:integer;var K2:integer;var IPIV:TVecInteger;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DLASY2( LTRANL, LTRANR, ISGN, N1, N2, TL, LDTL, TR,                   LDTR, B, LDB, SCALE, X, LDX, XNORM, INFO )
LOGICAL            LTRANL, LTRANR
INTEGER            INFO, ISGN, LDB, LDTL, LDTR, LDX, N1, N2
DOUBLE PRECISION   SCALE, XNORM
DOUBLE PRECISION   B( LDB, * ), TL( LDTL, * ), TR( LDTR, * ),                   X( LDX, * )}
procedure DLASY2(var LTRANL:longbool;var LTRANR:longbool;var ISGN:integer;var N1:integer;var N2:integer;var TL:TMatDouble;var LDTL:integer;var TR:TMatDouble;var LDTR:integer;var B:TMatDouble;var LDB:integer;var SCALE:double;var X:TMatDouble;var LDX:integer;var XNORM:double;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DORM2R( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,                   WORK, INFO )
charFACTER          SIDE, TRANS
INTEGER            INFO, K, LDA, LDC, M, N
DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )}
procedure DORM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatDouble;var LDA:integer;var TAU:TVecDouble;var C:TMatDouble;var LDC:integer;var WORK:TVecDouble;var INFO:integer);

{
SUBROUTINE DPTTRF( N, D, E, INFO )
INTEGER            INFO, N
DOUBLE PRECISION   D( * ), E( * )}
procedure DPTTRF(var N:integer;var D:TVecDouble;var E:TVecDouble;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DPTTRS( N, NRHS, D, E, B, LDB, INFO )
INTEGER            INFO, LDB, N, NRHS
DOUBLE PRECISION   B( LDB, * ), D( * ), E( * )}
procedure DPTTRS(var N:integer;var NRHS:integer;var D:TVecDouble;var E:TVecDouble;var B:TMatDouble;var LDB:integer;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DSTEQR( COMPZ, N, D, E, Z, LDZ, WORK, INFO )
charFACTER          COMPZ
INTEGER            INFO, LDZ, N
DOUBLE PRECISION   D( * ), E( * ), WORK( * ), Z( LDZ, * )}
procedure DSTEQR(var COMPZ:charF;var N:integer;var D:TVecDouble;var E:TVecDouble;var Z:TMatDouble;var LDZ:integer;var WORK:TVecDouble;var INFO:integer);

{
SUBROUTINE DTREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,                   LDVR, MM, M, WORK, INFO )
charFACTER          HOWMNY, SIDE
INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
LOGICAL            SELECT( * )
DOUBLE PRECISION   T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),                   WORK( * )}
procedure DTREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatDouble;var LDT:integer;var VL:TMatDouble;var LDVL:integer;var VR:TMatDouble;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecDouble;var INFO:integer);

{
SUBROUTINE DTREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, WORK,                   INFO )
charFACTER          COMPQ
INTEGER            IFST, ILST, INFO, LDQ, LDT, N
DOUBLE PRECISION   Q( LDQ, * ), T( LDT, * ), WORK( * )}
procedure DTREXC(var COMPQ:charF;var N:integer;var T:TMatDouble;var LDT:integer;var Q:TMatDouble;var LDQ:integer;var IFST:integer;var ILST:integer;var WORK:TVecDouble;var INFO:integer);

{
SUBROUTINE DTRSEN( JOB, COMPQ, SELECT, N, T, LDT, Q, LDQ, WR, WI,                   M, S, SEP, WORK, LWORK, IWORK, LIWORK, INFO )
charFACTER          COMPQ, JOB
INTEGER            INFO, LDQ, LDT, LIWORK, LWORK, M, N
DOUBLE PRECISION   S, SEP
LOGICAL            SELECT( * )
INTEGER            IWORK( * )
DOUBLE PRECISION   Q( LDQ, * ), T( LDT, * ), WI( * ), WORK( * ),                   WR( * )}
procedure DTRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatDouble;var LDT:integer;var Q:TMatDouble;var LDQ:integer;var WR:TVecDouble;var WI:TVecDouble;var M:integer;var S:double;var SEP:double;var WORK:TVecDouble;var LWORK:integer;var IWORK:TVecInteger;var LIWORK:integer;var INFO:integer);

{
SUBROUTINE DTRSYL( TRANA, TRANB, ISGN, M, N, A, LDA, B, LDB, C,                   LDC, SCALE, INFO )
charFACTER          TRANA, TRANB
INTEGER            INFO, ISGN, LDA, LDB, LDC, M, N
DOUBLE PRECISION   SCALE
DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )}
procedure DTRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer;var C:TMatDouble;var LDC:integer;var SCALE:double;var INFO:integer);

{
DOUBLE PRECISION FUNCTION DZSUM1( N, CX, INCX )
INTEGER            INCX, N
COMPLEX*16         CX( * )}
procedure FUNC_DZSUM1(var RESULT_:double;var N:integer;var CX:TVecComplex;var INCX:integer);

{
INTEGER          FUNCTION ICMAX1( N, CX, INCX )
INTEGER            INCX, N
COMPLEX            CX( * )}
procedure FUNC_ICMAX1(var RESULT_:integer;var N:integer;var CX:TVecComplex;var INCX:integer);

{
INTEGER          FUNCTION ILAENV( ISPEC, NAME, OPTS, N1, N2, N3,                 N4 )
charFACTER*( 2147483647 )    NAME, OPTS
INTEGER            ISPEC, N1, N2, N3, N4}
procedure FUNC_ILAENV(var RESULT_:integer;var ISPEC:integer;var NAME:charF;var OPTS:charF;var N1:integer;var N2:integer;var N3:integer;var N4:integer);

{
INTEGER          FUNCTION IZMAX1( N, CX, INCX )
INTEGER            INCX, N
COMPLEX*16         CX( * )}
procedure FUNC_IZMAX1(var RESULT_:integer;var N:integer;var CX:TVecComplex;var INCX:integer);

{
LOGICAL          FUNCTION LSAME( CA, CB )
charFACTER          CA, CB}
procedure FUNC_LSAME(var RESULT_:longbool;var CA:charF;var CB:charF);

{
LOGICAL          FUNCTION LSAMEN( N, CA, CB )
charFACTER*( 2147483647 )    CA, CB
INTEGER            N}
procedure FUNC_LSAMEN(var RESULT_:longbool;var N:integer;var CA:charF;var CB:charF);

{
REAL             FUNCTION SCSUM1( N, CX, INCX )
INTEGER            INCX, N
COMPLEX            CX( * )}
procedure FUNC_SCSUM1(var RESULT_:real;var N:integer;var CX:TVecComplex;var INCX:integer);

{
SUBROUTINE SGBTF2( M, N, KL, KU, AB, LDAB, IPIV, INFO )
INTEGER            INFO, KL, KU, LDAB, M, N
INTEGER            IPIV( * )
REAL               AB( LDAB, * )}
procedure SGBTF2(var M:integer;var N:integer;var KL:integer;var KU:integer;var AB:TMatReal;var LDAB:integer;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SGBTRF( M, N, KL, KU, AB, LDAB, IPIV, INFO )
INTEGER            INFO, KL, KU, LDAB, M, N
INTEGER            IPIV( * )
REAL               AB( LDAB, * )}
procedure SGBTRF(var M:integer;var N:integer;var KL:integer;var KU:integer;var AB:TMatReal;var LDAB:integer;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SGBTRS( TRANS, N, KL, KU, NRHS, AB, LDAB, IPIV, B, LDB,                   INFO )
charFACTER          TRANS
INTEGER            INFO, KL, KU, LDAB, LDB, N, NRHS
INTEGER            IPIV( * )
REAL               AB( LDAB, * ), B( LDB, * )}
procedure SGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatReal;var LDAB:integer;var IPIV:TVecInteger;var B:TMatReal;var LDB:integer;var INFO:integer);

{
SUBROUTINE SGEQR2( M, N, A, LDA, TAU, WORK, INFO )
INTEGER            INFO, LDA, M, N
REAL               A( LDA, * ), TAU( * ), WORK( * )}
procedure SGEQR2(var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var TAU:TVecReal;var WORK:TVecReal;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SGTTRF( N, DL, D, DU, DU2, IPIV, INFO )
INTEGER            INFO, N
INTEGER            IPIV( * )
REAL               D( * ), DL( * ), DU( * ), DU2( * )}
procedure SGTTRF(var N:integer;var DL:TVecReal;var D:TVecReal;var DU:TVecReal;var DU2:TVecReal;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SGTTRS( TRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB,                   INFO )
charFACTER          TRANS
INTEGER            INFO, LDB, N, NRHS
INTEGER            IPIV( * )
REAL               B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )}
procedure SGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecReal;var D:TVecReal;var DU:TVecReal;var DU2:TVecReal;var IPIV:TVecInteger;var B:TMatReal;var LDB:integer;var INFO:integer);

{
SUBROUTINE SLABAD( SMALL, LARGE )
REAL               LARGE, SMALL}
procedure SLABAD(var SMALL:real;var LARGE:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLACON( N, V, X, ISGN, EST, KASE )
INTEGER            KASE, N
REAL               EST
INTEGER            ISGN( * )
REAL               V( * ), X( * )}
procedure SLACON(var N:integer;var V:TVecReal;var X:TVecReal;var ISGN:TVecInteger;var EST:real;var KASE:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLACPY( UPLO, M, N, A, LDA, B, LDB )
charFACTER          UPLO
INTEGER            LDA, LDB, M, N
REAL               A( LDA, * ), B( LDB, * )}
procedure SLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer);

{
SUBROUTINE SLADIV( A, B, C, D, P, Q )
REAL               A, B, C, D, P, Q}
procedure SLADIV(var A:real;var B:real;var C:real;var D:real;var P:real;var Q:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLAE2( A, B, C, RT1, RT2 )
REAL               A, B, C, RT1, RT2}
procedure SLAE2(var A:real;var B:real;var C:real;var RT1:real;var RT2:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLAEV2( A, B, C, RT1, RT2, CS1, SN1 )
REAL               A, B, C, CS1, RT1, RT2, SN1}
procedure SLAEV2(var A:real;var B:real;var C:real;var RT1:real;var RT2:real;var CS1:real;var SN1:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLAEXC( WANTQ, N, T, LDT, Q, LDQ, J1, N1, N2, WORK,                   INFO )
LOGICAL            WANTQ
INTEGER            INFO, J1, LDQ, LDT, N, N1, N2
REAL               Q( LDQ, * ), T( LDT, * ), WORK( * )}
procedure SLAEXC(var WANTQ:longbool;var N:integer;var T:TMatReal;var LDT:integer;var Q:TMatReal;var LDQ:integer;var J1:integer;var N1:integer;var N2:integer;var WORK:TVecReal;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLAGTM( TRANS, N, NRHS, ALPHA, DL, D, DU, X, LDX, BETA,                   B, LDB )
charFACTER          TRANS
INTEGER            LDB, LDX, N, NRHS
REAL               ALPHA, BETA
REAL               B( LDB, * ), D( * ), DL( * ), DU( * ),                   X( LDX, * )}
procedure SLAGTM(var TRANS:charF;var N:integer;var NRHS:integer;var ALPHA:real;var DL:TVecReal;var D:TVecReal;var DU:TVecReal;var X:TMatReal;var LDX:integer;var BETA:real;var B:TMatReal;var LDB:integer);

{
SUBROUTINE SLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI,                   ILOZ, IHIZ, Z, LDZ, INFO )
LOGICAL            WANTT, WANTZ
INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
REAL               H( LDH, * ), WI( * ), WR( * ), Z( LDZ, * )}
procedure SLAHQR(var WANTT:longbool;var WANTZ:longbool;var N:integer;var ILO:integer;var IHI:integer;var H:TMatReal;var LDH:integer;var WR:TVecReal;var WI:TVecReal;var ILOZ:integer;var IHIZ:integer;var Z:TMatReal;var LDZ:integer;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLALN2( LTRANS, NA, NW, SMIN, CA, A, LDA, D1, D2, B,                   LDB, WR, WI, X, LDX, SCALE, XNORM, INFO )
LOGICAL            LTRANS
INTEGER            INFO, LDA, LDB, LDX, NA, NW
REAL               CA, D1, D2, SCALE, SMIN, WI, WR, XNORM
REAL               A( LDA, * ), B( LDB, * ), X( LDX, * )}
procedure SLALN2(var LTRANS:longbool;var NA:integer;var NW:integer;var SMIN:real;var CA:real;var A:TMatReal;var LDA:integer;var D1:real;var D2:real;var B:TMatReal;var LDB:integer;var WR:real;var WI:real;var X:TMatReal;var LDX:integer;var SCALE:real;var XNORM:real;var INFO:integer);cdecl; external 'arpacklib.dll';

{
REAL             FUNCTION SLAMCH( CMACH )
charFACTER          CMACH}
procedure FUNC_SLAMCH(var RESULT_:real;var CMACH:charF);

{
REAL             FUNCTION SLANGE( NORM, M, N, A, LDA, WORK )
charFACTER          NORM
INTEGER            LDA, M, N
REAL               A( LDA, * ), WORK( * )}
procedure FUNC_SLANGE(var RESULT_:real;var NORM:charF;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var WORK:TVecReal);

{
REAL             FUNCTION SLANHS( NORM, N, A, LDA, WORK )
charFACTER          NORM
INTEGER            LDA, N
REAL               A( LDA, * ), WORK( * )}
procedure FUNC_SLANHS(var RESULT_:real;var NORM:charF;var N:integer;var A:TMatReal;var LDA:integer;var WORK:TVecReal);

{
REAL             FUNCTION SLANST( NORM, N, D, E )
charFACTER          NORM
INTEGER            N
REAL               D( * ), E( * )}
procedure FUNC_SLANST(var RESULT_:real;var NORM:charF;var N:integer;var D:TVecReal;var E:TVecReal);

{
SUBROUTINE SLANV2( A, B, C, D, RT1R, RT1I, RT2R, RT2I, CS, SN )
REAL               A, B, C, CS, D, RT1I, RT1R, RT2I, RT2R, SN}
procedure SLANV2(var A:real;var B:real;var C:real;var D:real;var RT1R:real;var RT1I:real;var RT2R:real;var RT2I:real;var CS:real;var SN:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLAPTM( N, NRHS, ALPHA, D, E, X, LDX, BETA, B, LDB )
INTEGER            LDB, LDX, N, NRHS
REAL               ALPHA, BETA
REAL               B( LDB, * ), D( * ), E( * ), X( LDX, * )}
procedure SLAPTM(var N:integer;var NRHS:integer;var ALPHA:real;var D:TVecReal;var E:TVecReal;var X:TMatReal;var LDX:integer;var BETA:real;var B:TMatReal;var LDB:integer);cdecl; external 'arpacklib.dll';

{
REAL             FUNCTION SLAPY2( X, Y )
REAL               X, Y}
procedure FUNC_SLAPY2(var RESULT_:real;var X:real;var Y:real);

{
REAL             FUNCTION SLAPY3( X, Y, Z )
REAL               X, Y, Z}
procedure FUNC_SLAPY3(var RESULT_:real;var X:real;var Y:real;var Z:real);

{
REAL FUNCTION SLARAN( ISEED )
INTEGER            ISEED( 4 )}
procedure FUNC_SLARAN(var RESULT_:real;var ISEED:integer);

{
SUBROUTINE SLARF( SIDE, M, N, V, INCV, TAU, C, LDC, WORK )
charFACTER          SIDE
INTEGER            INCV, LDC, M, N
REAL               TAU
REAL               C( LDC, * ), V( * ), WORK( * )}
procedure SLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecReal;var INCV:integer;var TAU:real;var C:TMatReal;var LDC:integer;var WORK:TVecReal);

{
SUBROUTINE SLARFG( N, ALPHA, X, INCX, TAU )
INTEGER            INCX, N
REAL               ALPHA, TAU
REAL               X( * )}
procedure SLARFG(var N:integer;var ALPHA:real;var X:TVecReal;var INCX:integer;var TAU:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLARFX( SIDE, M, N, V, TAU, C, LDC, WORK )
charFACTER          SIDE
INTEGER            LDC, M, N
REAL               TAU
REAL               C( LDC, * ), V( * ), WORK( * )}
procedure SLARFX(var SIDE:charF;var M:integer;var N:integer;var V:TVecReal;var TAU:real;var C:TMatReal;var LDC:integer;var WORK:TVecReal);

{
REAL             FUNCTION SLARND( IDIST, ISEED )
INTEGER            IDIST
INTEGER            ISEED( 4 )}
procedure FUNC_SLARND(var RESULT_:real;var IDIST:integer;var ISEED:integer);

{
SUBROUTINE SLARNV( IDIST, ISEED, N, X )
INTEGER            IDIST, N
INTEGER            ISEED( 4 )
REAL               X( * )}
procedure SLARNV(var IDIST:integer;var ISEED:integer;var N:integer;var X:TVecReal);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLARTG( F, G, CS, SN, R )
REAL               CS, F, G, R, SN}
procedure SLARTG(var F:real;var G:real;var CS:real;var SN:real;var R:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLARUV( ISEED, N, X )
INTEGER            N
INTEGER            ISEED( 4 )
REAL               X( N )}
procedure SLARUV(var ISEED:integer;var N:integer;var X:TVecReal);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLASCL( TYPE, KL, KU, CFROM, CTO, M, N, A, LDA, INFO )
charFACTER          TYPE
INTEGER            INFO, KL, KU, LDA, M, N
REAL               CFROM, CTO
REAL               A( LDA, * )}
procedure SLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:real;var CTO:real;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var INFO:integer);

{
SUBROUTINE SLASET( UPLO, M, N, ALPHA, BETA, A, LDA )
charFACTER          UPLO
INTEGER            LDA, M, N
REAL               ALPHA, BETA
REAL               A( LDA, * )}
procedure SLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:real;var BETA:real;var A:TMatReal;var LDA:integer);

{
SUBROUTINE SLASR( SIDE, PIVOT, DIRECT, M, N, C, S, A, LDA )
charFACTER          DIRECT, PIVOT, SIDE
INTEGER            LDA, M, N
REAL               A( LDA, * ), C( * ), S( * )}
procedure SLASR(var SIDE:charF;var PIVOT:charF;var DIRECT:charF;var M:integer;var N:integer;var C:TVecReal;var S:TVecReal;var A:TMatReal;var LDA:integer);

{
SUBROUTINE SLASRT( ID, N, D, INFO )
charFACTER          ID
INTEGER            INFO, N
REAL               D( * )}
procedure SLASRT(var ID:charF;var N:integer;var D:TVecReal;var INFO:integer);

{
SUBROUTINE SLASSQ( N, X, INCX, SCALE, SUMSQ )
INTEGER            INCX, N
REAL               SCALE, SUMSQ
REAL               X( * )}
procedure SLASSQ(var N:integer;var X:TVecReal;var INCX:integer;var SCALE:real;var SUMSQ:real);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLASWP( N, A, LDA, K1, K2, IPIV, INCX )
INTEGER            INCX, K1, K2, LDA, N
INTEGER            IPIV( * )
REAL               A( LDA, * )}
procedure SLASWP(var N:integer;var A:TMatReal;var LDA:integer;var K1:integer;var K2:integer;var IPIV:TVecInteger;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SLASY2( LTRANL, LTRANR, ISGN, N1, N2, TL, LDTL, TR,                   LDTR, B, LDB, SCALE, X, LDX, XNORM, INFO )
LOGICAL            LTRANL, LTRANR
INTEGER            INFO, ISGN, LDB, LDTL, LDTR, LDX, N1, N2
REAL               SCALE, XNORM
REAL               B( LDB, * ), TL( LDTL, * ), TR( LDTR, * ),                   X( LDX, * )}
procedure SLASY2(var LTRANL:longbool;var LTRANR:longbool;var ISGN:integer;var N1:integer;var N2:integer;var TL:TMatReal;var LDTL:integer;var TR:TMatReal;var LDTR:integer;var B:TMatReal;var LDB:integer;var SCALE:real;var X:TMatReal;var LDX:integer;var XNORM:real;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SORM2R( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,                   WORK, INFO )
charFACTER          SIDE, TRANS
INTEGER            INFO, K, LDA, LDC, M, N
REAL               A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )}
procedure SORM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatReal;var LDA:integer;var TAU:TVecReal;var C:TMatReal;var LDC:integer;var WORK:TVecReal;var INFO:integer);

{
SUBROUTINE SPTTRF( N, D, E, INFO )
INTEGER            INFO, N
REAL               D( * ), E( * )}
procedure SPTTRF(var N:integer;var D:TVecReal;var E:TVecReal;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SPTTRS( N, NRHS, D, E, B, LDB, INFO )
INTEGER            INFO, LDB, N, NRHS
REAL               B( LDB, * ), D( * ), E( * )}
procedure SPTTRS(var N:integer;var NRHS:integer;var D:TVecReal;var E:TVecReal;var B:TMatReal;var LDB:integer;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SSTEQR( COMPZ, N, D, E, Z, LDZ, WORK, INFO )
charFACTER          COMPZ
INTEGER            INFO, LDZ, N
REAL               D( * ), E( * ), WORK( * ), Z( LDZ, * )}
procedure SSTEQR(var COMPZ:charF;var N:integer;var D:TVecReal;var E:TVecReal;var Z:TMatReal;var LDZ:integer;var WORK:TVecReal;var INFO:integer);

{
SUBROUTINE STREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,                   LDVR, MM, M, WORK, INFO )
charFACTER          HOWMNY, SIDE
INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
LOGICAL            SELECT( * )
REAL               T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),                   WORK( * )}
procedure STREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatReal;var LDT:integer;var VL:TMatReal;var LDVL:integer;var VR:TMatReal;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecReal;var INFO:integer);

{
SUBROUTINE STREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, WORK,                   INFO )
charFACTER          COMPQ
INTEGER            IFST, ILST, INFO, LDQ, LDT, N
REAL               Q( LDQ, * ), T( LDT, * ), WORK( * )}
procedure STREXC(var COMPQ:charF;var N:integer;var T:TMatReal;var LDT:integer;var Q:TMatReal;var LDQ:integer;var IFST:integer;var ILST:integer;var WORK:TVecReal;var INFO:integer);

{
SUBROUTINE STRSEN( JOB, COMPQ, SELECT, N, T, LDT, Q, LDQ, WR, WI,                   M, S, SEP, WORK, LWORK, IWORK, LIWORK, INFO )
charFACTER          COMPQ, JOB
INTEGER            INFO, LDQ, LDT, LIWORK, LWORK, M, N
REAL               S, SEP
LOGICAL            SELECT( * )
INTEGER            IWORK( * )
REAL               Q( LDQ, * ), T( LDT, * ), WI( * ), WORK( * ),                   WR( * )}
procedure STRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatReal;var LDT:integer;var Q:TMatReal;var LDQ:integer;var WR:TVecReal;var WI:TVecReal;var M:integer;var S:real;var SEP:real;var WORK:TVecReal;var LWORK:integer;var IWORK:TVecInteger;var LIWORK:integer;var INFO:integer);

{
SUBROUTINE STRSYL( TRANA, TRANB, ISGN, M, N, A, LDA, B, LDB, C,                   LDC, SCALE, INFO )
charFACTER          TRANA, TRANB
INTEGER            INFO, ISGN, LDA, LDB, LDC, M, N
REAL               SCALE
REAL               A( LDA, * ), B( LDB, * ), C( LDC, * )}
procedure STRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer;var C:TMatReal;var LDC:integer;var SCALE:real;var INFO:integer);

{
SUBROUTINE XERBLA( SRNAME, INFO )
charFACTER*6        SRNAME
INTEGER            INFO}
procedure XERBLA(var SRNAME:charF6;var INFO:integer);

{
SUBROUTINE XLAENV( ISPEC, NVALUE )
INTEGER            ISPEC, NVALUE}
procedure XLAENV(var ISPEC:integer;var NVALUE:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZGBTF2( M, N, KL, KU, AB, LDAB, IPIV, INFO )
INTEGER            INFO, KL, KU, LDAB, M, N
INTEGER            IPIV( * )
COMPLEX*16         AB( LDAB, * )}
procedure ZGBTF2(var M:integer;var N:integer;var KL:integer;var KU:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZGBTRF( M, N, KL, KU, AB, LDAB, IPIV, INFO )
INTEGER            INFO, KL, KU, LDAB, M, N
INTEGER            IPIV( * )
COMPLEX*16         AB( LDAB, * )}
procedure ZGBTRF(var M:integer;var N:integer;var KL:integer;var KU:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZGBTRS( TRANS, N, KL, KU, NRHS, AB, LDAB, IPIV, B, LDB,                   INFO )
charFACTER          TRANS
INTEGER            INFO, KL, KU, LDAB, LDB, N, NRHS
INTEGER            IPIV( * )
COMPLEX*16         AB( LDAB, * ), B( LDB, * )}
procedure ZGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer);

{
SUBROUTINE ZGEQR2( M, N, A, LDA, TAU, WORK, INFO )
INTEGER            INFO, LDA, M, N
COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )}
procedure ZGEQR2(var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var TAU:TVecComplex;var WORK:TVecComplex;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZGTTRF( N, DL, D, DU, DU2, IPIV, INFO )
INTEGER            INFO, N
INTEGER            IPIV( * )
COMPLEX*16         D( * ), DL( * ), DU( * ), DU2( * )}
procedure ZGTTRF(var N:integer;var DL:TVecComplex;var D:TVecComplex;var DU:TVecComplex;var DU2:TVecComplex;var IPIV:TVecInteger;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZGTTRS( TRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB,                   INFO )
charFACTER          TRANS
INTEGER            INFO, LDB, N, NRHS
INTEGER            IPIV( * )
COMPLEX*16         B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )}
procedure ZGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecComplex;var D:TVecComplex;var DU:TVecComplex;var DU2:TVecComplex;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer);

{
SUBROUTINE ZLACGV( N, X, INCX )
INTEGER            INCX, N
COMPLEX*16         X( * )}
procedure ZLACGV(var N:integer;var X:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZLACON( N, V, X, EST, KASE )
INTEGER            KASE, N
DOUBLE PRECISION   EST
COMPLEX*16         V( N ), X( N )}
procedure ZLACON(var N:integer;var V:TVecComplex;var X:TVecComplex;var EST:double;var KASE:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZLACPY( UPLO, M, N, A, LDA, B, LDB )
charFACTER          UPLO
INTEGER            LDA, LDB, M, N
COMPLEX*16         A( LDA, * ), B( LDB, * )}
procedure ZLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);

{
DOUBLE COMPLEX   FUNCTION ZLADIV( X, Y )
COMPLEX*16         X, Y}
procedure FUNC_ZLADIV(var RESULT_:TDoubleComplex;var X:TDoubleComplex;var Y:TDoubleComplex);

{
SUBROUTINE ZLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, W, ILOZ,                   IHIZ, Z, LDZ, INFO )
LOGICAL            WANTT, WANTZ
INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
COMPLEX*16         H( LDH, * ), W( * ), Z( LDZ, * )}
procedure ZLAHQR(var WANTT:longbool;var WANTZ:longbool;var N:integer;var ILO:integer;var IHI:integer;var H:TMatComplex;var LDH:integer;var W:TVecComplex;var ILOZ:integer;var IHIZ:integer;var Z:TMatComplex;var LDZ:integer;var INFO:integer);cdecl; external 'arpacklib.dll';

{
DOUBLE PRECISION FUNCTION ZLANGE( NORM, M, N, A, LDA, WORK )
charFACTER          NORM
INTEGER            LDA, M, N
DOUBLE PRECISION   WORK( * )
COMPLEX*16         A( LDA, * )}
procedure FUNC_ZLANGE(var RESULT_:double;var NORM:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecDouble);

{
DOUBLE PRECISION FUNCTION ZLANHS( NORM, N, A, LDA, WORK )
charFACTER          NORM
INTEGER            LDA, N
DOUBLE PRECISION   WORK( * )
COMPLEX*16         A( LDA, * )}
procedure FUNC_ZLANHS(var RESULT_:double;var NORM:charF;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecDouble);

{
SUBROUTINE ZLARF( SIDE, M, N, V, INCV, TAU, C, LDC, WORK )
charFACTER          SIDE
INTEGER            INCV, LDC, M, N
COMPLEX*16         TAU
COMPLEX*16         C( LDC, * ), V( * ), WORK( * )}
procedure ZLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecComplex;var INCV:integer;var TAU:TDoubleComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex);

{
SUBROUTINE ZLARFG( N, ALPHA, X, INCX, TAU )
INTEGER            INCX, N
COMPLEX*16         ALPHA, TAU
COMPLEX*16         X( * )}
procedure ZLARFG(var N:integer;var ALPHA:TDoubleComplex;var X:TVecComplex;var INCX:integer;var TAU:TDoubleComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZLARNV( IDIST, ISEED, N, X )
INTEGER            IDIST, N
INTEGER            ISEED( 4 )
COMPLEX*16         X( * )}
procedure ZLARNV(var IDIST:integer;var ISEED:integer;var N:integer;var X:TVecComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZLARTG( F, G, CS, SN, R )
DOUBLE PRECISION   CS
COMPLEX*16         F, G, R, SN}
procedure ZLARTG(var F:TDoubleComplex;var G:TDoubleComplex;var CS:double;var SN:TDoubleComplex;var R:TDoubleComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZLASCL( TYPE, KL, KU, CFROM, CTO, M, N, A, LDA, INFO )
charFACTER          TYPE
INTEGER            INFO, KL, KU, LDA, M, N
DOUBLE PRECISION   CFROM, CTO
COMPLEX*16         A( LDA, * )}
procedure ZLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:double;var CTO:double;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var INFO:integer);

{
SUBROUTINE ZLASET( UPLO, M, N, ALPHA, BETA, A, LDA )
charFACTER          UPLO
INTEGER            LDA, M, N
COMPLEX*16         ALPHA, BETA
COMPLEX*16         A( LDA, * )}
procedure ZLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var BETA:TDoubleComplex;var A:TMatComplex;var LDA:integer);

{
SUBROUTINE ZLASSQ( N, X, INCX, SCALE, SUMSQ )
INTEGER            INCX, N
DOUBLE PRECISION   SCALE, SUMSQ
COMPLEX*16         X( * )}
procedure ZLASSQ(var N:integer;var X:TVecComplex;var INCX:integer;var SCALE:double;var SUMSQ:double);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZLASWP( N, A, LDA, K1, K2, IPIV, INCX )
INTEGER            INCX, K1, K2, LDA, N
INTEGER            IPIV( * )
COMPLEX*16         A( LDA, * )}
procedure ZLASWP(var N:integer;var A:TMatComplex;var LDA:integer;var K1:integer;var K2:integer;var IPIV:TVecInteger;var INCX:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZLATRS( UPLO, TRANS, DIAG, NORMIN, N, A, LDA, X, SCALE,                   CNORM, INFO )
charFACTER          DIAG, NORMIN, TRANS, UPLO
INTEGER            INFO, LDA, N
DOUBLE PRECISION   SCALE
DOUBLE PRECISION   CNORM( * )
COMPLEX*16         A( LDA, * ), X( * )}
procedure ZLATRS(var UPLO:charF;var TRANS:charF;var DIAG:charF;var NORMIN:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var SCALE:double;var CNORM:TVecDouble;var INFO:integer);

{
DOUBLE PRECISION FUNCTION ZMACH(JOB)
INTEGER JOB}
procedure FUNC_ZMACH(var RESULT_:double;var JOB:integer);

{
SUBROUTINE ZROT( N, CX, INCX, CY, INCY, C, S )
INTEGER            INCX, INCY, N
DOUBLE PRECISION   C
COMPLEX*16         S
COMPLEX*16         CX( * ), CY( * )}
procedure ZROT(var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer;var C:double;var S:TDoubleComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZTREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,                   LDVR, MM, M, WORK, RWORK, INFO )
charFACTER          HOWMNY, SIDE
INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
LOGICAL            SELECT( * )
DOUBLE PRECISION   RWORK( * )
COMPLEX*16         T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),                   WORK( * )}
procedure ZTREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var VL:TMatComplex;var LDVL:integer;var VR:TMatComplex;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecComplex;var RWORK:TVecDouble;var INFO:integer);

{
SUBROUTINE ZTREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, INFO )
charFACTER          COMPQ
INTEGER            IFST, ILST, INFO, LDQ, LDT, N
COMPLEX*16         Q( LDQ, * ), T( LDT, * )}
procedure ZTREXC(var COMPQ:charF;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var IFST:integer;var ILST:integer;var INFO:integer);

{
SUBROUTINE ZTRSEN( JOB, COMPQ, SELECT, N, T, LDT, Q, LDQ, W, M, S,                   SEP, WORK, LWORK, INFO )
charFACTER          COMPQ, JOB
INTEGER            INFO, LDQ, LDT, LWORK, M, N
DOUBLE PRECISION   S, SEP
LOGICAL            SELECT( * )
COMPLEX*16         Q( LDQ, * ), T( LDT, * ), W( * ), WORK( * )}
procedure ZTRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var W:TVecComplex;var M:integer;var S:double;var SEP:double;var WORK:TVecComplex;var LWORK:integer;var INFO:integer);

{
SUBROUTINE ZTRSYL( TRANA, TRANB, ISGN, M, N, A, LDA, B, LDB, C,                   LDC, SCALE, INFO )
charFACTER          TRANA, TRANB
INTEGER            INFO, ISGN, LDA, LDB, LDC, M, N
DOUBLE PRECISION   SCALE
COMPLEX*16         A( LDA, * ), B( LDB, * ), C( LDC, * )}
procedure ZTRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var C:TMatComplex;var LDC:integer;var SCALE:double;var INFO:integer);

{
SUBROUTINE ZUNM2R( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,                   WORK, INFO )
charFACTER          SIDE, TRANS
INTEGER            INFO, K, LDA, LDC, M, N
COMPLEX*16         A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )}
procedure ZUNM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var TAU:TVecComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex;var INFO:integer);



// FICHIERS DE : C:\DEV\FORTRAN\ARPACK\SRC\

{
SUBROUTINE CGETV0   ( IDO, BMAT, ITRY, INITV, N, J, V, LDV, RESID, RNORM,      IPNTR, WORKD, IERR )
INCLUDE
INCLUDE
charFACTER  BMAT*1
LOGICAL    INITV
INTEGER    IDO, IERR, ITRY, J, LDV, N
REAL           RNORM
INTEGER    IPNTR(3)
COMPLEX           RESID(N), V(LDV,J), WORKD(2*N)}
procedure CGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatComplex;var LDV:integer;var RESID:TVecComplex;var RNORM:real;var IPNTR:TVecInteger;var WORKD:TVecComplex;var IERR:integer);

{
SUBROUTINE CNAITR   (IDO, BMAT, N, K, NP, NB, RESID, RNORM, V, LDV, H, LDH,     IPNTR, WORKD, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT*1
INTEGER    IDO, INFO, K, LDH, LDV, N, NB, NP
REAL           RNORM
INTEGER    IPNTR(3)
COMPLEX           H(LDH,K+NP), RESID(N), V(LDV,K+NP), WORKD(3*N)}
procedure CNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecComplex;var RNORM:real;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecComplex;var INFO:integer);

{
SUBROUTINE CNAPPS   ( N, KEV, NP, SHIFT, V, LDV, H, LDH, RESID, Q, LDQ,      WORKL, WORKD )
INCLUDE
INCLUDE
INTEGER    KEV, LDH, LDQ, LDV, N, NP
COMPLEX           H(LDH,KEV+NP), RESID(N), SHIFT(NP),            V(LDV,KEV+NP), Q(LDQ,KEV+NP), WORKD(2*N), WORKL(KEV+NP)}
procedure CNAPPS(var N:integer;var KEV:integer;var NP:integer;var SHIFT:TVecComplex;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var RESID:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var WORKD:TVecComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CNAUP2   ( IDO, BMAT, N, WHICH, NEV, NP, TOL, RESID, MODE, IUPD,      ISHIFT, MXITER, V, LDV, H, LDH, RITZ, BOUNDS,      Q, LDQ, WORKL, IPNTR, WORKD, RWORK, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, ISHIFT, IUPD, MODE, LDH, LDQ, LDV, MXITER,           N, NEV, NP
REAL           TOL
INTEGER    IPNTR(13)
COMPLEX           BOUNDS(NEV+NP), H(LDH,NEV+NP), Q(LDQ,NEV+NP),            RESID(N), RITZ(NEV+NP),  V(LDV,NEV+NP),            WORKD(3*N), WORKL( (NEV+NP)*(NEV+NP+3) )
REAL           RWORK(NEV+NP)}
procedure CNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:real;var RESID:TVecComplex;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var IPNTR:TVecInteger;var WORKD:TVecComplex;var RWORK:TVecReal;var INFO:integer);

{
SUBROUTINE CNAUPD   ( IDO, BMAT, N, WHICH, NEV, TOL, RESID, NCV, V, LDV, IPARAM,      IPNTR, WORKD, WORKL, LWORKL, RWORK, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, LDV, LWORKL, N, NCV, NEV
REAL           TOL
INTEGER    IPARAM(11), IPNTR(14)
COMPLEX           RESID(N), V(LDV,NCV), WORKD(3*N), WORKL(LWORKL)
REAL           RWORK(NCV)}
procedure CNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecReal;var INFO:integer);

{
SUBROUTINE CNEIGH (RNORM, N, H, LDH, RITZ, BOUNDS,                   Q, LDQ, WORKL, RWORK, IERR)
INCLUDE
INCLUDE
INTEGER    IERR, N, LDH, LDQ
REAL           RNORM
COMPLEX           BOUNDS(N), H(LDH,N), Q(LDQ,N), RITZ(N),           WORKL(N*(N+3)) 
REAL           RWORK(N)}
procedure CNEIGH(var RNORM:real;var N:integer;var H:TMatComplex;var LDH:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var RWORK:TVecReal;var IERR:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE CNEUPD (RVEC, HOWMNY, SELECT, D, Z, LDZ, SIGMA,                   WORKEV, BMAT, N, WHICH, NEV, TOL,                    RESID, NCV, V, LDV, IPARAM, IPNTR, WORKD,                    WORKL, LWORKL, RWORK, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT, HOWMNY, WHICH*2
LOGICAL    RVEC
INTEGER    INFO, LDZ, LDV, LWORKL, N, NCV, NEV
COMPLEX           SIGMA
REAL           TOL
INTEGER    IPARAM(11), IPNTR(14)
LOGICAL    SELECT(NCV)
REAL           RWORK(NCV)
COMPLEX           D(NEV), RESID(N), V(LDV,NCV), Z(LDZ, NEV),            WORKD(3*N), WORKL(LWORKL), WORKEV(2*NCV)}
procedure CNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecComplex;var Z:TMatComplex;var LDZ:integer;var SIGMA:TComplex;var WORKEV:TVecComplex;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecReal;var INFO:integer);

{
SUBROUTINE CNGETS ( ISHIFT, WHICH, KEV, NP, RITZ, BOUNDS)
INCLUDE
INCLUDE
charFACTER*2 WHICH
INTEGER    ISHIFT, KEV, NP
COMPLEX           BOUNDS(KEV+NP), RITZ(KEV+NP)}
procedure CNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex);

{
SUBROUTINE CSORTC (WHICH, APPLY, N, X, Y)
charFACTER*2 WHICH
LOGICAL    APPLY
INTEGER    N
COMPLEX           X(0:N-1), Y(0:N-1)}
procedure CSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecComplex;var Y:TVecComplex);

{
SUBROUTINE CSTATN}
procedure CSTATN();cdecl; external 'arpacklib.dll';

{
SUBROUTINE DGETV0   ( IDO, BMAT, ITRY, INITV, N, J, V, LDV, RESID, RNORM,      IPNTR, WORKD, IERR )
INCLUDE
INCLUDE
charFACTER  BMAT*1
LOGICAL    INITV
INTEGER    IDO, IERR, ITRY, J, LDV, N
DOUBLE PRECISION           RNORM
INTEGER    IPNTR(3)
DOUBLE PRECISION           RESID(N), V(LDV,J), WORKD(2*N)}
procedure DGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatDouble;var LDV:integer;var RESID:TVecDouble;var RNORM:double;var IPNTR:TVecInteger;var WORKD:TVecDouble;var IERR:integer);

{
SUBROUTINE DLAQRB ( WANTT, N, ILO, IHI, H, LDH, WR, WI,                    Z, INFO )
LOGICAL    WANTT
INTEGER    IHI, ILO, INFO, LDH, N
DOUBLE PRECISION           H( LDH, * ), WI( * ), WR( * ), Z( * )}
procedure DLAQRB(var WANTT:longbool;var N:integer;var ILO:integer;var IHI:integer;var H:TMatDouble;var LDH:integer;var WR:TVecDouble;var WI:TVecDouble;var Z:TVecDouble;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DNAITR   (IDO, BMAT, N, K, NP, NB, RESID, RNORM, V, LDV, H, LDH,     IPNTR, WORKD, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT*1
INTEGER    IDO, INFO, K, LDH, LDV, N, NB, NP
DOUBLE PRECISION           RNORM
INTEGER    IPNTR(3)
DOUBLE PRECISION           H(LDH,K+NP), RESID(N), V(LDV,K+NP), WORKD(3*N)}
procedure DNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecDouble;var RNORM:double;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer);

{
SUBROUTINE DNAPPS   ( N, KEV, NP, SHIFTR, SHIFTI, V, LDV, H, LDH, RESID, Q, LDQ,      WORKL, WORKD )
INCLUDE
INCLUDE
INTEGER    KEV, LDH, LDQ, LDV, N, NP
DOUBLE PRECISION           H(LDH,KEV+NP), RESID(N), SHIFTI(NP), SHIFTR(NP),            V(LDV,KEV+NP), Q(LDQ,KEV+NP), WORKD(2*N), WORKL(KEV+NP)}
procedure DNAPPS(var N:integer;var KEV:integer;var NP:integer;var SHIFTR:TVecDouble;var SHIFTI:TVecDouble;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var RESID:TVecDouble;var Q:TMatDouble;var LDQ:integer;var WORKL:TVecDouble;var WORKD:TVecDouble);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DNAUP2   ( IDO, BMAT, N, WHICH, NEV, NP, TOL, RESID, MODE, IUPD,      ISHIFT, MXITER, V, LDV, H, LDH, RITZR, RITZI, BOUNDS,      Q, LDQ, WORKL, IPNTR, WORKD, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, ISHIFT, IUPD, MODE, LDH, LDQ, LDV, MXITER,           N, NEV, NP
DOUBLE PRECISION           TOL
INTEGER    IPNTR(13)
DOUBLE PRECISION           BOUNDS(NEV+NP), H(LDH,NEV+NP), Q(LDQ,NEV+NP), RESID(N),           RITZI(NEV+NP), RITZR(NEV+NP), V(LDV,NEV+NP),            WORKD(3*N), WORKL( (NEV+NP)*(NEV+NP+3) )}
procedure DNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:double;var RESID:TVecDouble;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var RITZR:TVecDouble;var RITZI:TVecDouble;var BOUNDS:TVecDouble;var Q:TMatDouble;var LDQ:integer;var WORKL:TVecDouble;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer);

{
SUBROUTINE DNAUPD   ( IDO, BMAT, N, WHICH, NEV, TOL, RESID, NCV, V, LDV, IPARAM,      IPNTR, WORKD, WORKL, LWORKL, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, LDV, LWORKL, N, NCV, NEV
DOUBLE PRECISION           TOL
INTEGER    IPARAM(11), IPNTR(14)
DOUBLE PRECISION           RESID(N), V(LDV,NCV), WORKD(3*N), WORKL(LWORKL)}
procedure DNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer);

{
SUBROUTINE DNCONV (N, RITZR, RITZI, BOUNDS, TOL, NCONV)
INCLUDE
INCLUDE
INTEGER    N, NCONV
DOUBLE PRECISION           TOL
DOUBLE PRECISION           RITZR(N), RITZI(N), BOUNDS(N)}
procedure DNCONV(var N:integer;var RITZR:TVecDouble;var RITZI:TVecDouble;var BOUNDS:TVecDouble;var TOL:double;var NCONV:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DNEIGH (RNORM, N, H, LDH, RITZR, RITZI, BOUNDS,                   Q, LDQ, WORKL, IERR)
INCLUDE
INCLUDE
INTEGER    IERR, N, LDH, LDQ
DOUBLE PRECISION           RNORM
DOUBLE PRECISION           BOUNDS(N), H(LDH,N), Q(LDQ,N), RITZI(N), RITZR(N),           WORKL(N*(N+3))}
procedure DNEIGH(var RNORM:double;var N:integer;var H:TMatDouble;var LDH:integer;var RITZR:TVecDouble;var RITZI:TVecDouble;var BOUNDS:TVecDouble;var Q:TMatDouble;var LDQ:integer;var WORKL:TVecDouble;var IERR:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DNEUPD (RVEC, HOWMNY, SELECT, DR, DI, Z, LDZ, SIGMAR,                   SIGMAI, WORKEV, BMAT, N, WHICH, NEV, TOL,                    RESID, NCV, V, LDV, IPARAM, IPNTR, WORKD,                    WORKL, LWORKL, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT, HOWMNY, WHICH*2
LOGICAL    RVEC
INTEGER    INFO, LDZ, LDV, LWORKL, N, NCV, NEV
DOUBLE PRECISION           SIGMAR, SIGMAI, TOL
INTEGER    IPARAM(11), IPNTR(14)
LOGICAL    SELECT(NCV)
DOUBLE PRECISION           DR(NEV+1), DI(NEV+1), RESID(N), V(LDV,NCV), Z(LDZ,*),            WORKD(3*N), WORKL(LWORKL), WORKEV(3*NCV)}
procedure DNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var DR:TVecDouble;var DI:TVecDouble;var Z:TMatDouble;var LDZ:integer;var SIGMAR:double;var SIGMAI:double;var WORKEV:TVecDouble;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer);

{
SUBROUTINE DNGETS ( ISHIFT, WHICH, KEV, NP, RITZR, RITZI, BOUNDS,                    SHIFTR, SHIFTI )
INCLUDE
INCLUDE
charFACTER*2 WHICH
INTEGER    ISHIFT, KEV, NP
DOUBLE PRECISION           BOUNDS(KEV+NP), RITZR(KEV+NP), RITZI(KEV+NP),            SHIFTR(1), SHIFTI(1)}
procedure DNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZR:TVecDouble;var RITZI:TVecDouble;var BOUNDS:TVecDouble;var SHIFTR:TVecDouble;var SHIFTI:TVecDouble);

{
SUBROUTINE DSAITR   (IDO, BMAT, N, K, NP, MODE, RESID, RNORM, V, LDV, H, LDH,     IPNTR, WORKD, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT*1
INTEGER    IDO, INFO, K, LDH, LDV, N, MODE, NP
DOUBLE PRECISION           RNORM
INTEGER    IPNTR(3)
DOUBLE PRECISION           H(LDH,2), RESID(N), V(LDV,K+NP), WORKD(3*N)}
procedure DSAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var MODE:integer;var RESID:TVecDouble;var RNORM:double;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer);

{
SUBROUTINE DSAPPS   ( N, KEV, NP, SHIFT, V, LDV, H, LDH, RESID, Q, LDQ, WORKD )
INCLUDE
INCLUDE
INTEGER    KEV, LDH, LDQ, LDV, N, NP
DOUBLE PRECISION           H(LDH,2), Q(LDQ,KEV+NP), RESID(N), SHIFT(NP),            V(LDV,KEV+NP), WORKD(2*N)}
procedure DSAPPS(var N:integer;var KEV:integer;var NP:integer;var SHIFT:TVecDouble;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var RESID:TVecDouble;var Q:TMatDouble;var LDQ:integer;var WORKD:TVecDouble);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DSAUP2   ( IDO, BMAT, N, WHICH, NEV, NP, TOL, RESID, MODE, IUPD,      ISHIFT, MXITER, V, LDV, H, LDH, RITZ, BOUNDS,      Q, LDQ, WORKL, IPNTR, WORKD, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, ISHIFT, IUPD, LDH, LDQ, LDV, MXITER,           N, MODE, NEV, NP
DOUBLE PRECISION           TOL
INTEGER    IPNTR(3)
DOUBLE PRECISION           BOUNDS(NEV+NP), H(LDH,2), Q(LDQ,NEV+NP), RESID(N),            RITZ(NEV+NP), V(LDV,NEV+NP), WORKD(3*N),            WORKL(3*(NEV+NP))}
procedure DSAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:double;var RESID:TVecDouble;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var RITZ:TVecDouble;var BOUNDS:TVecDouble;var Q:TMatDouble;var LDQ:integer;var WORKL:TVecDouble;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer);

{
SUBROUTINE DSAUPD   ( IDO, BMAT, N, WHICH, NEV, TOL, RESID, NCV, V, LDV, IPARAM,      IPNTR, WORKD, WORKL, LWORKL, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, LDV, LWORKL, N, NCV, NEV
DOUBLE PRECISION           TOL
INTEGER    IPARAM(11), IPNTR(11)
DOUBLE PRECISION           RESID(N), V(LDV,NCV), WORKD(3*N), WORKL(LWORKL)}
procedure DSAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer);

{
SUBROUTINE DSCONV (N, RITZ, BOUNDS, TOL, NCONV)
INCLUDE
INCLUDE
INTEGER    N, NCONV
DOUBLE PRECISION           TOL
DOUBLE PRECISION           RITZ(N), BOUNDS(N)}
procedure DSCONV(var N:integer;var RITZ:TVecDouble;var BOUNDS:TVecDouble;var TOL:double;var NCONV:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DSEIGT   ( RNORM, N, H, LDH, EIG, BOUNDS, WORKL, IERR )
INCLUDE
INCLUDE
INTEGER    IERR, LDH, N
DOUBLE PRECISION           RNORM
DOUBLE PRECISION           EIG(N), BOUNDS(N), H(LDH,2), WORKL(3*N)}
procedure DSEIGT(var RNORM:double;var N:integer;var H:TMatDouble;var LDH:integer;var EIG:TVecDouble;var BOUNDS:TVecDouble;var WORKL:TVecDouble;var IERR:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE DSESRT (WHICH, APPLY, N, X, NA, A, LDA)
charFACTER*2 WHICH
LOGICAL    APPLY
INTEGER    LDA, N, NA
DOUBLE PRECISION           X(0:N-1), A(LDA, 0:N-1)}
procedure DSESRT(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecDouble;var NA:integer;var A:TMatDouble;var LDA:integer);

{
SUBROUTINE DSEUPD (RVEC, HOWMNY, SELECT, D, Z, LDZ, SIGMA, BMAT,                   N, WHICH, NEV, TOL, RESID, NCV, V, LDV, IPARAM,                    IPNTR, WORKD, WORKL, LWORKL, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT, HOWMNY, WHICH*2
LOGICAL    RVEC, SELECT(NCV)
INTEGER    INFO, LDZ, LDV, LWORKL, N, NCV, NEV
DOUBLE PRECISION           SIGMA, TOL
INTEGER    IPARAM(7), IPNTR(11)
DOUBLE PRECISION           D(NEV), RESID(N), V(LDV,NCV), Z(LDZ, NEV),            WORKD(2*N), WORKL(LWORKL)}
procedure DSEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecDouble;var Z:TMatDouble;var LDZ:integer;var SIGMA:double;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer);

{
SUBROUTINE DSGETS ( ISHIFT, WHICH, KEV, NP, RITZ, BOUNDS, SHIFTS )
INCLUDE
INCLUDE
charFACTER*2 WHICH
INTEGER    ISHIFT, KEV, NP
DOUBLE PRECISION           BOUNDS(KEV+NP), RITZ(KEV+NP), SHIFTS(NP)}
procedure DSGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecDouble;var BOUNDS:TVecDouble;var SHIFTS:TVecDouble);

{
SUBROUTINE DSORTC (WHICH, APPLY, N, XREAL, XIMAG, Y)
charFACTER*2 WHICH
LOGICAL    APPLY
INTEGER    N
DOUBLE PRECISION           XREAL(0:N-1), XIMAG(0:N-1), Y(0:N-1)}
procedure DSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var XREAL:TVecDouble;var XIMAG:TVecDouble;var Y:TVecDouble);

{
SUBROUTINE DSORTR (WHICH, APPLY, N, X1, X2)
charFACTER*2 WHICH
LOGICAL    APPLY
INTEGER    N
DOUBLE PRECISION           X1(0:N-1), X2(0:N-1)}
procedure DSORTR(var WHICH:charF2;var APPLY:longbool;var N:integer;var X1:TVecDouble;var X2:TVecDouble);

{
SUBROUTINE DSTATN}
procedure DSTATN();cdecl; external 'arpacklib.dll';

{
SUBROUTINE DSTATS}
procedure DSTATS();cdecl; external 'arpacklib.dll';

{
SUBROUTINE DSTQRB ( N, D, E, Z, WORK, INFO )
INTEGER    INFO, N
DOUBLE PRECISION           D( N ), E( N-1 ), Z( N ), WORK( 2*N-2 )}
procedure DSTQRB(var N:integer;var D:TVecDouble;var E:TVecDouble;var Z:TVecDouble;var WORK:TVecDouble;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SGETV0   ( IDO, BMAT, ITRY, INITV, N, J, V, LDV, RESID, RNORM,      IPNTR, WORKD, IERR )
INCLUDE
INCLUDE
charFACTER  BMAT*1
LOGICAL    INITV
INTEGER    IDO, IERR, ITRY, J, LDV, N
REAL           RNORM
INTEGER    IPNTR(3)
REAL           RESID(N), V(LDV,J), WORKD(2*N)}
procedure SGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatReal;var LDV:integer;var RESID:TVecReal;var RNORM:real;var IPNTR:TVecInteger;var WORKD:TVecReal;var IERR:integer);

{
SUBROUTINE SLAQRB ( WANTT, N, ILO, IHI, H, LDH, WR, WI,                    Z, INFO )
LOGICAL    WANTT
INTEGER    IHI, ILO, INFO, LDH, N
REAL           H( LDH, * ), WI( * ), WR( * ), Z( * )}
procedure SLAQRB(var WANTT:longbool;var N:integer;var ILO:integer;var IHI:integer;var H:TMatReal;var LDH:integer;var WR:TVecReal;var WI:TVecReal;var Z:TVecReal;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SNAITR   (IDO, BMAT, N, K, NP, NB, RESID, RNORM, V, LDV, H, LDH,     IPNTR, WORKD, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT*1
INTEGER    IDO, INFO, K, LDH, LDV, N, NB, NP
REAL           RNORM
INTEGER    IPNTR(3)
REAL           H(LDH,K+NP), RESID(N), V(LDV,K+NP), WORKD(3*N)}
procedure SNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecReal;var RNORM:real;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer);

{
SUBROUTINE SNAPPS   ( N, KEV, NP, SHIFTR, SHIFTI, V, LDV, H, LDH, RESID, Q, LDQ,      WORKL, WORKD )
INCLUDE
INCLUDE
INTEGER    KEV, LDH, LDQ, LDV, N, NP
REAL           H(LDH,KEV+NP), RESID(N), SHIFTI(NP), SHIFTR(NP),            V(LDV,KEV+NP), Q(LDQ,KEV+NP), WORKD(2*N), WORKL(KEV+NP)}
procedure SNAPPS(var N:integer;var KEV:integer;var NP:integer;var SHIFTR:TVecReal;var SHIFTI:TVecReal;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var RESID:TVecReal;var Q:TMatReal;var LDQ:integer;var WORKL:TVecReal;var WORKD:TVecReal);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SNAUP2   ( IDO, BMAT, N, WHICH, NEV, NP, TOL, RESID, MODE, IUPD,      ISHIFT, MXITER, V, LDV, H, LDH, RITZR, RITZI, BOUNDS,      Q, LDQ, WORKL, IPNTR, WORKD, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, ISHIFT, IUPD, MODE, LDH, LDQ, LDV, MXITER,           N, NEV, NP
REAL           TOL
INTEGER    IPNTR(13)
REAL           BOUNDS(NEV+NP), H(LDH,NEV+NP), Q(LDQ,NEV+NP), RESID(N),           RITZI(NEV+NP), RITZR(NEV+NP), V(LDV,NEV+NP),            WORKD(3*N), WORKL( (NEV+NP)*(NEV+NP+3) )}
procedure SNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:real;var RESID:TVecReal;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var RITZR:TVecReal;var RITZI:TVecReal;var BOUNDS:TVecReal;var Q:TMatReal;var LDQ:integer;var WORKL:TVecReal;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer);

{
SUBROUTINE SNAUPD   ( IDO, BMAT, N, WHICH, NEV, TOL, RESID, NCV, V, LDV, IPARAM,      IPNTR, WORKD, WORKL, LWORKL, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, LDV, LWORKL, N, NCV, NEV
REAL           TOL
INTEGER    IPARAM(11), IPNTR(14)
REAL           RESID(N), V(LDV,NCV), WORKD(3*N), WORKL(LWORKL)}
procedure SNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer);

{
SUBROUTINE SNCONV (N, RITZR, RITZI, BOUNDS, TOL, NCONV)
INCLUDE
INCLUDE
INTEGER    N, NCONV
REAL           TOL
REAL           RITZR(N), RITZI(N), BOUNDS(N)}
procedure SNCONV(var N:integer;var RITZR:TVecReal;var RITZI:TVecReal;var BOUNDS:TVecReal;var TOL:real;var NCONV:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SNEIGH (RNORM, N, H, LDH, RITZR, RITZI, BOUNDS,                   Q, LDQ, WORKL, IERR)
INCLUDE
INCLUDE
INTEGER    IERR, N, LDH, LDQ
REAL           RNORM
REAL           BOUNDS(N), H(LDH,N), Q(LDQ,N), RITZI(N), RITZR(N),           WORKL(N*(N+3))}
procedure SNEIGH(var RNORM:real;var N:integer;var H:TMatReal;var LDH:integer;var RITZR:TVecReal;var RITZI:TVecReal;var BOUNDS:TVecReal;var Q:TMatReal;var LDQ:integer;var WORKL:TVecReal;var IERR:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SNEUPD (RVEC, HOWMNY, SELECT, DR, DI, Z, LDZ, SIGMAR,                   SIGMAI, WORKEV, BMAT, N, WHICH, NEV, TOL,                    RESID, NCV, V, LDV, IPARAM, IPNTR, WORKD,                    WORKL, LWORKL, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT, HOWMNY, WHICH*2
LOGICAL    RVEC
INTEGER    INFO, LDZ, LDV, LWORKL, N, NCV, NEV
REAL           SIGMAR, SIGMAI, TOL
INTEGER    IPARAM(11), IPNTR(14)
LOGICAL    SELECT(NCV)
REAL           DR(NEV+1), DI(NEV+1), RESID(N), V(LDV,NCV), Z(LDZ,*),            WORKD(3*N), WORKL(LWORKL), WORKEV(3*NCV)}
procedure SNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var DR:TVecReal;var DI:TVecReal;var Z:TMatReal;var LDZ:integer;var SIGMAR:real;var SIGMAI:real;var WORKEV:TVecReal;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer);

{
SUBROUTINE SNGETS ( ISHIFT, WHICH, KEV, NP, RITZR, RITZI, BOUNDS,                    SHIFTR, SHIFTI )
INCLUDE
INCLUDE
charFACTER*2 WHICH
INTEGER    ISHIFT, KEV, NP
REAL           BOUNDS(KEV+NP), RITZR(KEV+NP), RITZI(KEV+NP),            SHIFTR(1), SHIFTI(1)}
procedure SNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZR:TVecReal;var RITZI:TVecReal;var BOUNDS:TVecReal;var SHIFTR:TVecReal;var SHIFTI:TVecReal);

{
SUBROUTINE SSAITR   (IDO, BMAT, N, K, NP, MODE, RESID, RNORM, V, LDV, H, LDH,     IPNTR, WORKD, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT*1
INTEGER    IDO, INFO, K, LDH, LDV, N, MODE, NP
REAL           RNORM
INTEGER    IPNTR(3)
REAL           H(LDH,2), RESID(N), V(LDV,K+NP), WORKD(3*N)}
procedure SSAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var MODE:integer;var RESID:TVecReal;var RNORM:real;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer);

{
SUBROUTINE SSAPPS   ( N, KEV, NP, SHIFT, V, LDV, H, LDH, RESID, Q, LDQ, WORKD )
INCLUDE
INCLUDE
INTEGER    KEV, LDH, LDQ, LDV, N, NP
REAL           H(LDH,2), Q(LDQ,KEV+NP), RESID(N), SHIFT(NP),            V(LDV,KEV+NP), WORKD(2*N)}
procedure SSAPPS(var N:integer;var KEV:integer;var NP:integer;var SHIFT:TVecReal;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var RESID:TVecReal;var Q:TMatReal;var LDQ:integer;var WORKD:TVecReal);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SSAUP2   ( IDO, BMAT, N, WHICH, NEV, NP, TOL, RESID, MODE, IUPD,      ISHIFT, MXITER, V, LDV, H, LDH, RITZ, BOUNDS,      Q, LDQ, WORKL, IPNTR, WORKD, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, ISHIFT, IUPD, LDH, LDQ, LDV, MXITER,           N, MODE, NEV, NP
REAL           TOL
INTEGER    IPNTR(3)
REAL           BOUNDS(NEV+NP), H(LDH,2), Q(LDQ,NEV+NP), RESID(N),            RITZ(NEV+NP), V(LDV,NEV+NP), WORKD(3*N),            WORKL(3*(NEV+NP))}
procedure SSAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:real;var RESID:TVecReal;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var RITZ:TVecReal;var BOUNDS:TVecReal;var Q:TMatReal;var LDQ:integer;var WORKL:TVecReal;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer);

{
SUBROUTINE SSAUPD   ( IDO, BMAT, N, WHICH, NEV, TOL, RESID, NCV, V, LDV, IPARAM,      IPNTR, WORKD, WORKL, LWORKL, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, LDV, LWORKL, N, NCV, NEV
REAL           TOL
INTEGER    IPARAM(11), IPNTR(11)
REAL           RESID(N), V(LDV,NCV), WORKD(3*N), WORKL(LWORKL)}
procedure SSAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer);

{
SUBROUTINE SSCONV (N, RITZ, BOUNDS, TOL, NCONV)
INCLUDE
INCLUDE
INTEGER    N, NCONV
REAL           TOL
REAL           RITZ(N), BOUNDS(N)}
procedure SSCONV(var N:integer;var RITZ:TVecReal;var BOUNDS:TVecReal;var TOL:real;var NCONV:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SSEIGT   ( RNORM, N, H, LDH, EIG, BOUNDS, WORKL, IERR )
INCLUDE
INCLUDE
INTEGER    IERR, LDH, N
REAL           RNORM
REAL           EIG(N), BOUNDS(N), H(LDH,2), WORKL(3*N)}
procedure SSEIGT(var RNORM:real;var N:integer;var H:TMatReal;var LDH:integer;var EIG:TVecReal;var BOUNDS:TVecReal;var WORKL:TVecReal;var IERR:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE SSESRT (WHICH, APPLY, N, X, NA, A, LDA)
charFACTER*2 WHICH
LOGICAL    APPLY
INTEGER    LDA, N, NA
REAL           X(0:N-1), A(LDA, 0:N-1)}
procedure SSESRT(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecReal;var NA:integer;var A:TMatReal;var LDA:integer);

{
SUBROUTINE SSEUPD (RVEC, HOWMNY, SELECT, D, Z, LDZ, SIGMA, BMAT,                   N, WHICH, NEV, TOL, RESID, NCV, V, LDV, IPARAM,                    IPNTR, WORKD, WORKL, LWORKL, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT, HOWMNY, WHICH*2
LOGICAL    RVEC, SELECT(NCV)
INTEGER    INFO, LDZ, LDV, LWORKL, N, NCV, NEV
REAL           SIGMA, TOL
INTEGER    IPARAM(7), IPNTR(11)
REAL           D(NEV), RESID(N), V(LDV,NCV), Z(LDZ, NEV),            WORKD(2*N), WORKL(LWORKL)}
procedure SSEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecReal;var Z:TMatReal;var LDZ:integer;var SIGMA:real;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer);

{
SUBROUTINE SSGETS ( ISHIFT, WHICH, KEV, NP, RITZ, BOUNDS, SHIFTS )
INCLUDE
INCLUDE
charFACTER*2 WHICH
INTEGER    ISHIFT, KEV, NP
REAL           BOUNDS(KEV+NP), RITZ(KEV+NP), SHIFTS(NP)}
procedure SSGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecReal;var BOUNDS:TVecReal;var SHIFTS:TVecReal);

{
SUBROUTINE SSORTC (WHICH, APPLY, N, XREAL, XIMAG, Y)
charFACTER*2 WHICH
LOGICAL    APPLY
INTEGER    N
REAL           XREAL(0:N-1), XIMAG(0:N-1), Y(0:N-1)}
procedure SSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var XREAL:TVecReal;var XIMAG:TVecReal;var Y:TVecReal);

{
SUBROUTINE SSORTR (WHICH, APPLY, N, X1, X2)
charFACTER*2 WHICH
LOGICAL    APPLY
INTEGER    N
REAL           X1(0:N-1), X2(0:N-1)}
procedure SSORTR(var WHICH:charF2;var APPLY:longbool;var N:integer;var X1:TVecReal;var X2:TVecReal);

{
SUBROUTINE SSTATN}
procedure SSTATN();cdecl; external 'arpacklib.dll';

{
SUBROUTINE SSTATS}
procedure SSTATS();cdecl; external 'arpacklib.dll';

{
SUBROUTINE SSTQRB ( N, D, E, Z, WORK, INFO )
INTEGER    INFO, N
REAL           D( N ), E( N-1 ), Z( N ), WORK( 2*N-2 )}
procedure SSTQRB(var N:integer;var D:TVecReal;var E:TVecReal;var Z:TVecReal;var WORK:TVecReal;var INFO:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZGETV0   ( IDO, BMAT, ITRY, INITV, N, J, V, LDV, RESID, RNORM,      IPNTR, WORKD, IERR )
INCLUDE
INCLUDE
charFACTER  BMAT*1
LOGICAL    INITV
INTEGER    IDO, IERR, ITRY, J, LDV, N
DOUBLE PRECISION           RNORM
INTEGER    IPNTR(3)
COMPLEX*16           RESID(N), V(LDV,J), WORKD(2*N)}
procedure ZGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatComplex;var LDV:integer;var RESID:TVecComplex;var RNORM:double;var IPNTR:TVecInteger;var WORKD:TVecComplex;var IERR:integer);

{
SUBROUTINE ZNAITR   (IDO, BMAT, N, K, NP, NB, RESID, RNORM, V, LDV, H, LDH,     IPNTR, WORKD, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT*1
INTEGER    IDO, INFO, K, LDH, LDV, N, NB, NP
DOUBLE PRECISION           RNORM
INTEGER    IPNTR(3)
COMPLEX*16           H(LDH,K+NP), RESID(N), V(LDV,K+NP), WORKD(3*N)}
procedure ZNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecComplex;var RNORM:double;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecComplex;var INFO:integer);

{
SUBROUTINE ZNAPPS   ( N, KEV, NP, SHIFT, V, LDV, H, LDH, RESID, Q, LDQ,      WORKL, WORKD )
INCLUDE
INCLUDE
INTEGER    KEV, LDH, LDQ, LDV, N, NP
COMPLEX*16           H(LDH,KEV+NP), RESID(N), SHIFT(NP),            V(LDV,KEV+NP), Q(LDQ,KEV+NP), WORKD(2*N), WORKL(KEV+NP)}
procedure ZNAPPS(var N:integer;var KEV:integer;var NP:integer;var SHIFT:TVecComplex;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var RESID:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var WORKD:TVecComplex);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZNAUP2   ( IDO, BMAT, N, WHICH, NEV, NP, TOL, RESID, MODE, IUPD,      ISHIFT, MXITER, V, LDV, H, LDH, RITZ, BOUNDS,      Q, LDQ, WORKL, IPNTR, WORKD, RWORK, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, ISHIFT, IUPD, MODE, LDH, LDQ, LDV, MXITER,           N, NEV, NP
DOUBLE PRECISION           TOL
INTEGER    IPNTR(13)
COMPLEX*16           BOUNDS(NEV+NP), H(LDH,NEV+NP), Q(LDQ,NEV+NP),            RESID(N), RITZ(NEV+NP),  V(LDV,NEV+NP),            WORKD(3*N), WORKL( (NEV+NP)*(NEV+NP+3) )
DOUBLE PRECISION           RWORK(NEV+NP)}
procedure ZNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:double;var RESID:TVecComplex;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var IPNTR:TVecInteger;var WORKD:TVecComplex;var RWORK:TVecDouble;var INFO:integer);

{
SUBROUTINE ZNAUPD   ( IDO, BMAT, N, WHICH, NEV, TOL, RESID, NCV, V, LDV, IPARAM,      IPNTR, WORKD, WORKL, LWORKL, RWORK, INFO )
INCLUDE
INCLUDE
charFACTER  BMAT*1, WHICH*2
INTEGER    IDO, INFO, LDV, LWORKL, N, NCV, NEV
DOUBLE PRECISION           TOL
INTEGER    IPARAM(11), IPNTR(14)
COMPLEX*16           RESID(N), V(LDV,NCV), WORKD(3*N), WORKL(LWORKL)
DOUBLE PRECISION           RWORK(NCV)}
procedure ZNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecDouble;var INFO:integer);

{
SUBROUTINE ZNEIGH (RNORM, N, H, LDH, RITZ, BOUNDS,                   Q, LDQ, WORKL, RWORK, IERR)
INCLUDE
INCLUDE
INTEGER    IERR, N, LDH, LDQ
DOUBLE PRECISION           RNORM
COMPLEX*16           BOUNDS(N), H(LDH,N), Q(LDQ,N), RITZ(N),           WORKL(N*(N+3)) 
DOUBLE PRECISION           RWORK(N)}
procedure ZNEIGH(var RNORM:double;var N:integer;var H:TMatComplex;var LDH:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var RWORK:TVecDouble;var IERR:integer);cdecl; external 'arpacklib.dll';

{
SUBROUTINE ZNEUPD (RVEC, HOWMNY, SELECT, D, Z, LDZ, SIGMA,                   WORKEV, BMAT, N, WHICH, NEV, TOL,                    RESID, NCV, V, LDV, IPARAM, IPNTR, WORKD,                    WORKL, LWORKL, RWORK, INFO)
INCLUDE
INCLUDE
charFACTER  BMAT, HOWMNY, WHICH*2
LOGICAL    RVEC
INTEGER    INFO, LDZ, LDV, LWORKL, N, NCV, NEV
COMPLEX*16           SIGMA
DOUBLE PRECISION           TOL
INTEGER    IPARAM(11), IPNTR(14)
LOGICAL    SELECT(NCV)
DOUBLE PRECISION           RWORK(NCV)
COMPLEX*16           D(NEV), RESID(N), V(LDV,NCV), Z(LDZ, NEV),            WORKD(3*N), WORKL(LWORKL), WORKEV(2*NCV)}
procedure ZNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecComplex;var Z:TMatComplex;var LDZ:integer;var SIGMA:TDoubleComplex;var WORKEV:TVecComplex;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecDouble;var INFO:integer);

{
SUBROUTINE ZNGETS ( ISHIFT, WHICH, KEV, NP, RITZ, BOUNDS)
INCLUDE
INCLUDE
charFACTER*2 WHICH
INTEGER    ISHIFT, KEV, NP
COMPLEX*16           BOUNDS(KEV+NP), RITZ(KEV+NP)}
procedure ZNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex);

{
SUBROUTINE ZSORTC (WHICH, APPLY, N, X, Y)
charFACTER*2 WHICH
LOGICAL    APPLY
INTEGER    N
COMPLEX*16           X(0:N-1), Y(0:N-1)}
procedure ZSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecComplex;var Y:TVecComplex);

{
SUBROUTINE ZSTATN}
procedure ZSTATN();cdecl; external 'arpacklib.dll';


implementation

procedure _CMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var IDIGIT:integer;var IFMT:charF;l__IFMT:integer);cdecl; external 'arpacklib.dll' name 'CMOUT';
procedure CMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var IDIGIT:integer;var IFMT:charF);
begin
  _CMOUT(LOUT,M,N,A,LDA,IDIGIT,IFMT,length(IFMT));
end;

procedure _CVOUT(var LOUT:integer;var N:integer;var CX:TVecComplex;var IDIGIT:integer;var IFMT:charF;l__IFMT:integer);cdecl; external 'arpacklib.dll' name 'CVOUT';
procedure CVOUT(var LOUT:integer;var N:integer;var CX:TVecComplex;var IDIGIT:integer;var IFMT:charF);
begin
  _CVOUT(LOUT,N,CX,IDIGIT,IFMT,length(IFMT));
end;

procedure _DMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var IDIGIT:integer;var IFMT:charF;l__IFMT:integer);cdecl; external 'arpacklib.dll' name 'DMOUT';
procedure DMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var IDIGIT:integer;var IFMT:charF);
begin
  _DMOUT(LOUT,M,N,A,LDA,IDIGIT,IFMT,length(IFMT));
end;

procedure _DVOUT(var LOUT:integer;var N:integer;var SX:TVecDouble;var IDIGIT:integer;var IFMT:charF;l__IFMT:integer);cdecl; external 'arpacklib.dll' name 'DVOUT';
procedure DVOUT(var LOUT:integer;var N:integer;var SX:TVecDouble;var IDIGIT:integer;var IFMT:charF);
begin
  _DVOUT(LOUT,N,SX,IDIGIT,IFMT,length(IFMT));
end;

procedure _FUNC_ICNTEQ(var RESULT_:integer;var N:integer;var ARRAY_:TVecInteger;var VALUE:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ICNTEQ';
procedure FUNC_ICNTEQ(var RESULT_:integer;var N:integer;var ARRAY_:TVecInteger;var VALUE:integer);
begin
  _FUNC_ICNTEQ(RESULT_,N,ARRAY_,VALUE);
end;

procedure _IVOUT(var LOUT:integer;var N:integer;var IX:TVecInteger;var IDIGIT:integer;var IFMT:charF;l__IFMT:integer);cdecl; external 'arpacklib.dll' name 'IVOUT';
procedure IVOUT(var LOUT:integer;var N:integer;var IX:TVecInteger;var IDIGIT:integer;var IFMT:charF);
begin
  _IVOUT(LOUT,N,IX,IDIGIT,IFMT,length(IFMT));
end;

procedure _SMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var IDIGIT:integer;var IFMT:charF;l__IFMT:integer);cdecl; external 'arpacklib.dll' name 'SMOUT';
procedure SMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var IDIGIT:integer;var IFMT:charF);
begin
  _SMOUT(LOUT,M,N,A,LDA,IDIGIT,IFMT,length(IFMT));
end;

procedure _SVOUT(var LOUT:integer;var N:integer;var SX:TVecReal;var IDIGIT:integer;var IFMT:charF;l__IFMT:integer);cdecl; external 'arpacklib.dll' name 'SVOUT';
procedure SVOUT(var LOUT:integer;var N:integer;var SX:TVecReal;var IDIGIT:integer;var IFMT:charF);
begin
  _SVOUT(LOUT,N,SX,IDIGIT,IFMT,length(IFMT));
end;

procedure _ZMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var IDIGIT:integer;var IFMT:charF;l__IFMT:integer);cdecl; external 'arpacklib.dll' name 'ZMOUT';
procedure ZMOUT(var LOUT:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var IDIGIT:integer;var IFMT:charF);
begin
  _ZMOUT(LOUT,M,N,A,LDA,IDIGIT,IFMT,length(IFMT));
end;

procedure _ZVOUT(var LOUT:integer;var N:integer;var CX:TVecComplex;var IDIGIT:integer;var IFMT:charF;l__IFMT:integer);cdecl; external 'arpacklib.dll' name 'ZVOUT';
procedure ZVOUT(var LOUT:integer;var N:integer;var CX:TVecComplex;var IDIGIT:integer;var IFMT:charF);
begin
  _ZVOUT(LOUT,N,CX,IDIGIT,IFMT,length(IFMT));
end;

procedure _FUNC_CDOTC(var RESULT_:TComplex;var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer);cdecl; external 'arpacklib.dll' name 'FUNC_CDOTC';
procedure FUNC_CDOTC(var RESULT_:TComplex;var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer);
begin
  _FUNC_CDOTC(RESULT_,N,CX,INCX,CY,INCY);
end;

procedure _FUNC_CDOTU(var RESULT_:TComplex;var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer);cdecl; external 'arpacklib.dll' name 'FUNC_CDOTU';
procedure FUNC_CDOTU(var RESULT_:TComplex;var N:integer;var CX:TVecComplex;var INCX:integer;var CY:TVecComplex;var INCY:integer);
begin
  _FUNC_CDOTU(RESULT_,N,CX,INCX,CY,INCY);
end;

procedure _CGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TComplex;var Y:TVecComplex;var INCY:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'CGBMV';
procedure CGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TComplex;var Y:TVecComplex;var INCY:integer);
begin
  _CGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(TRANS));
end;

procedure _CGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var BETA:TComplex;var C:TMatComplex;var LDC:integer;l__TRANSA,l__TRANSB:integer);cdecl; external 'arpacklib.dll' name 'CGEMM';
procedure CGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var BETA:TComplex;var C:TMatComplex;var LDC:integer);
begin
  _CGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC,length(TRANSA),length(TRANSB));
end;

procedure _CGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TComplex;var Y:TVecComplex;var INCY:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'CGEMV';
procedure CGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TComplex;var Y:TVecComplex;var INCY:integer);
begin
  _CGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(TRANS));
end;

procedure _CTBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;l__UPLO,l__TRANS,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'CTBSV';
procedure CTBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer);
begin
  _CTBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX,length(UPLO),length(TRANS),length(DIAG));
end;

procedure _CTRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;l__SIDE,l__UPLO,l__TRANSA,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'CTRMM';
procedure CTRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);
begin
  _CTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB,length(SIDE),length(UPLO),length(TRANSA),length(DIAG));
end;

procedure _CTRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;l__SIDE,l__UPLO,l__TRANSA,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'CTRSM';
procedure CTRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);
begin
  _CTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB,length(SIDE),length(UPLO),length(TRANSA),length(DIAG));
end;

procedure _CTRSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;l__UPLO,l__TRANS,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'CTRSV';
procedure CTRSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer);
begin
  _CTRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX,length(UPLO),length(TRANS),length(DIAG));
end;

procedure _FUNC_DASUM(var RESULT_:double;var N:integer;var DX:TVecDouble;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DASUM';
procedure FUNC_DASUM(var RESULT_:double;var N:integer;var DX:TVecDouble;var INCX:integer);
begin
  _FUNC_DASUM(RESULT_,N,DX,INCX);
end;

procedure _FUNC_DDOT(var RESULT_:double;var N:integer;var DX:TVecDouble;var INCX:integer;var DY:TVecDouble;var INCY:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DDOT';
procedure FUNC_DDOT(var RESULT_:double;var N:integer;var DX:TVecDouble;var INCX:integer;var DY:TVecDouble;var INCY:integer);
begin
  _FUNC_DDOT(RESULT_,N,DX,INCX,DY,INCY);
end;

procedure _DGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;var BETA:double;var Y:TVecDouble;var INCY:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'DGBMV';
procedure DGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;var BETA:double;var Y:TVecDouble;var INCY:integer);
begin
  _DGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(TRANS));
end;

procedure _DGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer;var BETA:double;var C:TMatDouble;var LDC:integer;l__TRANSA,l__TRANSB:integer);cdecl; external 'arpacklib.dll' name 'DGEMM';
procedure DGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer;var BETA:double;var C:TMatDouble;var LDC:integer);
begin
  _DGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC,length(TRANSA),length(TRANSB));
end;

procedure _DGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;var BETA:double;var Y:TVecDouble;var INCY:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'DGEMV';
procedure DGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;var BETA:double;var Y:TVecDouble;var INCY:integer);
begin
  _DGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(TRANS));
end;

procedure _FUNC_DNRM2(var RESULT_:double;var N:integer;var DX:TVecDouble;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DNRM2';
procedure FUNC_DNRM2(var RESULT_:double;var N:integer;var DX:TVecDouble;var INCX:integer);
begin
  _FUNC_DNRM2(RESULT_,N,DX,INCX);
end;

procedure _DSYMV(var UPLO:charF;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;var BETA:double;var Y:TVecDouble;var INCY:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'DSYMV';
procedure DSYMV(var UPLO:charF;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;var BETA:double;var Y:TVecDouble;var INCY:integer);
begin
  _DSYMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(UPLO));
end;

procedure _DSYR2(var UPLO:charF;var N:integer;var ALPHA:double;var X:TVecDouble;var INCX:integer;var Y:TVecDouble;var INCY:integer;var A:TMatDouble;var LDA:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'DSYR2';
procedure DSYR2(var UPLO:charF;var N:integer;var ALPHA:double;var X:TVecDouble;var INCX:integer;var Y:TVecDouble;var INCY:integer;var A:TMatDouble;var LDA:integer);
begin
  _DSYR2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA,length(UPLO));
end;

procedure _DTBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer;l__UPLO,l__TRANS,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'DTBSV';
procedure DTBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatDouble;var LDA:integer;var X:TVecDouble;var INCX:integer);
begin
  _DTBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX,length(UPLO),length(TRANS),length(DIAG));
end;

procedure _DTRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer;l__SIDE,l__UPLO,l__TRANSA,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'DTRMM';
procedure DTRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer);
begin
  _DTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB,length(SIDE),length(UPLO),length(TRANSA),length(DIAG));
end;

procedure _DTRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer;l__SIDE,l__UPLO,l__TRANSA,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'DTRSM';
procedure DTRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:double;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer);
begin
  _DTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB,length(SIDE),length(UPLO),length(TRANSA),length(DIAG));
end;

procedure _FUNC_DZASUM(var RESULT_:double;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DZASUM';
procedure FUNC_DZASUM(var RESULT_:double;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer);
begin
  _FUNC_DZASUM(RESULT_,N,ZX,INCX);
end;

procedure _FUNC_DZNRM2(var RESULT_:double;var N:integer;var X:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DZNRM2';
procedure FUNC_DZNRM2(var RESULT_:double;var N:integer;var X:TVecComplex;var INCX:integer);
begin
  _FUNC_DZNRM2(RESULT_,N,X,INCX);
end;

procedure _FUNC_ICAMAX(var RESULT_:integer;var N:integer;var CX:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ICAMAX';
procedure FUNC_ICAMAX(var RESULT_:integer;var N:integer;var CX:TVecComplex;var INCX:integer);
begin
  _FUNC_ICAMAX(RESULT_,N,CX,INCX);
end;

procedure _FUNC_IDAMAX(var RESULT_:integer;var N:integer;var DX:TVecDouble;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_IDAMAX';
procedure FUNC_IDAMAX(var RESULT_:integer;var N:integer;var DX:TVecDouble;var INCX:integer);
begin
  _FUNC_IDAMAX(RESULT_,N,DX,INCX);
end;

procedure _FUNC_ISAMAX(var RESULT_:integer;var N:integer;var SX:TVecReal;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ISAMAX';
procedure FUNC_ISAMAX(var RESULT_:integer;var N:integer;var SX:TVecReal;var INCX:integer);
begin
  _FUNC_ISAMAX(RESULT_,N,SX,INCX);
end;

procedure _FUNC_IZAMAX(var RESULT_:integer;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_IZAMAX';
procedure FUNC_IZAMAX(var RESULT_:integer;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer);
begin
  _FUNC_IZAMAX(RESULT_,N,ZX,INCX);
end;

procedure _FUNC_SASUM(var RESULT_:real;var N:integer;var SX:TVecReal;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SASUM';
procedure FUNC_SASUM(var RESULT_:real;var N:integer;var SX:TVecReal;var INCX:integer);
begin
  _FUNC_SASUM(RESULT_,N,SX,INCX);
end;

procedure _FUNC_SCASUM(var RESULT_:real;var N:integer;var CX:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SCASUM';
procedure FUNC_SCASUM(var RESULT_:real;var N:integer;var CX:TVecComplex;var INCX:integer);
begin
  _FUNC_SCASUM(RESULT_,N,CX,INCX);
end;

procedure _FUNC_SCNRM2(var RESULT_:real;var N:integer;var X:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SCNRM2';
procedure FUNC_SCNRM2(var RESULT_:real;var N:integer;var X:TVecComplex;var INCX:integer);
begin
  _FUNC_SCNRM2(RESULT_,N,X,INCX);
end;

procedure _FUNC_SDOT(var RESULT_:real;var N:integer;var SX:TVecReal;var INCX:integer;var SY:TVecReal;var INCY:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SDOT';
procedure FUNC_SDOT(var RESULT_:real;var N:integer;var SX:TVecReal;var INCX:integer;var SY:TVecReal;var INCY:integer);
begin
  _FUNC_SDOT(RESULT_,N,SX,INCX,SY,INCY);
end;

procedure _SGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;var BETA:real;var Y:TVecReal;var INCY:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'SGBMV';
procedure SGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;var BETA:real;var Y:TVecReal;var INCY:integer);
begin
  _SGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(TRANS));
end;

procedure _SGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer;var BETA:real;var C:TMatReal;var LDC:integer;l__TRANSA,l__TRANSB:integer);cdecl; external 'arpacklib.dll' name 'SGEMM';
procedure SGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer;var BETA:real;var C:TMatReal;var LDC:integer);
begin
  _SGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC,length(TRANSA),length(TRANSB));
end;

procedure _SGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;var BETA:real;var Y:TVecReal;var INCY:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'SGEMV';
procedure SGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;var BETA:real;var Y:TVecReal;var INCY:integer);
begin
  _SGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(TRANS));
end;

procedure _FUNC_SNRM2(var RESULT_:real;var N:integer;var SX:TVecReal;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SNRM2';
procedure FUNC_SNRM2(var RESULT_:real;var N:integer;var SX:TVecReal;var INCX:integer);
begin
  _FUNC_SNRM2(RESULT_,N,SX,INCX);
end;

procedure _SSYMV(var UPLO:charF;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;var BETA:real;var Y:TVecReal;var INCY:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'SSYMV';
procedure SSYMV(var UPLO:charF;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;var BETA:real;var Y:TVecReal;var INCY:integer);
begin
  _SSYMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(UPLO));
end;

procedure _SSYR2(var UPLO:charF;var N:integer;var ALPHA:real;var X:TVecReal;var INCX:integer;var Y:TVecReal;var INCY:integer;var A:TMatReal;var LDA:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'SSYR2';
procedure SSYR2(var UPLO:charF;var N:integer;var ALPHA:real;var X:TVecReal;var INCX:integer;var Y:TVecReal;var INCY:integer;var A:TMatReal;var LDA:integer);
begin
  _SSYR2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA,length(UPLO));
end;

procedure _STBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer;l__UPLO,l__TRANS,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'STBSV';
procedure STBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatReal;var LDA:integer;var X:TVecReal;var INCX:integer);
begin
  _STBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX,length(UPLO),length(TRANS),length(DIAG));
end;

procedure _STRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer;l__SIDE,l__UPLO,l__TRANSA,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'STRMM';
procedure STRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer);
begin
  _STRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB,length(SIDE),length(UPLO),length(TRANSA),length(DIAG));
end;

procedure _STRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer;l__SIDE,l__UPLO,l__TRANSA,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'STRSM';
procedure STRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:real;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer);
begin
  _STRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB,length(SIDE),length(UPLO),length(TRANSA),length(DIAG));
end;

procedure _FUNC_ZDOTC(var RESULT_:TDoubleComplex;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer;var ZY:TVecDoubleComplex;var INCY:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ZDOTC';
procedure FUNC_ZDOTC(var RESULT_:TDoubleComplex;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer;var ZY:TVecDoubleComplex;var INCY:integer);
begin
  _FUNC_ZDOTC(RESULT_,N,ZX,INCX,ZY,INCY);
end;

procedure _FUNC_ZDOTU(var RESULT_:TDoubleComplex;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer;var ZY:TVecDoubleComplex;var INCY:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ZDOTU';
procedure FUNC_ZDOTU(var RESULT_:TDoubleComplex;var N:integer;var ZX:TVecDoubleComplex;var INCX:integer;var ZY:TVecDoubleComplex;var INCY:integer);
begin
  _FUNC_ZDOTU(RESULT_,N,ZX,INCX,ZY,INCY);
end;

procedure _ZGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TDoubleComplex;var Y:TVecComplex;var INCY:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'ZGBMV';
procedure ZGBMV(var TRANS:charF;var M:integer;var N:integer;var KL:integer;var KU:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TDoubleComplex;var Y:TVecComplex;var INCY:integer);
begin
  _ZGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(TRANS));
end;

procedure _ZGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var BETA:TDoubleComplex;var C:TMatComplex;var LDC:integer;l__TRANSA,l__TRANSB:integer);cdecl; external 'arpacklib.dll' name 'ZGEMM';
procedure ZGEMM(var TRANSA:charF;var TRANSB:charF;var M:integer;var N:integer;var K:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var BETA:TDoubleComplex;var C:TMatComplex;var LDC:integer);
begin
  _ZGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC,length(TRANSA),length(TRANSB));
end;

procedure _ZGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TDoubleComplex;var Y:TVecComplex;var INCY:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'ZGEMV';
procedure ZGEMV(var TRANS:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;var BETA:TDoubleComplex;var Y:TVecComplex;var INCY:integer);
begin
  _ZGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY,length(TRANS));
end;

procedure _ZTBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;l__UPLO,l__TRANS,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'ZTBSV';
procedure ZTBSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer);
begin
  _ZTBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX,length(UPLO),length(TRANS),length(DIAG));
end;

procedure _ZTRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;l__SIDE,l__UPLO,l__TRANSA,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'ZTRMM';
procedure ZTRMM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);
begin
  _ZTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB,length(SIDE),length(UPLO),length(TRANSA),length(DIAG));
end;

procedure _ZTRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;l__SIDE,l__UPLO,l__TRANSA,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'ZTRSM';
procedure ZTRSM(var SIDE:charF;var UPLO:charF;var TRANSA:charF;var DIAG:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);
begin
  _ZTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB,length(SIDE),length(UPLO),length(TRANSA),length(DIAG));
end;

procedure _ZTRSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer;l__UPLO,l__TRANS,l__DIAG:integer);cdecl; external 'arpacklib.dll' name 'ZTRSV';
procedure ZTRSV(var UPLO:charF;var TRANS:charF;var DIAG:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var INCX:integer);
begin
  _ZTRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX,length(UPLO),length(TRANS),length(DIAG));
end;

procedure _CGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'CGBTRS';
procedure CGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer);
begin
  _CGBTRS(TRANS,N,KL,KU,NRHS,AB,LDAB,IPIV,B,LDB,INFO,length(TRANS));
end;

procedure _CGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecComplex;var D:TVecComplex;var DU:TVecComplex;var DU2:TVecComplex;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'CGTTRS';
procedure CGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecComplex;var D:TVecComplex;var DU:TVecComplex;var DU2:TVecComplex;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer);
begin
  _CGTTRS(TRANS,N,NRHS,DL,D,DU,DU2,IPIV,B,LDB,INFO,length(TRANS));
end;

procedure _CLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'CLACPY';
procedure CLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);
begin
  _CLACPY(UPLO,M,N,A,LDA,B,LDB,length(UPLO));
end;

procedure _FUNC_CLADIV(var RESULT_:TComplex;var X:TComplex;var Y:TComplex);cdecl; external 'arpacklib.dll' name 'FUNC_CLADIV';
procedure FUNC_CLADIV(var RESULT_:TComplex;var X:TComplex;var Y:TComplex);
begin
  _FUNC_CLADIV(RESULT_,X,Y);
end;

procedure _FUNC_CLANGE(var RESULT_:real;var NORM:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecReal;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_CLANGE';
procedure FUNC_CLANGE(var RESULT_:real;var NORM:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecReal);
begin
  _FUNC_CLANGE(RESULT_,NORM,M,N,A,LDA,WORK,length(NORM));
end;

procedure _FUNC_CLANHS(var RESULT_:real;var NORM:charF;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecReal;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_CLANHS';
procedure FUNC_CLANHS(var RESULT_:real;var NORM:charF;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecReal);
begin
  _FUNC_CLANHS(RESULT_,NORM,N,A,LDA,WORK,length(NORM));
end;

procedure _CLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecComplex;var INCV:integer;var TAU:TComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex;l__SIDE:integer);cdecl; external 'arpacklib.dll' name 'CLARF';
procedure CLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecComplex;var INCV:integer;var TAU:TComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex);
begin
  _CLARF(SIDE,M,N,V,INCV,TAU,C,LDC,WORK,length(SIDE));
end;

procedure _CLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:real;var CTO:real;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var INFO:integer;l__TYPE_:integer);cdecl; external 'arpacklib.dll' name 'CLASCL';
procedure CLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:real;var CTO:real;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var INFO:integer);
begin
  _CLASCL(TYPE_,KL,KU,CFROM,CTO,M,N,A,LDA,INFO,length(TYPE_));
end;

procedure _CLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:TComplex;var BETA:TComplex;var A:TMatComplex;var LDA:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'CLASET';
procedure CLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:TComplex;var BETA:TComplex;var A:TMatComplex;var LDA:integer);
begin
  _CLASET(UPLO,M,N,ALPHA,BETA,A,LDA,length(UPLO));
end;

procedure _CLATRS(var UPLO:charF;var TRANS:charF;var DIAG:charF;var NORMIN:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var SCALE:real;var CNORM:TVecReal;var INFO:integer;l__UPLO,l__TRANS,l__DIAG,l__NORMIN:integer);cdecl; external 'arpacklib.dll' name 'CLATRS';
procedure CLATRS(var UPLO:charF;var TRANS:charF;var DIAG:charF;var NORMIN:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var SCALE:real;var CNORM:TVecReal;var INFO:integer);
begin
  _CLATRS(UPLO,TRANS,DIAG,NORMIN,N,A,LDA,X,SCALE,CNORM,INFO,length(UPLO),length(TRANS),length(DIAG),length(NORMIN));
end;

procedure _FUNC_CMACH(var RESULT_:real;var JOB:integer);cdecl; external 'arpacklib.dll' name 'FUNC_CMACH';
procedure FUNC_CMACH(var RESULT_:real;var JOB:integer);
begin
  _FUNC_CMACH(RESULT_,JOB);
end;

procedure _CTREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var VL:TMatComplex;var LDVL:integer;var VR:TMatComplex;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecComplex;var RWORK:TVecReal;var INFO:integer;l__SIDE,l__HOWMNY:integer);cdecl; external 'arpacklib.dll' name 'CTREVC';
procedure CTREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var VL:TMatComplex;var LDVL:integer;var VR:TMatComplex;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecComplex;var RWORK:TVecReal;var INFO:integer);
begin
  _CTREVC(SIDE,HOWMNY,SELECT,N,T,LDT,VL,LDVL,VR,LDVR,MM,M,WORK,RWORK,INFO,length(SIDE),length(HOWMNY));
end;

procedure _CTREXC(var COMPQ:charF;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var IFST:integer;var ILST:integer;var INFO:integer;l__COMPQ:integer);cdecl; external 'arpacklib.dll' name 'CTREXC';
procedure CTREXC(var COMPQ:charF;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var IFST:integer;var ILST:integer;var INFO:integer);
begin
  _CTREXC(COMPQ,N,T,LDT,Q,LDQ,IFST,ILST,INFO,length(COMPQ));
end;

procedure _CTRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var W:TVecComplex;var M:integer;var S:real;var SEP:real;var WORK:TVecComplex;var LWORK:integer;var INFO:integer;l__JOB,l__COMPQ:integer);cdecl; external 'arpacklib.dll' name 'CTRSEN';
procedure CTRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var W:TVecComplex;var M:integer;var S:real;var SEP:real;var WORK:TVecComplex;var LWORK:integer;var INFO:integer);
begin
  _CTRSEN(JOB,COMPQ,SELECT,N,T,LDT,Q,LDQ,W,M,S,SEP,WORK,LWORK,INFO,length(JOB),length(COMPQ));
end;

procedure _CTRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var C:TMatComplex;var LDC:integer;var SCALE:real;var INFO:integer;l__TRANA,l__TRANB:integer);cdecl; external 'arpacklib.dll' name 'CTRSYL';
procedure CTRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var C:TMatComplex;var LDC:integer;var SCALE:real;var INFO:integer);
begin
  _CTRSYL(TRANA,TRANB,ISGN,M,N,A,LDA,B,LDB,C,LDC,SCALE,INFO,length(TRANA),length(TRANB));
end;

procedure _CUNM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var TAU:TVecComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex;var INFO:integer;l__SIDE,l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'CUNM2R';
procedure CUNM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var TAU:TVecComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex;var INFO:integer);
begin
  _CUNM2R(SIDE,TRANS,M,N,K,A,LDA,TAU,C,LDC,WORK,INFO,length(SIDE),length(TRANS));
end;

procedure _DGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatDouble;var LDAB:integer;var IPIV:TVecInteger;var B:TMatDouble;var LDB:integer;var INFO:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'DGBTRS';
procedure DGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatDouble;var LDAB:integer;var IPIV:TVecInteger;var B:TMatDouble;var LDB:integer;var INFO:integer);
begin
  _DGBTRS(TRANS,N,KL,KU,NRHS,AB,LDAB,IPIV,B,LDB,INFO,length(TRANS));
end;

procedure _DGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecDouble;var D:TVecDouble;var DU:TVecDouble;var DU2:TVecDouble;var IPIV:TVecInteger;var B:TMatDouble;var LDB:integer;var INFO:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'DGTTRS';
procedure DGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecDouble;var D:TVecDouble;var DU:TVecDouble;var DU2:TVecDouble;var IPIV:TVecInteger;var B:TMatDouble;var LDB:integer;var INFO:integer);
begin
  _DGTTRS(TRANS,N,NRHS,DL,D,DU,DU2,IPIV,B,LDB,INFO,length(TRANS));
end;

procedure _DLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'DLACPY';
procedure DLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer);
begin
  _DLACPY(UPLO,M,N,A,LDA,B,LDB,length(UPLO));
end;

procedure _DLAGTM(var TRANS:charF;var N:integer;var NRHS:integer;var ALPHA:double;var DL:TVecDouble;var D:TVecDouble;var DU:TVecDouble;var X:TMatDouble;var LDX:integer;var BETA:double;var B:TMatDouble;var LDB:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'DLAGTM';
procedure DLAGTM(var TRANS:charF;var N:integer;var NRHS:integer;var ALPHA:double;var DL:TVecDouble;var D:TVecDouble;var DU:TVecDouble;var X:TMatDouble;var LDX:integer;var BETA:double;var B:TMatDouble;var LDB:integer);
begin
  _DLAGTM(TRANS,N,NRHS,ALPHA,DL,D,DU,X,LDX,BETA,B,LDB,length(TRANS));
end;

procedure _FUNC_DLAMCH(var RESULT_:double;var CMACH:charF;l__CMACH:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DLAMCH';
procedure FUNC_DLAMCH(var RESULT_:double;var CMACH:charF);
begin
  _FUNC_DLAMCH(RESULT_,CMACH,length(CMACH));
end;

procedure _FUNC_DLANGE(var RESULT_:double;var NORM:charF;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var WORK:TVecDouble;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DLANGE';
procedure FUNC_DLANGE(var RESULT_:double;var NORM:charF;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var WORK:TVecDouble);
begin
  _FUNC_DLANGE(RESULT_,NORM,M,N,A,LDA,WORK,length(NORM));
end;

procedure _FUNC_DLANHS(var RESULT_:double;var NORM:charF;var N:integer;var A:TMatDouble;var LDA:integer;var WORK:TVecDouble;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DLANHS';
procedure FUNC_DLANHS(var RESULT_:double;var NORM:charF;var N:integer;var A:TMatDouble;var LDA:integer;var WORK:TVecDouble);
begin
  _FUNC_DLANHS(RESULT_,NORM,N,A,LDA,WORK,length(NORM));
end;

procedure _FUNC_DLANST(var RESULT_:double;var NORM:charF;var N:integer;var D:TVecDouble;var E:TVecDouble;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DLANST';
procedure FUNC_DLANST(var RESULT_:double;var NORM:charF;var N:integer;var D:TVecDouble;var E:TVecDouble);
begin
  _FUNC_DLANST(RESULT_,NORM,N,D,E,length(NORM));
end;

procedure _FUNC_DLAPY2(var RESULT_:double;var X:double;var Y:double);cdecl; external 'arpacklib.dll' name 'FUNC_DLAPY2';
procedure FUNC_DLAPY2(var RESULT_:double;var X:double;var Y:double);
begin
  _FUNC_DLAPY2(RESULT_,X,Y);
end;

procedure _FUNC_DLAPY3(var RESULT_:double;var X:double;var Y:double;var Z:double);cdecl; external 'arpacklib.dll' name 'FUNC_DLAPY3';
procedure FUNC_DLAPY3(var RESULT_:double;var X:double;var Y:double;var Z:double);
begin
  _FUNC_DLAPY3(RESULT_,X,Y,Z);
end;

procedure _FUNC_DLARAN(var RESULT_:double;var ISEED:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DLARAN';
procedure FUNC_DLARAN(var RESULT_:double;var ISEED:integer);
begin
  _FUNC_DLARAN(RESULT_,ISEED);
end;

procedure _DLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecDouble;var INCV:integer;var TAU:double;var C:TMatDouble;var LDC:integer;var WORK:TVecDouble;l__SIDE:integer);cdecl; external 'arpacklib.dll' name 'DLARF';
procedure DLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecDouble;var INCV:integer;var TAU:double;var C:TMatDouble;var LDC:integer;var WORK:TVecDouble);
begin
  _DLARF(SIDE,M,N,V,INCV,TAU,C,LDC,WORK,length(SIDE));
end;

procedure _DLARFX(var SIDE:charF;var M:integer;var N:integer;var V:TVecDouble;var TAU:double;var C:TMatDouble;var LDC:integer;var WORK:TVecDouble;l__SIDE:integer);cdecl; external 'arpacklib.dll' name 'DLARFX';
procedure DLARFX(var SIDE:charF;var M:integer;var N:integer;var V:TVecDouble;var TAU:double;var C:TMatDouble;var LDC:integer;var WORK:TVecDouble);
begin
  _DLARFX(SIDE,M,N,V,TAU,C,LDC,WORK,length(SIDE));
end;

procedure _FUNC_DLARND(var RESULT_:double;var IDIST:integer;var ISEED:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DLARND';
procedure FUNC_DLARND(var RESULT_:double;var IDIST:integer;var ISEED:integer);
begin
  _FUNC_DLARND(RESULT_,IDIST,ISEED);
end;

procedure _DLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:double;var CTO:double;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var INFO:integer;l__TYPE_:integer);cdecl; external 'arpacklib.dll' name 'DLASCL';
procedure DLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:double;var CTO:double;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var INFO:integer);
begin
  _DLASCL(TYPE_,KL,KU,CFROM,CTO,M,N,A,LDA,INFO,length(TYPE_));
end;

procedure _DLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:double;var BETA:double;var A:TMatDouble;var LDA:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'DLASET';
procedure DLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:double;var BETA:double;var A:TMatDouble;var LDA:integer);
begin
  _DLASET(UPLO,M,N,ALPHA,BETA,A,LDA,length(UPLO));
end;

procedure _DLASR(var SIDE:charF;var PIVOT:charF;var DIRECT:charF;var M:integer;var N:integer;var C:TVecDouble;var S:TVecDouble;var A:TMatDouble;var LDA:integer;l__SIDE,l__PIVOT,l__DIRECT:integer);cdecl; external 'arpacklib.dll' name 'DLASR';
procedure DLASR(var SIDE:charF;var PIVOT:charF;var DIRECT:charF;var M:integer;var N:integer;var C:TVecDouble;var S:TVecDouble;var A:TMatDouble;var LDA:integer);
begin
  _DLASR(SIDE,PIVOT,DIRECT,M,N,C,S,A,LDA,length(SIDE),length(PIVOT),length(DIRECT));
end;

procedure _DLASRT(var ID:charF;var N:integer;var D:TVecDouble;var INFO:integer;l__ID:integer);cdecl; external 'arpacklib.dll' name 'DLASRT';
procedure DLASRT(var ID:charF;var N:integer;var D:TVecDouble;var INFO:integer);
begin
  _DLASRT(ID,N,D,INFO,length(ID));
end;

procedure _DORM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatDouble;var LDA:integer;var TAU:TVecDouble;var C:TMatDouble;var LDC:integer;var WORK:TVecDouble;var INFO:integer;l__SIDE,l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'DORM2R';
procedure DORM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatDouble;var LDA:integer;var TAU:TVecDouble;var C:TMatDouble;var LDC:integer;var WORK:TVecDouble;var INFO:integer);
begin
  _DORM2R(SIDE,TRANS,M,N,K,A,LDA,TAU,C,LDC,WORK,INFO,length(SIDE),length(TRANS));
end;

procedure _DSTEQR(var COMPZ:charF;var N:integer;var D:TVecDouble;var E:TVecDouble;var Z:TMatDouble;var LDZ:integer;var WORK:TVecDouble;var INFO:integer;l__COMPZ:integer);cdecl; external 'arpacklib.dll' name 'DSTEQR';
procedure DSTEQR(var COMPZ:charF;var N:integer;var D:TVecDouble;var E:TVecDouble;var Z:TMatDouble;var LDZ:integer;var WORK:TVecDouble;var INFO:integer);
begin
  _DSTEQR(COMPZ,N,D,E,Z,LDZ,WORK,INFO,length(COMPZ));
end;

procedure _DTREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatDouble;var LDT:integer;var VL:TMatDouble;var LDVL:integer;var VR:TMatDouble;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecDouble;var INFO:integer;l__SIDE,l__HOWMNY:integer);cdecl; external 'arpacklib.dll' name 'DTREVC';
procedure DTREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatDouble;var LDT:integer;var VL:TMatDouble;var LDVL:integer;var VR:TMatDouble;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecDouble;var INFO:integer);
begin
  _DTREVC(SIDE,HOWMNY,SELECT,N,T,LDT,VL,LDVL,VR,LDVR,MM,M,WORK,INFO,length(SIDE),length(HOWMNY));
end;

procedure _DTREXC(var COMPQ:charF;var N:integer;var T:TMatDouble;var LDT:integer;var Q:TMatDouble;var LDQ:integer;var IFST:integer;var ILST:integer;var WORK:TVecDouble;var INFO:integer;l__COMPQ:integer);cdecl; external 'arpacklib.dll' name 'DTREXC';
procedure DTREXC(var COMPQ:charF;var N:integer;var T:TMatDouble;var LDT:integer;var Q:TMatDouble;var LDQ:integer;var IFST:integer;var ILST:integer;var WORK:TVecDouble;var INFO:integer);
begin
  _DTREXC(COMPQ,N,T,LDT,Q,LDQ,IFST,ILST,WORK,INFO,length(COMPQ));
end;

procedure _DTRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatDouble;var LDT:integer;var Q:TMatDouble;var LDQ:integer;var WR:TVecDouble;var WI:TVecDouble;var M:integer;var S:double;var SEP:double;var WORK:TVecDouble;var LWORK:integer;var IWORK:TVecInteger;var LIWORK:integer;var INFO:integer;l__JOB,l__COMPQ:integer);cdecl; external 'arpacklib.dll' name 'DTRSEN';
procedure DTRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatDouble;var LDT:integer;var Q:TMatDouble;var LDQ:integer;var WR:TVecDouble;var WI:TVecDouble;var M:integer;var S:double;var SEP:double;var WORK:TVecDouble;var LWORK:integer;var IWORK:TVecInteger;var LIWORK:integer;var INFO:integer);
begin
  _DTRSEN(JOB,COMPQ,SELECT,N,T,LDT,Q,LDQ,WR,WI,M,S,SEP,WORK,LWORK,IWORK,LIWORK,INFO,length(JOB),length(COMPQ));
end;

procedure _DTRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer;var C:TMatDouble;var LDC:integer;var SCALE:double;var INFO:integer;l__TRANA,l__TRANB:integer);cdecl; external 'arpacklib.dll' name 'DTRSYL';
procedure DTRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatDouble;var LDA:integer;var B:TMatDouble;var LDB:integer;var C:TMatDouble;var LDC:integer;var SCALE:double;var INFO:integer);
begin
  _DTRSYL(TRANA,TRANB,ISGN,M,N,A,LDA,B,LDB,C,LDC,SCALE,INFO,length(TRANA),length(TRANB));
end;

procedure _FUNC_DZSUM1(var RESULT_:double;var N:integer;var CX:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_DZSUM1';
procedure FUNC_DZSUM1(var RESULT_:double;var N:integer;var CX:TVecComplex;var INCX:integer);
begin
  _FUNC_DZSUM1(RESULT_,N,CX,INCX);
end;

procedure _FUNC_ICMAX1(var RESULT_:integer;var N:integer;var CX:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ICMAX1';
procedure FUNC_ICMAX1(var RESULT_:integer;var N:integer;var CX:TVecComplex;var INCX:integer);
begin
  _FUNC_ICMAX1(RESULT_,N,CX,INCX);
end;

procedure _FUNC_ILAENV(var RESULT_:integer;var ISPEC:integer;var NAME:charF;var OPTS:charF;var N1:integer;var N2:integer;var N3:integer;var N4:integer;l__NAME,l__OPTS:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ILAENV';
procedure FUNC_ILAENV(var RESULT_:integer;var ISPEC:integer;var NAME:charF;var OPTS:charF;var N1:integer;var N2:integer;var N3:integer;var N4:integer);
begin
  _FUNC_ILAENV(RESULT_,ISPEC,NAME,OPTS,N1,N2,N3,N4,length(NAME),length(OPTS));
end;

procedure _FUNC_IZMAX1(var RESULT_:integer;var N:integer;var CX:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_IZMAX1';
procedure FUNC_IZMAX1(var RESULT_:integer;var N:integer;var CX:TVecComplex;var INCX:integer);
begin
  _FUNC_IZMAX1(RESULT_,N,CX,INCX);
end;

procedure _FUNC_LSAME(var RESULT_:longbool;var CA:charF;var CB:charF;l__CA,l__CB:integer);cdecl; external 'arpacklib.dll' name 'FUNC_LSAME';
procedure FUNC_LSAME(var RESULT_:longbool;var CA:charF;var CB:charF);
begin
  _FUNC_LSAME(RESULT_,CA,CB,length(CA),length(CB));
end;

procedure _FUNC_LSAMEN(var RESULT_:longbool;var N:integer;var CA:charF;var CB:charF;l__CA,l__CB:integer);cdecl; external 'arpacklib.dll' name 'FUNC_LSAMEN';
procedure FUNC_LSAMEN(var RESULT_:longbool;var N:integer;var CA:charF;var CB:charF);
begin
  _FUNC_LSAMEN(RESULT_,N,CA,CB,length(CA),length(CB));
end;

procedure _FUNC_SCSUM1(var RESULT_:real;var N:integer;var CX:TVecComplex;var INCX:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SCSUM1';
procedure FUNC_SCSUM1(var RESULT_:real;var N:integer;var CX:TVecComplex;var INCX:integer);
begin
  _FUNC_SCSUM1(RESULT_,N,CX,INCX);
end;

procedure _SGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatReal;var LDAB:integer;var IPIV:TVecInteger;var B:TMatReal;var LDB:integer;var INFO:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'SGBTRS';
procedure SGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatReal;var LDAB:integer;var IPIV:TVecInteger;var B:TMatReal;var LDB:integer;var INFO:integer);
begin
  _SGBTRS(TRANS,N,KL,KU,NRHS,AB,LDAB,IPIV,B,LDB,INFO,length(TRANS));
end;

procedure _SGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecReal;var D:TVecReal;var DU:TVecReal;var DU2:TVecReal;var IPIV:TVecInteger;var B:TMatReal;var LDB:integer;var INFO:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'SGTTRS';
procedure SGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecReal;var D:TVecReal;var DU:TVecReal;var DU2:TVecReal;var IPIV:TVecInteger;var B:TMatReal;var LDB:integer;var INFO:integer);
begin
  _SGTTRS(TRANS,N,NRHS,DL,D,DU,DU2,IPIV,B,LDB,INFO,length(TRANS));
end;

procedure _SLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'SLACPY';
procedure SLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer);
begin
  _SLACPY(UPLO,M,N,A,LDA,B,LDB,length(UPLO));
end;

procedure _SLAGTM(var TRANS:charF;var N:integer;var NRHS:integer;var ALPHA:real;var DL:TVecReal;var D:TVecReal;var DU:TVecReal;var X:TMatReal;var LDX:integer;var BETA:real;var B:TMatReal;var LDB:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'SLAGTM';
procedure SLAGTM(var TRANS:charF;var N:integer;var NRHS:integer;var ALPHA:real;var DL:TVecReal;var D:TVecReal;var DU:TVecReal;var X:TMatReal;var LDX:integer;var BETA:real;var B:TMatReal;var LDB:integer);
begin
  _SLAGTM(TRANS,N,NRHS,ALPHA,DL,D,DU,X,LDX,BETA,B,LDB,length(TRANS));
end;

procedure _FUNC_SLAMCH(var RESULT_:real;var CMACH:charF;l__CMACH:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SLAMCH';
procedure FUNC_SLAMCH(var RESULT_:real;var CMACH:charF);
begin
  _FUNC_SLAMCH(RESULT_,CMACH,length(CMACH));
end;

procedure _FUNC_SLANGE(var RESULT_:real;var NORM:charF;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var WORK:TVecReal;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SLANGE';
procedure FUNC_SLANGE(var RESULT_:real;var NORM:charF;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var WORK:TVecReal);
begin
  _FUNC_SLANGE(RESULT_,NORM,M,N,A,LDA,WORK,length(NORM));
end;

procedure _FUNC_SLANHS(var RESULT_:real;var NORM:charF;var N:integer;var A:TMatReal;var LDA:integer;var WORK:TVecReal;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SLANHS';
procedure FUNC_SLANHS(var RESULT_:real;var NORM:charF;var N:integer;var A:TMatReal;var LDA:integer;var WORK:TVecReal);
begin
  _FUNC_SLANHS(RESULT_,NORM,N,A,LDA,WORK,length(NORM));
end;

procedure _FUNC_SLANST(var RESULT_:real;var NORM:charF;var N:integer;var D:TVecReal;var E:TVecReal;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SLANST';
procedure FUNC_SLANST(var RESULT_:real;var NORM:charF;var N:integer;var D:TVecReal;var E:TVecReal);
begin
  _FUNC_SLANST(RESULT_,NORM,N,D,E,length(NORM));
end;

procedure _FUNC_SLAPY2(var RESULT_:real;var X:real;var Y:real);cdecl; external 'arpacklib.dll' name 'FUNC_SLAPY2';
procedure FUNC_SLAPY2(var RESULT_:real;var X:real;var Y:real);
begin
  _FUNC_SLAPY2(RESULT_,X,Y);
end;

procedure _FUNC_SLAPY3(var RESULT_:real;var X:real;var Y:real;var Z:real);cdecl; external 'arpacklib.dll' name 'FUNC_SLAPY3';
procedure FUNC_SLAPY3(var RESULT_:real;var X:real;var Y:real;var Z:real);
begin
  _FUNC_SLAPY3(RESULT_,X,Y,Z);
end;

procedure _FUNC_SLARAN(var RESULT_:real;var ISEED:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SLARAN';
procedure FUNC_SLARAN(var RESULT_:real;var ISEED:integer);
begin
  _FUNC_SLARAN(RESULT_,ISEED);
end;

procedure _SLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecReal;var INCV:integer;var TAU:real;var C:TMatReal;var LDC:integer;var WORK:TVecReal;l__SIDE:integer);cdecl; external 'arpacklib.dll' name 'SLARF';
procedure SLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecReal;var INCV:integer;var TAU:real;var C:TMatReal;var LDC:integer;var WORK:TVecReal);
begin
  _SLARF(SIDE,M,N,V,INCV,TAU,C,LDC,WORK,length(SIDE));
end;

procedure _SLARFX(var SIDE:charF;var M:integer;var N:integer;var V:TVecReal;var TAU:real;var C:TMatReal;var LDC:integer;var WORK:TVecReal;l__SIDE:integer);cdecl; external 'arpacklib.dll' name 'SLARFX';
procedure SLARFX(var SIDE:charF;var M:integer;var N:integer;var V:TVecReal;var TAU:real;var C:TMatReal;var LDC:integer;var WORK:TVecReal);
begin
  _SLARFX(SIDE,M,N,V,TAU,C,LDC,WORK,length(SIDE));
end;

procedure _FUNC_SLARND(var RESULT_:real;var IDIST:integer;var ISEED:integer);cdecl; external 'arpacklib.dll' name 'FUNC_SLARND';
procedure FUNC_SLARND(var RESULT_:real;var IDIST:integer;var ISEED:integer);
begin
  _FUNC_SLARND(RESULT_,IDIST,ISEED);
end;

procedure _SLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:real;var CTO:real;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var INFO:integer;l__TYPE_:integer);cdecl; external 'arpacklib.dll' name 'SLASCL';
procedure SLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:real;var CTO:real;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var INFO:integer);
begin
  _SLASCL(TYPE_,KL,KU,CFROM,CTO,M,N,A,LDA,INFO,length(TYPE_));
end;

procedure _SLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:real;var BETA:real;var A:TMatReal;var LDA:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'SLASET';
procedure SLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:real;var BETA:real;var A:TMatReal;var LDA:integer);
begin
  _SLASET(UPLO,M,N,ALPHA,BETA,A,LDA,length(UPLO));
end;

procedure _SLASR(var SIDE:charF;var PIVOT:charF;var DIRECT:charF;var M:integer;var N:integer;var C:TVecReal;var S:TVecReal;var A:TMatReal;var LDA:integer;l__SIDE,l__PIVOT,l__DIRECT:integer);cdecl; external 'arpacklib.dll' name 'SLASR';
procedure SLASR(var SIDE:charF;var PIVOT:charF;var DIRECT:charF;var M:integer;var N:integer;var C:TVecReal;var S:TVecReal;var A:TMatReal;var LDA:integer);
begin
  _SLASR(SIDE,PIVOT,DIRECT,M,N,C,S,A,LDA,length(SIDE),length(PIVOT),length(DIRECT));
end;

procedure _SLASRT(var ID:charF;var N:integer;var D:TVecReal;var INFO:integer;l__ID:integer);cdecl; external 'arpacklib.dll' name 'SLASRT';
procedure SLASRT(var ID:charF;var N:integer;var D:TVecReal;var INFO:integer);
begin
  _SLASRT(ID,N,D,INFO,length(ID));
end;

procedure _SORM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatReal;var LDA:integer;var TAU:TVecReal;var C:TMatReal;var LDC:integer;var WORK:TVecReal;var INFO:integer;l__SIDE,l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'SORM2R';
procedure SORM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatReal;var LDA:integer;var TAU:TVecReal;var C:TMatReal;var LDC:integer;var WORK:TVecReal;var INFO:integer);
begin
  _SORM2R(SIDE,TRANS,M,N,K,A,LDA,TAU,C,LDC,WORK,INFO,length(SIDE),length(TRANS));
end;

procedure _SSTEQR(var COMPZ:charF;var N:integer;var D:TVecReal;var E:TVecReal;var Z:TMatReal;var LDZ:integer;var WORK:TVecReal;var INFO:integer;l__COMPZ:integer);cdecl; external 'arpacklib.dll' name 'SSTEQR';
procedure SSTEQR(var COMPZ:charF;var N:integer;var D:TVecReal;var E:TVecReal;var Z:TMatReal;var LDZ:integer;var WORK:TVecReal;var INFO:integer);
begin
  _SSTEQR(COMPZ,N,D,E,Z,LDZ,WORK,INFO,length(COMPZ));
end;

procedure _STREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatReal;var LDT:integer;var VL:TMatReal;var LDVL:integer;var VR:TMatReal;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecReal;var INFO:integer;l__SIDE,l__HOWMNY:integer);cdecl; external 'arpacklib.dll' name 'STREVC';
procedure STREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatReal;var LDT:integer;var VL:TMatReal;var LDVL:integer;var VR:TMatReal;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecReal;var INFO:integer);
begin
  _STREVC(SIDE,HOWMNY,SELECT,N,T,LDT,VL,LDVL,VR,LDVR,MM,M,WORK,INFO,length(SIDE),length(HOWMNY));
end;

procedure _STREXC(var COMPQ:charF;var N:integer;var T:TMatReal;var LDT:integer;var Q:TMatReal;var LDQ:integer;var IFST:integer;var ILST:integer;var WORK:TVecReal;var INFO:integer;l__COMPQ:integer);cdecl; external 'arpacklib.dll' name 'STREXC';
procedure STREXC(var COMPQ:charF;var N:integer;var T:TMatReal;var LDT:integer;var Q:TMatReal;var LDQ:integer;var IFST:integer;var ILST:integer;var WORK:TVecReal;var INFO:integer);
begin
  _STREXC(COMPQ,N,T,LDT,Q,LDQ,IFST,ILST,WORK,INFO,length(COMPQ));
end;

procedure _STRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatReal;var LDT:integer;var Q:TMatReal;var LDQ:integer;var WR:TVecReal;var WI:TVecReal;var M:integer;var S:real;var SEP:real;var WORK:TVecReal;var LWORK:integer;var IWORK:TVecInteger;var LIWORK:integer;var INFO:integer;l__JOB,l__COMPQ:integer);cdecl; external 'arpacklib.dll' name 'STRSEN';
procedure STRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatReal;var LDT:integer;var Q:TMatReal;var LDQ:integer;var WR:TVecReal;var WI:TVecReal;var M:integer;var S:real;var SEP:real;var WORK:TVecReal;var LWORK:integer;var IWORK:TVecInteger;var LIWORK:integer;var INFO:integer);
begin
  _STRSEN(JOB,COMPQ,SELECT,N,T,LDT,Q,LDQ,WR,WI,M,S,SEP,WORK,LWORK,IWORK,LIWORK,INFO,length(JOB),length(COMPQ));
end;

procedure _STRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer;var C:TMatReal;var LDC:integer;var SCALE:real;var INFO:integer;l__TRANA,l__TRANB:integer);cdecl; external 'arpacklib.dll' name 'STRSYL';
procedure STRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatReal;var LDA:integer;var B:TMatReal;var LDB:integer;var C:TMatReal;var LDC:integer;var SCALE:real;var INFO:integer);
begin
  _STRSYL(TRANA,TRANB,ISGN,M,N,A,LDA,B,LDB,C,LDC,SCALE,INFO,length(TRANA),length(TRANB));
end;

procedure _XERBLA(var SRNAME:charF6;var INFO:integer;l__SRNAME:integer);cdecl; external 'arpacklib.dll' name 'XERBLA';
procedure XERBLA(var SRNAME:charF6;var INFO:integer);
begin
  _XERBLA(SRNAME,INFO,length(SRNAME));
end;

procedure _ZGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'ZGBTRS';
procedure ZGBTRS(var TRANS:charF;var N:integer;var KL:integer;var KU:integer;var NRHS:integer;var AB:TMatComplex;var LDAB:integer;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer);
begin
  _ZGBTRS(TRANS,N,KL,KU,NRHS,AB,LDAB,IPIV,B,LDB,INFO,length(TRANS));
end;

procedure _ZGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecComplex;var D:TVecComplex;var DU:TVecComplex;var DU2:TVecComplex;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer;l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'ZGTTRS';
procedure ZGTTRS(var TRANS:charF;var N:integer;var NRHS:integer;var DL:TVecComplex;var D:TVecComplex;var DU:TVecComplex;var DU2:TVecComplex;var IPIV:TVecInteger;var B:TMatComplex;var LDB:integer;var INFO:integer);
begin
  _ZGTTRS(TRANS,N,NRHS,DL,D,DU,DU2,IPIV,B,LDB,INFO,length(TRANS));
end;

procedure _ZLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'ZLACPY';
procedure ZLACPY(var UPLO:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer);
begin
  _ZLACPY(UPLO,M,N,A,LDA,B,LDB,length(UPLO));
end;

procedure _FUNC_ZLADIV(var RESULT_:TDoubleComplex;var X:TDoubleComplex;var Y:TDoubleComplex);cdecl; external 'arpacklib.dll' name 'FUNC_ZLADIV';
procedure FUNC_ZLADIV(var RESULT_:TDoubleComplex;var X:TDoubleComplex;var Y:TDoubleComplex);
begin
  _FUNC_ZLADIV(RESULT_,X,Y);
end;

procedure _FUNC_ZLANGE(var RESULT_:double;var NORM:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecDouble;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ZLANGE';
procedure FUNC_ZLANGE(var RESULT_:double;var NORM:charF;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecDouble);
begin
  _FUNC_ZLANGE(RESULT_,NORM,M,N,A,LDA,WORK,length(NORM));
end;

procedure _FUNC_ZLANHS(var RESULT_:double;var NORM:charF;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecDouble;l__NORM:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ZLANHS';
procedure FUNC_ZLANHS(var RESULT_:double;var NORM:charF;var N:integer;var A:TMatComplex;var LDA:integer;var WORK:TVecDouble);
begin
  _FUNC_ZLANHS(RESULT_,NORM,N,A,LDA,WORK,length(NORM));
end;

procedure _ZLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecComplex;var INCV:integer;var TAU:TDoubleComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex;l__SIDE:integer);cdecl; external 'arpacklib.dll' name 'ZLARF';
procedure ZLARF(var SIDE:charF;var M:integer;var N:integer;var V:TVecComplex;var INCV:integer;var TAU:TDoubleComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex);
begin
  _ZLARF(SIDE,M,N,V,INCV,TAU,C,LDC,WORK,length(SIDE));
end;

procedure _ZLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:double;var CTO:double;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var INFO:integer;l__TYPE_:integer);cdecl; external 'arpacklib.dll' name 'ZLASCL';
procedure ZLASCL(var TYPE_:charF;var KL:integer;var KU:integer;var CFROM:double;var CTO:double;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var INFO:integer);
begin
  _ZLASCL(TYPE_,KL,KU,CFROM,CTO,M,N,A,LDA,INFO,length(TYPE_));
end;

procedure _ZLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var BETA:TDoubleComplex;var A:TMatComplex;var LDA:integer;l__UPLO:integer);cdecl; external 'arpacklib.dll' name 'ZLASET';
procedure ZLASET(var UPLO:charF;var M:integer;var N:integer;var ALPHA:TDoubleComplex;var BETA:TDoubleComplex;var A:TMatComplex;var LDA:integer);
begin
  _ZLASET(UPLO,M,N,ALPHA,BETA,A,LDA,length(UPLO));
end;

procedure _ZLATRS(var UPLO:charF;var TRANS:charF;var DIAG:charF;var NORMIN:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var SCALE:double;var CNORM:TVecDouble;var INFO:integer;l__UPLO,l__TRANS,l__DIAG,l__NORMIN:integer);cdecl; external 'arpacklib.dll' name 'ZLATRS';
procedure ZLATRS(var UPLO:charF;var TRANS:charF;var DIAG:charF;var NORMIN:charF;var N:integer;var A:TMatComplex;var LDA:integer;var X:TVecComplex;var SCALE:double;var CNORM:TVecDouble;var INFO:integer);
begin
  _ZLATRS(UPLO,TRANS,DIAG,NORMIN,N,A,LDA,X,SCALE,CNORM,INFO,length(UPLO),length(TRANS),length(DIAG),length(NORMIN));
end;

procedure _FUNC_ZMACH(var RESULT_:double;var JOB:integer);cdecl; external 'arpacklib.dll' name 'FUNC_ZMACH';
procedure FUNC_ZMACH(var RESULT_:double;var JOB:integer);
begin
  _FUNC_ZMACH(RESULT_,JOB);
end;

procedure _ZTREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var VL:TMatComplex;var LDVL:integer;var VR:TMatComplex;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecComplex;var RWORK:TVecDouble;var INFO:integer;l__SIDE,l__HOWMNY:integer);cdecl; external 'arpacklib.dll' name 'ZTREVC';
procedure ZTREVC(var SIDE:charF;var HOWMNY:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var VL:TMatComplex;var LDVL:integer;var VR:TMatComplex;var LDVR:integer;var MM:integer;var M:integer;var WORK:TVecComplex;var RWORK:TVecDouble;var INFO:integer);
begin
  _ZTREVC(SIDE,HOWMNY,SELECT,N,T,LDT,VL,LDVL,VR,LDVR,MM,M,WORK,RWORK,INFO,length(SIDE),length(HOWMNY));
end;

procedure _ZTREXC(var COMPQ:charF;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var IFST:integer;var ILST:integer;var INFO:integer;l__COMPQ:integer);cdecl; external 'arpacklib.dll' name 'ZTREXC';
procedure ZTREXC(var COMPQ:charF;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var IFST:integer;var ILST:integer;var INFO:integer);
begin
  _ZTREXC(COMPQ,N,T,LDT,Q,LDQ,IFST,ILST,INFO,length(COMPQ));
end;

procedure _ZTRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var W:TVecComplex;var M:integer;var S:double;var SEP:double;var WORK:TVecComplex;var LWORK:integer;var INFO:integer;l__JOB,l__COMPQ:integer);cdecl; external 'arpacklib.dll' name 'ZTRSEN';
procedure ZTRSEN(var JOB:charF;var COMPQ:charF;var SELECT:TVecLogical;var N:integer;var T:TMatComplex;var LDT:integer;var Q:TMatComplex;var LDQ:integer;var W:TVecComplex;var M:integer;var S:double;var SEP:double;var WORK:TVecComplex;var LWORK:integer;var INFO:integer);
begin
  _ZTRSEN(JOB,COMPQ,SELECT,N,T,LDT,Q,LDQ,W,M,S,SEP,WORK,LWORK,INFO,length(JOB),length(COMPQ));
end;

procedure _ZTRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var C:TMatComplex;var LDC:integer;var SCALE:double;var INFO:integer;l__TRANA,l__TRANB:integer);cdecl; external 'arpacklib.dll' name 'ZTRSYL';
procedure ZTRSYL(var TRANA:charF;var TRANB:charF;var ISGN:integer;var M:integer;var N:integer;var A:TMatComplex;var LDA:integer;var B:TMatComplex;var LDB:integer;var C:TMatComplex;var LDC:integer;var SCALE:double;var INFO:integer);
begin
  _ZTRSYL(TRANA,TRANB,ISGN,M,N,A,LDA,B,LDB,C,LDC,SCALE,INFO,length(TRANA),length(TRANB));
end;

procedure _ZUNM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var TAU:TVecComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex;var INFO:integer;l__SIDE,l__TRANS:integer);cdecl; external 'arpacklib.dll' name 'ZUNM2R';
procedure ZUNM2R(var SIDE:charF;var TRANS:charF;var M:integer;var N:integer;var K:integer;var A:TMatComplex;var LDA:integer;var TAU:TVecComplex;var C:TMatComplex;var LDC:integer;var WORK:TVecComplex;var INFO:integer);
begin
  _ZUNM2R(SIDE,TRANS,M,N,K,A,LDA,TAU,C,LDC,WORK,INFO,length(SIDE),length(TRANS));
end;

procedure _CGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatComplex;var LDV:integer;var RESID:TVecComplex;var RNORM:real;var IPNTR:TVecInteger;var WORKD:TVecComplex;var IERR:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'CGETV0';
procedure CGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatComplex;var LDV:integer;var RESID:TVecComplex;var RNORM:real;var IPNTR:TVecInteger;var WORKD:TVecComplex;var IERR:integer);
begin
  _CGETV0(IDO,BMAT,ITRY,INITV,N,J,V,LDV,RESID,RNORM,IPNTR,WORKD,IERR,length(BMAT));
end;

procedure _CNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecComplex;var RNORM:real;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecComplex;var INFO:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'CNAITR';
procedure CNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecComplex;var RNORM:real;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecComplex;var INFO:integer);
begin
  _CNAITR(IDO,BMAT,N,K,NP,NB,RESID,RNORM,V,LDV,H,LDH,IPNTR,WORKD,INFO,length(BMAT));
end;

procedure _CNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:real;var RESID:TVecComplex;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var IPNTR:TVecInteger;var WORKD:TVecComplex;var RWORK:TVecReal;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'CNAUP2';
procedure CNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:real;var RESID:TVecComplex;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var IPNTR:TVecInteger;var WORKD:TVecComplex;var RWORK:TVecReal;var INFO:integer);
begin
  _CNAUP2(IDO,BMAT,N,WHICH,NEV,NP,TOL,RESID,MODE,IUPD,ISHIFT,MXITER,V,LDV,H,LDH,RITZ,BOUNDS,Q,LDQ,WORKL,IPNTR,WORKD,RWORK,INFO,length(BMAT),length(WHICH));
end;

procedure _CNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecReal;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'CNAUPD';
procedure CNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecReal;var INFO:integer);
begin
  _CNAUPD(IDO,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,RWORK,INFO,length(BMAT),length(WHICH));
end;

procedure _CNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecComplex;var Z:TMatComplex;var LDZ:integer;var SIGMA:TComplex;var WORKEV:TVecComplex;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecReal;var INFO:integer;l__HOWMNY,l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'CNEUPD';
procedure CNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecComplex;var Z:TMatComplex;var LDZ:integer;var SIGMA:TComplex;var WORKEV:TVecComplex;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecReal;var INFO:integer);
begin
  _CNEUPD(RVEC,HOWMNY,SELECT,D,Z,LDZ,SIGMA,WORKEV,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,RWORK,INFO,length(HOWMNY),length(BMAT),length(WHICH));
end;

procedure _CNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'CNGETS';
procedure CNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex);
begin
  _CNGETS(ISHIFT,WHICH,KEV,NP,RITZ,BOUNDS,length(WHICH));
end;

procedure _CSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecComplex;var Y:TVecComplex;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'CSORTC';
procedure CSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecComplex;var Y:TVecComplex);
begin
  _CSORTC(WHICH,APPLY,N,X,Y,length(WHICH));
end;

procedure _DGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatDouble;var LDV:integer;var RESID:TVecDouble;var RNORM:double;var IPNTR:TVecInteger;var WORKD:TVecDouble;var IERR:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'DGETV0';
procedure DGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatDouble;var LDV:integer;var RESID:TVecDouble;var RNORM:double;var IPNTR:TVecInteger;var WORKD:TVecDouble;var IERR:integer);
begin
  _DGETV0(IDO,BMAT,ITRY,INITV,N,J,V,LDV,RESID,RNORM,IPNTR,WORKD,IERR,length(BMAT));
end;

procedure _DNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecDouble;var RNORM:double;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'DNAITR';
procedure DNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecDouble;var RNORM:double;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer);
begin
  _DNAITR(IDO,BMAT,N,K,NP,NB,RESID,RNORM,V,LDV,H,LDH,IPNTR,WORKD,INFO,length(BMAT));
end;

procedure _DNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:double;var RESID:TVecDouble;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var RITZR:TVecDouble;var RITZI:TVecDouble;var BOUNDS:TVecDouble;var Q:TMatDouble;var LDQ:integer;var WORKL:TVecDouble;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DNAUP2';
procedure DNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:double;var RESID:TVecDouble;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var RITZR:TVecDouble;var RITZI:TVecDouble;var BOUNDS:TVecDouble;var Q:TMatDouble;var LDQ:integer;var WORKL:TVecDouble;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer);
begin
  _DNAUP2(IDO,BMAT,N,WHICH,NEV,NP,TOL,RESID,MODE,IUPD,ISHIFT,MXITER,V,LDV,H,LDH,RITZR,RITZI,BOUNDS,Q,LDQ,WORKL,IPNTR,WORKD,INFO,length(BMAT),length(WHICH));
end;

procedure _DNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DNAUPD';
procedure DNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer);
begin
  _DNAUPD(IDO,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,INFO,length(BMAT),length(WHICH));
end;

procedure _DNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var DR:TVecDouble;var DI:TVecDouble;var Z:TMatDouble;var LDZ:integer;var SIGMAR:double;var SIGMAI:double;var WORKEV:TVecDouble;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer;l__HOWMNY,l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DNEUPD';
procedure DNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var DR:TVecDouble;var DI:TVecDouble;var Z:TMatDouble;var LDZ:integer;var SIGMAR:double;var SIGMAI:double;var WORKEV:TVecDouble;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer);
begin
  _DNEUPD(RVEC,HOWMNY,SELECT,DR,DI,Z,LDZ,SIGMAR,SIGMAI,WORKEV,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,INFO,length(HOWMNY),length(BMAT),length(WHICH));
end;

procedure _DNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZR:TVecDouble;var RITZI:TVecDouble;var BOUNDS:TVecDouble;var SHIFTR:TVecDouble;var SHIFTI:TVecDouble;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DNGETS';
procedure DNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZR:TVecDouble;var RITZI:TVecDouble;var BOUNDS:TVecDouble;var SHIFTR:TVecDouble;var SHIFTI:TVecDouble);
begin
  _DNGETS(ISHIFT,WHICH,KEV,NP,RITZR,RITZI,BOUNDS,SHIFTR,SHIFTI,length(WHICH));
end;

procedure _DSAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var MODE:integer;var RESID:TVecDouble;var RNORM:double;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'DSAITR';
procedure DSAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var MODE:integer;var RESID:TVecDouble;var RNORM:double;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer);
begin
  _DSAITR(IDO,BMAT,N,K,NP,MODE,RESID,RNORM,V,LDV,H,LDH,IPNTR,WORKD,INFO,length(BMAT));
end;

procedure _DSAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:double;var RESID:TVecDouble;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var RITZ:TVecDouble;var BOUNDS:TVecDouble;var Q:TMatDouble;var LDQ:integer;var WORKL:TVecDouble;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DSAUP2';
procedure DSAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:double;var RESID:TVecDouble;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatDouble;var LDV:integer;var H:TMatDouble;var LDH:integer;var RITZ:TVecDouble;var BOUNDS:TVecDouble;var Q:TMatDouble;var LDQ:integer;var WORKL:TVecDouble;var IPNTR:TVecInteger;var WORKD:TVecDouble;var INFO:integer);
begin
  _DSAUP2(IDO,BMAT,N,WHICH,NEV,NP,TOL,RESID,MODE,IUPD,ISHIFT,MXITER,V,LDV,H,LDH,RITZ,BOUNDS,Q,LDQ,WORKL,IPNTR,WORKD,INFO,length(BMAT),length(WHICH));
end;

procedure _DSAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DSAUPD';
procedure DSAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer);
begin
  _DSAUPD(IDO,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,INFO,length(BMAT),length(WHICH));
end;

procedure _DSESRT(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecDouble;var NA:integer;var A:TMatDouble;var LDA:integer;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DSESRT';
procedure DSESRT(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecDouble;var NA:integer;var A:TMatDouble;var LDA:integer);
begin
  _DSESRT(WHICH,APPLY,N,X,NA,A,LDA,length(WHICH));
end;

procedure _DSEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecDouble;var Z:TMatDouble;var LDZ:integer;var SIGMA:double;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer;l__HOWMNY,l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DSEUPD';
procedure DSEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecDouble;var Z:TMatDouble;var LDZ:integer;var SIGMA:double;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecDouble;var NCV:integer;var V:TMatDouble;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecDouble;var WORKL:TVecDouble;var LWORKL:integer;var INFO:integer);
begin
  _DSEUPD(RVEC,HOWMNY,SELECT,D,Z,LDZ,SIGMA,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,INFO,length(HOWMNY),length(BMAT),length(WHICH));
end;

procedure _DSGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecDouble;var BOUNDS:TVecDouble;var SHIFTS:TVecDouble;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DSGETS';
procedure DSGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecDouble;var BOUNDS:TVecDouble;var SHIFTS:TVecDouble);
begin
  _DSGETS(ISHIFT,WHICH,KEV,NP,RITZ,BOUNDS,SHIFTS,length(WHICH));
end;

procedure _DSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var XREAL:TVecDouble;var XIMAG:TVecDouble;var Y:TVecDouble;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DSORTC';
procedure DSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var XREAL:TVecDouble;var XIMAG:TVecDouble;var Y:TVecDouble);
begin
  _DSORTC(WHICH,APPLY,N,XREAL,XIMAG,Y,length(WHICH));
end;

procedure _DSORTR(var WHICH:charF2;var APPLY:longbool;var N:integer;var X1:TVecDouble;var X2:TVecDouble;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'DSORTR';
procedure DSORTR(var WHICH:charF2;var APPLY:longbool;var N:integer;var X1:TVecDouble;var X2:TVecDouble);
begin
  _DSORTR(WHICH,APPLY,N,X1,X2,length(WHICH));
end;

procedure _SGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatReal;var LDV:integer;var RESID:TVecReal;var RNORM:real;var IPNTR:TVecInteger;var WORKD:TVecReal;var IERR:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'SGETV0';
procedure SGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatReal;var LDV:integer;var RESID:TVecReal;var RNORM:real;var IPNTR:TVecInteger;var WORKD:TVecReal;var IERR:integer);
begin
  _SGETV0(IDO,BMAT,ITRY,INITV,N,J,V,LDV,RESID,RNORM,IPNTR,WORKD,IERR,length(BMAT));
end;

procedure _SNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecReal;var RNORM:real;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'SNAITR';
procedure SNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecReal;var RNORM:real;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer);
begin
  _SNAITR(IDO,BMAT,N,K,NP,NB,RESID,RNORM,V,LDV,H,LDH,IPNTR,WORKD,INFO,length(BMAT));
end;

procedure _SNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:real;var RESID:TVecReal;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var RITZR:TVecReal;var RITZI:TVecReal;var BOUNDS:TVecReal;var Q:TMatReal;var LDQ:integer;var WORKL:TVecReal;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SNAUP2';
procedure SNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:real;var RESID:TVecReal;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var RITZR:TVecReal;var RITZI:TVecReal;var BOUNDS:TVecReal;var Q:TMatReal;var LDQ:integer;var WORKL:TVecReal;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer);
begin
  _SNAUP2(IDO,BMAT,N,WHICH,NEV,NP,TOL,RESID,MODE,IUPD,ISHIFT,MXITER,V,LDV,H,LDH,RITZR,RITZI,BOUNDS,Q,LDQ,WORKL,IPNTR,WORKD,INFO,length(BMAT),length(WHICH));
end;

procedure _SNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SNAUPD';
procedure SNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer);
begin
  _SNAUPD(IDO,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,INFO,length(BMAT),length(WHICH));
end;

procedure _SNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var DR:TVecReal;var DI:TVecReal;var Z:TMatReal;var LDZ:integer;var SIGMAR:real;var SIGMAI:real;var WORKEV:TVecReal;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer;l__HOWMNY,l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SNEUPD';
procedure SNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var DR:TVecReal;var DI:TVecReal;var Z:TMatReal;var LDZ:integer;var SIGMAR:real;var SIGMAI:real;var WORKEV:TVecReal;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer);
begin
  _SNEUPD(RVEC,HOWMNY,SELECT,DR,DI,Z,LDZ,SIGMAR,SIGMAI,WORKEV,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,INFO,length(HOWMNY),length(BMAT),length(WHICH));
end;

procedure _SNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZR:TVecReal;var RITZI:TVecReal;var BOUNDS:TVecReal;var SHIFTR:TVecReal;var SHIFTI:TVecReal;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SNGETS';
procedure SNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZR:TVecReal;var RITZI:TVecReal;var BOUNDS:TVecReal;var SHIFTR:TVecReal;var SHIFTI:TVecReal);
begin
  _SNGETS(ISHIFT,WHICH,KEV,NP,RITZR,RITZI,BOUNDS,SHIFTR,SHIFTI,length(WHICH));
end;

procedure _SSAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var MODE:integer;var RESID:TVecReal;var RNORM:real;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'SSAITR';
procedure SSAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var MODE:integer;var RESID:TVecReal;var RNORM:real;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer);
begin
  _SSAITR(IDO,BMAT,N,K,NP,MODE,RESID,RNORM,V,LDV,H,LDH,IPNTR,WORKD,INFO,length(BMAT));
end;

procedure _SSAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:real;var RESID:TVecReal;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var RITZ:TVecReal;var BOUNDS:TVecReal;var Q:TMatReal;var LDQ:integer;var WORKL:TVecReal;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SSAUP2';
procedure SSAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:real;var RESID:TVecReal;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatReal;var LDV:integer;var H:TMatReal;var LDH:integer;var RITZ:TVecReal;var BOUNDS:TVecReal;var Q:TMatReal;var LDQ:integer;var WORKL:TVecReal;var IPNTR:TVecInteger;var WORKD:TVecReal;var INFO:integer);
begin
  _SSAUP2(IDO,BMAT,N,WHICH,NEV,NP,TOL,RESID,MODE,IUPD,ISHIFT,MXITER,V,LDV,H,LDH,RITZ,BOUNDS,Q,LDQ,WORKL,IPNTR,WORKD,INFO,length(BMAT),length(WHICH));
end;

procedure _SSAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SSAUPD';
procedure SSAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer);
begin
  _SSAUPD(IDO,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,INFO,length(BMAT),length(WHICH));
end;

procedure _SSESRT(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecReal;var NA:integer;var A:TMatReal;var LDA:integer;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SSESRT';
procedure SSESRT(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecReal;var NA:integer;var A:TMatReal;var LDA:integer);
begin
  _SSESRT(WHICH,APPLY,N,X,NA,A,LDA,length(WHICH));
end;

procedure _SSEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecReal;var Z:TMatReal;var LDZ:integer;var SIGMA:real;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer;l__HOWMNY,l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SSEUPD';
procedure SSEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecReal;var Z:TMatReal;var LDZ:integer;var SIGMA:real;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:real;var RESID:TVecReal;var NCV:integer;var V:TMatReal;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecReal;var WORKL:TVecReal;var LWORKL:integer;var INFO:integer);
begin
  _SSEUPD(RVEC,HOWMNY,SELECT,D,Z,LDZ,SIGMA,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,INFO,length(HOWMNY),length(BMAT),length(WHICH));
end;

procedure _SSGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecReal;var BOUNDS:TVecReal;var SHIFTS:TVecReal;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SSGETS';
procedure SSGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecReal;var BOUNDS:TVecReal;var SHIFTS:TVecReal);
begin
  _SSGETS(ISHIFT,WHICH,KEV,NP,RITZ,BOUNDS,SHIFTS,length(WHICH));
end;

procedure _SSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var XREAL:TVecReal;var XIMAG:TVecReal;var Y:TVecReal;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SSORTC';
procedure SSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var XREAL:TVecReal;var XIMAG:TVecReal;var Y:TVecReal);
begin
  _SSORTC(WHICH,APPLY,N,XREAL,XIMAG,Y,length(WHICH));
end;

procedure _SSORTR(var WHICH:charF2;var APPLY:longbool;var N:integer;var X1:TVecReal;var X2:TVecReal;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'SSORTR';
procedure SSORTR(var WHICH:charF2;var APPLY:longbool;var N:integer;var X1:TVecReal;var X2:TVecReal);
begin
  _SSORTR(WHICH,APPLY,N,X1,X2,length(WHICH));
end;

procedure _ZGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatComplex;var LDV:integer;var RESID:TVecComplex;var RNORM:double;var IPNTR:TVecInteger;var WORKD:TVecComplex;var IERR:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'ZGETV0';
procedure ZGETV0(var IDO:integer;var BMAT:charF;var ITRY:integer;var INITV:longbool;var N:integer;var J:integer;var V:TMatComplex;var LDV:integer;var RESID:TVecComplex;var RNORM:double;var IPNTR:TVecInteger;var WORKD:TVecComplex;var IERR:integer);
begin
  _ZGETV0(IDO,BMAT,ITRY,INITV,N,J,V,LDV,RESID,RNORM,IPNTR,WORKD,IERR,length(BMAT));
end;

procedure _ZNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecComplex;var RNORM:double;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecComplex;var INFO:integer;l__BMAT:integer);cdecl; external 'arpacklib.dll' name 'ZNAITR';
procedure ZNAITR(var IDO:integer;var BMAT:charF;var N:integer;var K:integer;var NP:integer;var NB:integer;var RESID:TVecComplex;var RNORM:double;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var IPNTR:TVecInteger;var WORKD:TVecComplex;var INFO:integer);
begin
  _ZNAITR(IDO,BMAT,N,K,NP,NB,RESID,RNORM,V,LDV,H,LDH,IPNTR,WORKD,INFO,length(BMAT));
end;

procedure _ZNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:double;var RESID:TVecComplex;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var IPNTR:TVecInteger;var WORKD:TVecComplex;var RWORK:TVecDouble;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'ZNAUP2';
procedure ZNAUP2(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var NP:integer;var TOL:double;var RESID:TVecComplex;var MODE:integer;var IUPD:integer;var ISHIFT:integer;var MXITER:integer;var V:TMatComplex;var LDV:integer;var H:TMatComplex;var LDH:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;var Q:TMatComplex;var LDQ:integer;var WORKL:TVecComplex;var IPNTR:TVecInteger;var WORKD:TVecComplex;var RWORK:TVecDouble;var INFO:integer);
begin
  _ZNAUP2(IDO,BMAT,N,WHICH,NEV,NP,TOL,RESID,MODE,IUPD,ISHIFT,MXITER,V,LDV,H,LDH,RITZ,BOUNDS,Q,LDQ,WORKL,IPNTR,WORKD,RWORK,INFO,length(BMAT),length(WHICH));
end;

procedure _ZNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecDouble;var INFO:integer;l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'ZNAUPD';
procedure ZNAUPD(var IDO:integer;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecDouble;var INFO:integer);
begin
  _ZNAUPD(IDO,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,RWORK,INFO,length(BMAT),length(WHICH));
end;

procedure _ZNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecComplex;var Z:TMatComplex;var LDZ:integer;var SIGMA:TDoubleComplex;var WORKEV:TVecComplex;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecDouble;var INFO:integer;l__HOWMNY,l__BMAT,l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'ZNEUPD';
procedure ZNEUPD(var RVEC:longbool;var HOWMNY:charF;var SELECT:TVecLogical;var D:TVecComplex;var Z:TMatComplex;var LDZ:integer;var SIGMA:TDoubleComplex;var WORKEV:TVecComplex;var BMAT:charF;var N:integer;var WHICH:charF2;var NEV:integer;var TOL:double;var RESID:TVecComplex;var NCV:integer;var V:TMatComplex;var LDV:integer;var IPARAM:TVecInteger;var IPNTR:TVecInteger;var WORKD:TVecComplex;var WORKL:TVecComplex;var LWORKL:integer;var RWORK:TVecDouble;var INFO:integer);
begin
  _ZNEUPD(RVEC,HOWMNY,SELECT,D,Z,LDZ,SIGMA,WORKEV,BMAT,N,WHICH,NEV,TOL,RESID,NCV,V,LDV,IPARAM,IPNTR,WORKD,WORKL,LWORKL,RWORK,INFO,length(HOWMNY),length(BMAT),length(WHICH));
end;

procedure _ZNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'ZNGETS';
procedure ZNGETS(var ISHIFT:integer;var WHICH:charF2;var KEV:integer;var NP:integer;var RITZ:TVecComplex;var BOUNDS:TVecComplex);
begin
  _ZNGETS(ISHIFT,WHICH,KEV,NP,RITZ,BOUNDS,length(WHICH));
end;

procedure _ZSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecComplex;var Y:TVecComplex;l__WHICH:integer);cdecl; external 'arpacklib.dll' name 'ZSORTC';
procedure ZSORTC(var WHICH:charF2;var APPLY:longbool;var N:integer;var X:TVecComplex;var Y:TVecComplex);
begin
  _ZSORTC(WHICH,APPLY,N,X,Y,length(WHICH));
end;
end.
